header
lorom

	!FREESPACE =		$368000	; freespace


	!OAMX =			$0200	; main oam. x pos
	!OAMY =			$0201	; Y POS
	!OAMTILE =		$0202	; TILE
	!OAMPROP =		$0203	; PROPERTIES
	!OAMSECONDARY =		$0400	; size and high x offset bits 
	!OAMEXTENDED =		$0420	; holds size and high x offset bits for sprites temporarily

	!MARIOCOUNTER =		$7F0000	; counts how many oam addresses mario is using
	!MARIOSTART =		$7F0001	; determines where to start copying from mario's oam
	!SPRITEINDEX =	 	$7F0002	; Index for next free OAM slot for normal sprites. Also serves as counter. Two bytes
	!UBERINDEX =		$7F0004	; Index for uber prioirty sprites. 2 bytes
	!SUPERINDEX =		$7F0006	; Index for super priority sprites. 2 bytes
	!HIGHINDEX =		$7F0008	; Index for high priority sprites. 2 bytes
	!YOSHIINDEX = 		$7F000A ; Index for yoshi sprites. 2 bytes
	!MARIOOAMX = 		$7F0010	; oam for mario, 7 slots. 10-2B
	!MARIOOAMY = 		$7F0011
	!MARIOOAMTILE =		$7F0012
	!MARIOOAMPROP = 	$7F0013
	!MARIOTILESIZE =	$7F002C ; tilesize bytes. 7. 2C-32
	!SPRITEOAM =		$7F0033 ; New sprite table for OAM index. Points to highest OAM slot for normal sprites. 24 bytes, 33-4A
	!SUPEROAMX = 		$7F004B	; OAM for super priority sprites. $200 bytes.
	!SUPEROAMY =		$7F004C
	!SUPEROAMTILE =		$7F004D
	!SUPEROAMPROP =		$7F004E 
	!HIGHOAMX =		$7F024B	; OAM for high priority sprites. $200 bytes.
	!HIGHOAMY =		$7F024C
	!HIGHOAMTILE =		$7F024D
	!HIGHOAMPROP =		$7F024E
	!SUPEROAMEXTENDED =	$7F044B	; extended oam for super prioirty sprites. $80 bytes
	!HIGHOAMEXTENDED =	$7F04CB ; extended oam for high priority sprites. $80 bytes
	!YOSHIOAMX =		$7F054B	; OAM for yoshi, 8 tiles
	!YOSHIOAMY =		$7F054C
	!YOSHIOAMTILE =		$7F054D
	!YOSHIOAMPROP =		$7F054E
	!YOSHIOAMEXTENDED =	$7F056B

;			; does final OAM code each frame
ORG $008494
	JML FINISHOAM		


; initialization for every single frame
ORG $009322
	JML GAMEMODE_HACK

ORG $009329			; position of game mode table
GAMEMODE_TABLE:



; item box stuff

ORG $008E01			; item box properties table
ITEMBOX_PROP:
db $02,$38,$3A,$30,$34		; set item box sprite properties to max priority rather than doing it through code


ORG $009079			; item box item routine
	LDY $0DC2		; item box sprite
	BEQ ITEMBOX_RETURN	; return if nothing there
	LDA ITEMBOX_PROP,y	; get properites
	STA !OAMPROP		; store properties
	LDA #$78
	STA !OAMX		; store x offset
	LDA #$0F
	STA !OAMY		; store y offset
	LDA $8DF9,y		; get tile
	STA !OAMTILE		; store tile
	LDA #$02
	STA !OAMEXTENDED	; store size and high x offset bit
	REP #$20
	LDA #$0004		; update uberindex
	STA !UBERINDEX
	SEP #$20
ITEMBOX_RETURN:
	RTL
; end item box stuff


; mario stuff
ORG $00E3D2
	JML MARIO_OAM_HACK	; jump to the mario oam hack

ORG $00E401
	PHX			; change push y to push x

ORG $00E441
	JML MARIO_OAM_HACK2	; jump to second mario oam hack

ORG $00E458
	JML MARIO_OAM_HACK3	; third

ORG $00F69E
	RTL			; change this to an RTL

; end mario stuff



; sprite stuff start

ORG $00FBE4
	JML LVLENDSPRCOIN_HACK

ORG $0180D2	
	JML SPRITE_INIT_HACK	; hijack the stuff that sets up sprite tables every frame

ORG $0189F6
	JML SHELLLESSKOOPA_HACK

ORG $018DAF
	JSR $9F0D	; draw body
	JMP GOOMBAWING_HACK	; draw second wing

ORG $018DEC
	LDA #$00
	JML GOOMBAWING_HACK2
GOOMBAWING_HACK:
	JSR $A365
	LDA #$01
	JML GOOMBAWING_HACK2

ORG $018E8A
	JML PIRANHAPLANT_HACK

ORG $018FAF
	JML LAKITU_HACK

org $019806
	JML FINISHOAM_SUPER

org $01980A
	JML FINISHOAM_HIGH	; access the high oam finish routine with a JSL

ORG $01980E			; access get draw info bnk1 with a JSL
GETDRAWINFOBNK1_LONG:
	JSR $A365
	RTL

ORG $019812
	JML STUNNED_HACK2

ORG $019821
	JML STUNNED_HACK

ORG $019A3A		; fixes the kicked shell 
	JSR $981B

ORG $019A44
	JML SHELL_HACK

ORG $019A5A
	JML SPINJUMP_HACK

ORG $019B07
	JML SMUSHED_HACK

ORG $019D17
	JML SUBSPRGFX0_HACK

ORG $019D78
	JML SUBSPRGFX1_HACK1

ORG $019DE1
	JML SUBSPRGFX1_HACK2

ORG $019E49
	JML KOOPAWING_HACK

ORG $019F17
	JML SUBSPRGFX2_HACK

ORG $01A1D0		; change this to point further into the stunned routine
	JSR $9812

org $01A14D
	JML STUNGOOMBA_HACK

ORG $01A1E8
	JML STUNTHROWBLOCK_HACK

ORG $01A1EC
	JML STUNBOMB_HACK

ORG $01A1F6
	JML STUNKEY_HACK

ORG $01A20C
	JML STUNNEDADD_HACK

ORG $01A218
	JML STUNPOW_HACK

ORG $01A222
	JML STUNNEDADD_HACK2

ORG $01A352
	JML STUNBABYYOSHI_HACK

ORG $01A3CD
	LDA $0000		; fill in some bytes

ORG $01AD71
	BRA $0D			; fix flying ? block 

ORG $01AD6E
	LDA $C2,X
	BNE FLYINGQUESTION_0
	JSR $9E95		; draw wings
	JML FLYINGQUESTION_HACK3

ORG $01AD80:
FLYINGQUESTION_0:

ORG $01AD94:
	LDA $0000		; fill in some bytes

ORG $01AD83
	JML FLYINGQUESTION_HACK

ORG $01AE65
	JML FLYINGQUESTION_HACK2

ORG $01AF5D
	JML THWOMP_HACK

ORG $01B2E7
	JML PLATFORM_HACK

ORG $01B3A5
	JML ORANGEPLATS_HACK

ORG $01B66C
	JML FLOATMINE_HACK

ORG $01B72A
	JML TURNBLOCKBRIDGE_HACK

ORG $01B7BB			; what updates SPRITEINDEX and does some other stuff
	JML FINISHOAMWRITE_HACK

ORG $01BAA7			; number of tiles used by climbing door
db $09,$09,$09,$09,$09,$06,$06,$06,$03,$06,$06,$06,$09,$09,$09,$09

ORG $01BAB7			; tile numbers for climbing door
db $03,$13,$03
db $05,$15,$05,$05,$15,$05
db $00,$10,$00,$00,$10,$00,$01,$11,$01

ORG $01BB33
	JML CLIMBINGDOOR_HACK

ORG $01BBFD
	RTS			; skip some useless code

ORG $01BD11
	JML MAGIMAGIC_HACK

ORG $01BEBC
	JML MAGIKOOPA_HACK

ORG $01BEE1
	JML MAGIKOOPA_HACK2

ORG $01C135
	JML GOALTAPE_HACK

ORG $01C194
	JML VINE_HACK

ORG $01C35B
	JML BERRY_HACK

ORG $01C648
	JML COINSPRGFX_HACK

ORG $01C6B2
	JML POWERUP_HACK

ORG $01C7CE
	JML BROWNPLAT_HACK

ORG $01DBA8
	JML GRINDER_HACK

ORG $01DBD7
	JML FUZZBALL_HACK

ORG $01DC11
	JML LINEGRINDER_HACK

ORG $01DC80
	JML LINEROPE_HACK

ORG $01E23D
	JML KEYHOLE_HACK

ORG $01E45F
	JML DRYSPRITES_HACK

ORG $01E6F7
	JML STUNSPRINGBOARD_HACK

ORG $01E708
	JML SMUSHED_HACK2

ORG $01E901
	JML LAKITUCLOUD_HACK

ORG $01EF6B
	JML YOSHI_HACK

ORG $01F02C
	JML YOSHI_HACK2

ORG $01EE8D
	JML YOSHI_HACK3

ORG $01F46A
	JML YOSHITONGUE_HACK

ORG $01F790
	JML YOSHIEGG_HACK

ORG $01F7AD
	JML YOSHIEGG_HACK2

ORG $01FA1F
	JML BOOBLOCK_HACK

ORG $0280C4
	JML BOMBSPLODE_HACK

ORG $02B685
	JML POKEY_HACK

ORG $02B74B
	JML POKEY_HACK2

ORG $02B8FA
	JML TORPEDO_HACK

ORG $02BB51
	JML YOSHIWINGS_HACK

ORG $02BC24
	JML DOLPHIN_HACK

ORG $02BE58
	JML FUZZSPARKY_HACK	; graphics routine for both fuzzball and sparky (ground guided)

ORG $02BEC9
	JML HOTHEAD_HACK

ORG $02BF84
	JML URCHIN_HACK

ORG $02C8C2
	JML CHUCK_HACK1

ORG $02CA37
	JML CHUCK_HACK2

ORG $02CAB6
	JML CHUCK_HACK3

ORG $02CAFC
	JML CHUCK_HACK4

ORG $02CB5F
	JML CHUCK_HACK5

ORG $02CBBB
	JML CHUCK_HACK6

ORG $02CD91
	JML PALACESWITCH_HACK

ORG $02CEF9
	JML PEABOUNCER_HACK

ORG $02D5EA
	JML BANZAIBILL_HACK

ORG $02D7AF
	JML CHAIN_HACK		; used for a couple sprites with chains attaching them

ORG $02D819
	JML BALLNCHAIN_HACK

ORG $02D84E
	JML GREYPLAT_HACK

ORG $02D8CB
	JML BUBBLE_HACK1

ORG $02D9E6
	JML BUBBLE_HACK2

ORG $02DB08
	JML HAMMERBRO_HACK

ORG $02DC5D
	JML HAMMERBROPLAT_HACK

ORG $02DE5B
	JML SUMOBRO_HACK

ORG $02DEF0
	JML SUMOLIGHTNING_HACK

org $02E00E
	JML VOLCLOTUS_HACK

ORG $02E249
	JML DIRCOINS_HACK

org $02E3C6
	JML GASBUBBLE_HACK

ORG $02E581
	JML MUSHSCALE_HACK

org $02E63D
	JML HOLE_HACK

ORG $02E67D
	JML LAKITUFISH_HACK

org $02E905
	JML GROWINGPIPE_HACK

ORG $02E9EF
	JML PIPELAKITU_HACK

ORG $02EA25
	JML PIPELAKITU_HACK2

org $02ECF7
	JML SUPERKOOPA_HACK

ORG $02EDFA
	JML FLOATINGSKULL_HACK

ORG $02EF2A
	JML COINCLOUD_HACK

ORG $02EF45
	JML COINCLOUD_HACK2

ORG $02F12D
	JML WIGGLER_HACK

org $02F228
	JML WIGGLER_HACK2

org $02F3F9
	JML BIRDS_HACK

ORG $02F48D
	JML CHIMNEYSMOKE_HACK

org $02F4EB
	JML FIREPLACE_HACK

ORG $02F5DA
	JML GHOSTHOUSEEXIT_HACK

ORG $02F63B
	JML CASTLEANIMATION_HACK

org $02F6BA
	JML CASTLEANIMATION_HACK2

ORG $0383E0
	JML BIGBOO_HACK

org $038498
	JML FALLINGGREYPLAT_HACK

org $0384CE
	JML BLURP_HACK

ORG $0385B4
	JML PUFFER_HACK

ORG $0386BB
	JML FLYINGPLAT_HACK

ORG $038740
	JML LAVAPLAT_HACK

ORG $038859
	JML MEGAMOLE_HACK

ORG $0388A7
	JML SWOOPER_HACK

ORG $038968
	JML SLIDINGKOOPA_HACK

ORG $038B57
	JML BOWSERSTATUE_HACK

org $038D34
	JML CARROTLIFT_HACK

org $038DAC
	JML MESSAGEBOX_HACK

ORG $038E2E
	JML TIMEDPLAT_HACK

org $038EBA
	JML GREYBLOCK_HACK

org $038F2F
	JML STATUEFIREBALL_HACK

ORG $038F9D
	JML BOOSTREAM_HACK2

org $03900D
	JML REFLECTINGFIREBALL_HACK

org $039191
	JML FISHINGBOO_HACK

ORG $039218
	JML FALLINGSPIKE_HACK

org $039288
	JML CREATEEATBLOCK_HACK

org $0394E1
	JML WOODSPIKE_HACK

ORG $0396A3
	JML REX_HACK

ORG $039790
	JML FISHBONE_HACK

ORG $0397BD
	JML FISHBONE_HACK2

ORG $039E5F
	JML DINO_HACK

org $039EC8
	JML DINO_HACK2

ORG $03A071
	JML BLAARG_HACK

ORG $03A0AF
	JML BLAARG_HACK2

ORG $03B39F
	JML MECHAKOOPA_HACK

ORG $03B411
	JML MECHAKOOPA_HACK2

ORG $03C244
	JML LIGHTSWITCH_HACK

org $03C286
	JML CHAINSAW_HACK

ORG $03C404
	JML DRYBONES_HACK

ORG $03C4A5
	JML DISCOBALL_HACK



; extended sprites

ORG $028C8F
	JML UNKNOWNEX_HACK	; unknown extended sprite

ORG $028D11
	JML BOOSTREAM_HACK

ORG $028D9B
	JML WATERSPLASH_HACK

ORG $028E31
	JML ZZZ_HACK

ORG $028EA1
	JML YOSHISHATTER_HACK

ORG $028EEE
	JML STARSPARKLE_HACK

ORG $028F56
	JML LAVASPLASH_HACK

ORG $028FEF
	JML SHATTERBLOCK_HACK

ORG $029238
	JML BOUNCEBLOCK_HACK

ORG $0296F4
	BRA SMOKEPUFF_HACK2	; skip over some crap regarding bosses

ORG $029704
SMOKEPUFF_HACK2:

ORG $02970E
	JML SMOKEPUFF_HACK

ORG $0297A3
	BRA CONTACT_HACK2	; SKIP OVER SOME CRAP REGARDING BOSSES

ORG $0297B4
CONTACT_HACK2:

ORG $0297BE
	JML CONTACT_HACK

ORG $02993B
	LDA $0000		; clear some bytes

ORG $02994F
	BRA DUST_HACK2		; skip over some crap regarding bosses

ORG $02996F
DUST_HACK2:
	JML DUST_HACK

ORG $029A3D
	JML COINBLOCKCOIN_HACK

ORG $029B76
	JML VOLCLOTUSFIRE_HACK

ORG $029C54
	JML SMOKETRAIL_HACK

ORG $029C8B
	JML SPINJUMPSTARS_HACK

ORG $029D1D
	LDA $0000		; delete some unnecessary code

ORG $029D27			; dunno what sprite this is; shares cloud coin code
	JML UNKNOWNEXSPR2

ORG $029D45
	JML CLOUDCOIN_HACK

ORG $029E5F
	JML LAUNCHERARM_HACK

ORG $029EAF
	JML LAVASPLASH2_HACK

ORG $029F46
	JML AIRBUBBLE_HACK

ORG $029F76
	JML YOSHIFIREBALL_HACK

ORG $02A1D5
	JML EXSPRSUB_HACK

ORG $02A235
	JML TINYFLAME_HACK

ORG $02A287
	JML BASEBALL_HACK	

ORG $02A2C6
	JML BONE_HACK

org $02A31A
	JML EXSPRSUB2_HACK

ORG $02A36C
	JML SMOKEPUFF2_HACK

ORG $02AE9B
	JML SCORESPRITE_HACK

ORG $02F967
	JML LIGHTNINGFIRE_HACK

ORG $02FA2B
	JML CASTLEFLAME_HACK

org $02FCCD
	JML BOORING_HACK3

ORG $02FCD9
	JML BOORING_HACK2

ORG $02FD4A
	JML BOORING_HACK		; pretty sure this is used by a couple of things, actually

org $02FE48
	JML BONUS1UP_HACK

; misc

ORG $07F1E1
	JML BONUSSTAR_HACK


reset bytes

ORG !FREESPACE

db "STAR"				;\
dw MainEnd-MainStart-$01		; |Write RATS tag #1 to protect main code
dw MainEnd-MainStart-$01^$FFFF		;/

MainStart:

GAMEMODE_HACK:
	LDA $0100		; game mode
	CMP #$0C
	BCC GAMEMODE_1
	CMP #$10
	BCC GAMEMODE_0
GAMEMODE_1:
	ASL			; everything except overworld
	TAX
	REP #$20		; initialize some RAM every frame
	LDA GAMEMODE_TABLE,x	; put game mode in scratch
	STA $00
	LDA #$01FC
	STA !SPRITEINDEX	; set initial sprite index
	LDA #$0000
	STA !UBERINDEX
	STA !SUPERINDEX
	STA !HIGHINDEX		; reset these
	STA !MARIOCOUNTER	; set mariocounter and mariostart
	STA !YOSHIINDEX

	SEP #$20		; 8 bit A
	LDA #$00
	STA $02			; put bank of game mode in scratch
	JML [$0000]		; run the game
GAMEMODE_0:			; overworld
	ASL
	TAX
	REP #$20
	LDA GAMEMODE_TABLE,x	; put game mode target address in scratch
	STA $00
	SEP #$20
	LDA #$00		; put bank of target address in scratch
	STA $02
	JML [$0000]		; run the game


FINISHOAM:
	LDA $0100		; check game mode
	CMP #$0C
	BCC FINISH_0
	CMP #$10
	BCC FINISH_1
	BRA FINISH_0		; go move mario/etc to OAM
FINISH_1:			; finish moving stuff
CODE_008494:	LDY #$1E                
CODE_008496:	LDX $8475,Y       
CODE_008499:	LDA $0423,X             
CODE_00849C:	ASL                       
CODE_00849D:	ASL                       
CODE_00849E:	ORA $0422,X             
CODE_0084A1:	ASL                       
CODE_0084A2:	ASL                       
CODE_0084A3:	ORA $0421,X             
CODE_0084A6:	ASL                       
CODE_0084A7:	ASL                       
CODE_0084A8:	ORA $0420,X             
CODE_0084AB:	STA $0400,Y             
CODE_0084AE:	LDA $0427,X             
CODE_0084B1:	ASL                       
CODE_0084B2:	ASL                       
CODE_0084B3:	ORA $0426,X             
CODE_0084B6:	ASL                       
CODE_0084B7:	ASL                       
CODE_0084B8:	ORA $0425,X             
CODE_0084BB:	ASL                       
CODE_0084BC:	ASL                       
CODE_0084BD:	ORA $0424,X             
CODE_0084C0:	STA $0401,Y             
CODE_0084C3:	DEY                       
CODE_0084C4:	DEY                       
CODE_0084C5:	BPL CODE_008496           
		JML $0084C7	; return    


FINISH_0:           
	; super index stuff
	REP #$30
	LDA !SUPERINDEX	; get total number of used super priority sprite tiles
	TAX		; stick in x
	CLC
	ADC !UBERINDEX	; get where we should start writing in OAM
	TAY		; stick in y
	PHA		; push this for later
	DEY
	DEY
	DEX
	DEX
	BMI SUPERFINISH_0
SUPERFINISH_1:
	LDA !SUPEROAMX,X
	STA !OAMX,Y
	DEY
	DEY
	DEX
	DEX
	LDA !SUPEROAMX,X
	STA !OAMX,Y
	DEY
	DEY
	DEX
	DEX
	BPL SUPERFINISH_1
SUPERFINISH_0:
	LDA !SUPERINDEX
	LSR
	LSR
	TAX
	LDA $01,S
	LSR
	LSR
	TAY
	DEY
	DEX
	BMI SUPERFINISH_2
SUPERFINISH_3:
	LDA !SUPEROAMEXTENDED,X
	STA !OAMEXTENDED,Y
	DEY
	DEX
	BPL SUPERFINISH_3
SUPERFINISH_2:
	; high index stuff
	LDA !HIGHINDEX
	TAX
	PLA
	CLC
	ADC !HIGHINDEX
	TAY
	PHA
	DEY
	DEY
	DEX
	DEX
	BMI HIGHFINISH_0
HIGHFINISH_1:
	LDA !HIGHOAMX,X
	STA !OAMX,Y
	DEY
	DEY
	DEX
	DEX
	LDA !HIGHOAMX,X
	STA !OAMX,Y
	DEY
	DEY
	DEX
	DEX
	BPL HIGHFINISH_1
HIGHFINISH_0:
	LDA !HIGHINDEX
	LSR
	LSR
	TAX
	LDA $01,S
	LSR
	LSR
	TAY
	DEY
	DEX
	BMI HIGHFINISH_2
HIGHFINISH_3:
	LDA !HIGHOAMEXTENDED,X
	STA !OAMEXTENDED,Y
	DEY
	DEX
	BPL HIGHFINISH_3
HIGHFINISH_2:
	; mario 
	LDA !MARIOSTART
	AND #$00FF
	STA $03
	LDA.w #!MARIOOAMX>>8
	STA $01
	LDA.w #!MARIOOAMX
	CLC
	ADC $03
	STA $00
	LDA !MARIOCOUNTER
	AND #$00FF
	ASL
	ASL
	STA $03
	TAY
	PLA
	CLC
	ADC $03
	TAX
	PHA
	DEX
	DEX
	DEY
	DEY
	BMI MARIOFINISH_0
MARIOFINISH_1:
	LDA [$00],Y
	STA !OAMX,X
	DEX
	DEX
	DEY
	DEY
	LDA [$00],Y
	STA !OAMX,X
	DEX
	DEX
	DEY
	DEY
	BPL MARIOFINISH_1
MARIOFINISH_0:
	LDA !MARIOSTART
	AND #$00FF
	LSR
	LSR
	STA $03
	LDA.w #!MARIOTILESIZE>>8
	STA $01
	LDA.w #!MARIOTILESIZE
	CLC
	ADC $03
	STA $00
	LDA !MARIOCOUNTER
	AND #$00FF
	TAY
	LDA $01,S
	LSR
	LSR
	TAX
	DEX
	DEY
	BMI MARIOFINISH_2
MARIOFINISH_3:
	LDA [$00],Y
	STA !OAMEXTENDED,X
	DEX
	DEY
	BPL MARIOFINISH_3
MARIOFINISH_2:
	; yoshi   
	LDA !YOSHIINDEX
	TAX  
	PLA
	CLC
	ADC !YOSHIINDEX
	TAY
	PHA
	DEY
	DEY
	DEX
	DEX
	BMI YOSHIFINISH_0
YOSHIFINISH_1:
	LDA !YOSHIOAMX,X
	STA !OAMX,Y
	DEY
	DEY
	DEX
	DEX
	LDA !YOSHIOAMX,X
	STA !OAMX,Y
	DEY
	DEY
	DEX
	DEX
	BPL YOSHIFINISH_1
YOSHIFINISH_0:
	LDA !YOSHIINDEX
	LSR
	LSR
	TAX
	PLA
	LSR
	LSR
	TAY
	DEY
	DEX
	BMI YOSHIFINISH_2
YOSHIFINISH_3:
	LDA !YOSHIOAMEXTENDED,X
	STA !OAMEXTENDED,Y
	DEY
	DEX
	BPL YOSHIFINISH_3
YOSHIFINISH_2:
	SEP #$30
	JMP FINISH_1



MARIO_OAM_HACK:			; hack for mario's OAM routine
	PHA			; push properties byte
	LDA $0100		; get game mode
	CMP #$14
	BCS MARIO_OAM_NOTOW
	CMP #$0C
	BCC MARIO_OAM_NOTOW
	JMP MARIO_ON_OW
MARIO_OAM_NOTOW:
	LDA #$04
	STA !MARIOCOUNTER	; initialize these
	LDA #$08
	STA !MARIOSTART
	LDA $01,S
	LDX #$08		; oam index
	STA !MARIOOAMPROP,x	; set properites
	JSR MARIO_SUBROUTINE	; subroutine to set tiles/etc
	LDA $01,s		; get properties byte
	STA !MARIOOAMPROP,x	; set properites
	JSR MARIO_SUBROUTINE	; subroutine to set tiles/etc
	LDA $01,s		; get properties byte
	PHX
	LDX $04
	CPX #$E8
	BNE CODE_00E3EC
	EOR #$40
CODE_00E3EC:
	PLX
	STA !MARIOOAMPROP,x	; set properites
	JSR MARIO_SUBROUTINE	; subroutine to set tiles/etc
	LDA $01,s		; get properties byte
	STA !MARIOOAMPROP,x	; set properites
	JSR MARIO_SUBROUTINE	; subroutine to set tiles/etc
	JML $00E3FB		; return to normal mario code


MARIO_OAM_HACK2:
	PHA
	LDA $0100		; get game mode
	CMP #$14
	BCS MARIO_OAM_NOTOW2
	CMP #$0C
	BCC MARIO_OAM_NOTOW2
	PLA
	JMP MARIO_ON_OW2
MARIO_OAM_NOTOW2:
	PLA
	TYX
	TSB $78
	BMI CODE_00E448
	LDA !MARIOCOUNTER	; increment mario counter
	INC A
	STA !MARIOCOUNTER
	LDA $01,s		; get properties byte
	STA !MARIOOAMPROP,x	; set properites
	JSR MARIO_SUBROUTINE	; store tile to oam
CODE_00E448:
	LDA !MARIOCOUNTER
	INC A
	INC A
	STA !MARIOCOUNTER	; add 2 to mario counter
	LDX #$04
	PHA			; push this number
	LDA #$00
	STA !MARIOSTART		; set where to start oam later
	LDA $02,s		; get properties byte
	STA !MARIOOAMPROP,x	; set properites
	JSR MARIO_SUBROUTINE
	PLA			; get pushed number
	CMP !MARIOCOUNTER
	BNE MARIOCAPE_0		; branch if last tile hidden
	LDX #$00
	BRA MARIOCAPE_1
MARIOCAPE_0:
	LDA #$04
	STA !MARIOSTART		; set where to start oam later
	TAX
MARIOCAPE_1:
	LDA $0E
	STA $06
	LDA !MARIOCOUNTER
	PHA			; push this
	LDA $02,s		; get properties byte
	STA !MARIOOAMPROP,x	; set properites
	JSR MARIO_SUBROUTINE
	PLA			; get pushed number again
	CMP !MARIOCOUNTER
	BEQ MARIOCAPE_2
	LDA !MARIOSTART		; set where to start oam later
	CLC
	ADC #$04
	STA !MARIOSTART
MARIOCAPE_2:
MARIO_OAM_HACK3:
	LDA $0100		; get game mode
	CMP #$14
	BCS MARIO_OAM_NOTOW3
	CMP #$0C
	BCC MARIO_OAM_NOTOW3
	JMP MARIO_ON_OW3
MARIO_OAM_NOTOW3:
	PLA			; pull properties byte back
MARIO_ON_OW3:
	JSL $00F636		; do this subroutine
	PLB
	RTL			; return
	





MARIO_SUB_RETURN:
	ASL $04      
	LDA !MARIOCOUNTER	; decrement counter
	DEC A
	STA !MARIOCOUNTER
	JMP CODE_00E4B2		; return to subroutine
	


MARIO_SUBROUTINE:
CODE_00E45D:	LSR $78                   
CODE_00E45F:	BCS MARIO_SUB_RETURN          
CODE_00E461:	LDY $06                   
CODE_00E463:	LDA $DFDA,Y	    	; Mario 8x8 tiles
CODE_00E466:	BMI MARIO_SUB_RETURN          
CODE_00E468:	STA !MARIOOAMTILE,X          
CODE_00E46B:	LDY $05                   
CODE_00E46D:	REP #$20                  ; Accum (16 bit) 
CODE_00E46F:	LDA $80                 ; mario's y screen position
CODE_00E471:	CLC                       
CODE_00E472:	ADC $DE32,Y       	; mario's y screen position + offset?
CODE_00E475:	PHA                       
CODE_00E476:	CLC                       
CODE_00E477:	ADC #$0010              
CODE_00E47A:	CMP #$0100              
CODE_00E47D:	PLA                       
CODE_00E47E:	SEP #$20                  ; Accum (8 bit) 
CODE_00E480:	BCS MARIO_SUB_RETURN         ; don't write if below/above the screen?
CODE_00E482:	STA !MARIOOAMY,X         
CODE_00E485:	REP #$20                  ; Accum (16 bit) 
CODE_00E487:	LDA $7E			; mario x position (screen) 
CODE_00E489:	CLC                       
CODE_00E48A:	ADC $DD4E,Y       ; offset
CODE_00E48D:	PHA                       
CODE_00E48E:	CLC                       
CODE_00E48F:	ADC #$0080              
CODE_00E492:	CMP #$0200              ; don't write if too far left/right
CODE_00E495:	PLA                       
CODE_00E496:	SEP #$20                  ; Accum (8 bit) 
CODE_00E498:	BCS MARIO_SUB_RETURN           
CODE_00E49A:	STA !MARIOOAMX,X        
CODE_00E49D:	XBA                       
CODE_00E49E:	LSR                       
CODE_00E49F:	
		PHX
		PHP                       
CODE_00E4A0:	TXA                       
CODE_00E4A1:	LSR                       
CODE_00E4A2:	LSR                       
CODE_00E4A3:	TAX                       
CODE_00E4A4:	ASL $04                   
CODE_00E4A6:	ROL                       
CODE_00E4A7:	PLP                       
CODE_00E4A8:	ROL                       
CODE_00E4A9:	AND #$03                
CODE_00E4AB:	STA !MARIOTILESIZE,X   
		PLX   
CODE_00E4AE:	INX                     
CODE_00E4AF:	INX                       
CODE_00E4B0:	INX                       
CODE_00E4B1:	INX                       
CODE_00E4B2:	INC $05                   
CODE_00E4B4:	INC $05                   
CODE_00E4B6:	INC $06                   
Return00E4B8:	RTS                       ; Return 


MARIO_ON_OW:
	PLA		; pull A
	STA $0303,y	; restore old code
	STA $0307,y	;
	JML $00E3D8	; return

MARIO_ON_OW2:
	TSB $78		; restore old code
	BMI MARIO_ON_OW2_0
	JML $00E445	; return
MARIO_ON_OW2_0:
	JML $00E448	; return
	





SPRITE_INIT_HACK:
	PHX		; push X
	TXA
	ASL A
	TAX
	REP #$20	; 16 bit A 
	LDA !SPRITEINDEX
	STA !SPRITEOAM,x; set oam index
	SEP #$20	; 8 bit A
	PLX		; pull x
	JML $0180E5	; return
	

LVLENDSPRCOIN_HACK:
	TXY		; store x in y temporarily
	TAX
	LDA $FBA4,x	; get sprite tile number
	PHA		; push it
	TYA		; y holds sprite index
	ASL A
	TAX
	REP #$20	; 16 bit A
	LDA !SPRITEOAM,x; get oam index
	REP #$10	; 16 bit X Y
	TAY
	SEP #$20	; 8 bit A
	PLA		; pull sprite tile number
	STA !OAMTILE,y	; set tile
	SEP #$10	; 8 bit X Y
	JML $00FBEE	; return


SHELLLESSKOOPA_HACK:
	PHX		; push sprite index
	PHA		; push tile number
	TXA
	ASL A
	REP #$30	; 16 bit A X Y
	AND #$00FF	; clear high byte
	TAX
	LDA !SPRITEOAM,x; get oam index
	TAY
	SEP #$20	; 8 bit A
	PLA		; pull tile number
	STA !OAMTILE,y	; store tile
	SEP #$10	; 8 bit 'A X Y
	PLX		; pull sprite index
	JML $0189FC	; return


GOOMBAWING_HACK2:
	STA $03
	LDA $1570,X
	LSR
	LSR
	AND #$02
	CLC
	ADC $1602,X
	STA $05
	ASL
	STA $02
	LDA $157C,X
	STA $04
	PHX		; push sprite index
	REP #$30	; 16 bit A X Y
	LDA !SPRITEINDEX; get oam index
	TAY 		; stick in y
	LDA #$0000	; clear high byte of A
	SEP #$20	; 8 bit A
	LDA $03
	CLC
	ADC $02
	PHA
	LDA $04
	BNE CODE_018E15
	LDA $01,s	; get number pushed
	CLC
	ADC #$08
	BRA GOOMBAWING_HACK2_0
CODE_018E15:
	LDA $01,s
GOOMBAWING_HACK2_0:
	TAX
	LDA $00
	CLC
	ADC $8DC7,x
	STA !OAMX,y
	PLA
	TAX
	LDA $01
	CLC
	ADC $8DD7,x
	STA !OAMY,y	
	LDA $05
	TAX
	LDA $8DE1,x
	STA !OAMTILE,y	
	REP #$20	; 16 bit A
	PHY
	TYA
	LSR
	LSR
	TAY
	SEP #$20	; 8 bit a
	LDA $8DE5,x
	STA !OAMEXTENDED,y
	PLY
	LDA $03
	TAX
	LDA $04
	LSR
	LDA $8DDF,x
	BCS CODE_018E49
	EOR #$40
CODE_018E49:
	ORA $64
	STA !OAMPROP,y
	SEP #$30	; 8 bit A
	PLX
	LDY #$FF
	LDA #$00
	JSL $01B7B3	; finish writing to OAM 
	JML $018E5E	; return
	

PIRANHAPLANT_HACK:
	REP #$30	; 16 bit A X Y
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,x
	TAY
	PLX
	SEP #$20	; 8 bit A
	LDA $9E,x	; get sprite number
	CMP #$1A	; check if classic version
	BEQ PIRANHAPLANT_CLASSIC
	LDA !OAMPROP-$4,y
	AND #$F1
	ORA #$0B
	STA !OAMPROP-$4,Y
	BRA PIRANHAPLANT_HACK_0
PIRANHAPLANT_CLASSIC:
	LDA !OAMPROP,y
	AND #$F1
	ORA #$0B
	STA !OAMPROP,y
PIRANHAPLANT_HACK_0:
	SEP #$10	; 8 bit x y
	JML $018E97	; return


LAKITU_HACK:
	REP #$30
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,x
	TAY
	SEP #$20	;
	LDA !OAMY,Y
	SEC
	SBC #$03
	STA !OAMY,y
	PLX
	SEP #$10
	JML $018FB8	; return


STUNNED_RETURN:
	JML $0198A6	; return

STUNNED_HACK2:
	LDA $14C8,x
	CMP #$0B
	BNE STUNNED_0
	LDA $13E0
	CMP #$0F
	BNE STUNNED_0
	LDA #$06
	STA $1602,X
	JSR SUBSPRGFX2_HIGH
	JMP STUNNED_HIGHPRI
STUNNED_0:
	LDA #$06
	STA $1602,X
	JML $01981E	; return

STUNNED_HACK:
	LDA $1EEB
	BMI STUNNED_RETURN
	LDA $1602,x
	CMP #$06
	BNE STUNNED_RETURN
	REP #$30	; 16 bit A X Y
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,x
	TAY
	PLX
	SEP #$20	; 8 bit A
	LDA $1558,x
	BNE CODE_019842
	LDA $1540,x
	BEQ STUNNED_RETURN2
	CMP #$30
	BCS CODE_01984D
CODE_019842:
	LSR
	LDA !OAMX,y
	ADC #$00
	BCS CODE_01984D
	STA !OAMX,y
CODE_01984D:
	LDA $9E,x
	CMP #$11
	BEQ STUNNED_RETURN2
	LDA $15A0,x
	ORA $186C,X
	BNE STUNNED_RETURN2
	LDA $15F6,X
	ASL
	LDA #$08
	BCC CODE_019862
	LDA #$00
CODE_019862:
	STA $00
	LDA !OAMX,y
	CLC
	ADC #$02
	STA !OAMX-$8,y
	CLC
	ADC #$04
	STA !OAMX-$4,Y
	LDA !OAMY,Y
	CLC
	ADC $00
	STA !OAMY-$8,Y
	STA !OAMY-$4,Y
	PHY
	LDY #$0064
	LDA $14
	AND #$F8
	BNE CODE_01988A
	LDY #$004D
CODE_01988A:
	TYA
	PLY
	STA !OAMTILE-$8,Y
	STA !OAMTILE-$4,Y
	LDA $64
	STA !OAMPROP-$8,Y
	STA !OAMPROP-$4,Y
	REP #$20	; 16 BIT A
	TYA
	LSR A
	LSR A
	TAY
	LDA !SPRITEINDEX; update sprite index, 'cause two tiles were drawn
	SEC
	SBC #$0008
	STA !SPRITEINDEX
	SEP #$20	; 8 BIT A
	LDA #$00
	STA !OAMEXTENDED-$2,Y
	STA !OAMEXTENDED-$1,Y	
STUNNED_RETURN2:
	SEP #$30	; 8 bit A X Y
	JML $0198A6	; return


STUNNED_RETURN2_2:
	SEP #$30	; 8 bit A X Y
	TYX
	JML $0198A6	; return


STUNNED_HIGHPRI:
	REP #$30	; 16 bit A X Y
	TXY		; use y for sprite index
	LDA !HIGHINDEX
	SEC
	SBC #$0004	; offset since we drew a tile
	TAX
	SEP #$20	; 8 bit A
	LDA $1558,y
	BNE CODE_019842_2
	LDA $1540,y
	BEQ STUNNED_RETURN2_2
	CMP #$30
	BCS CODE_01984D_2
CODE_019842_2:
	LSR
	LDA !HIGHOAMX,X
	ADC #$00
	BCS CODE_01984D_2
	STA !HIGHOAMX,X
CODE_01984D_2:
	LDA $009E,Y
	CMP #$11
	BEQ STUNNED_RETURN2_2
	LDA $15A0,Y
	ORA $186C,Y
	BNE STUNNED_RETURN2_2
	LDA $15F6,Y
	ASL
	LDA #$08
	BCC CODE_019862_2
	LDA #$00
CODE_019862_2:
	STA $00
	LDA !HIGHOAMX,X
	STA !HIGHOAMX+$8,X
	CLC
	ADC #$02
	STA !HIGHOAMX,X
	CLC
	ADC #$04
	STA !HIGHOAMX+$4,X
	LDA !HIGHOAMY,X
	STA !HIGHOAMY+$8,X
	CLC
	ADC $00
	STA !HIGHOAMY,X
	STA !HIGHOAMY+$4,X
	LDA !HIGHOAMTILE,X
	STA !HIGHOAMTILE+$8,X
	LDA !HIGHOAMPROP,X
	STA !HIGHOAMPROP+$8,X
	PHX
	LDX #$0064
	LDA $14
	AND #$F8
	BNE CODE_01988A_2
	LDX #$004D
CODE_01988A_2:
	TXA
	PLX
	STA !HIGHOAMTILE,X
	STA !HIGHOAMTILE+$4,X
	LDA $64
	STA !HIGHOAMPROP,X
	STA !HIGHOAMPROP+$4,X
	REP #$20	; 16 BIT A
	LDA !HIGHINDEX
	CLC
	ADC #$0008	; add two tiles to this
	STA !HIGHINDEX
	TXA
	LSR A
	LSR A
	TAX
	SEP #$20	; 8 BIT A
	LDA !HIGHOAMEXTENDED,X
	STA !HIGHOAMEXTENDED+$2,x
	LDA #$00
	STA !HIGHOAMEXTENDED,X
	STA !HIGHOAMEXTENDED+$1,X
	SEP #$30	; 8 bit A X Y
	TYX
	JML $0198A6	; return


SHELL_HACK:
	PHA
	REP #$30	; 16 bit A X Y
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,x
	TAY
	SEP #$20
	PLX
	PLA
	EOR !OAMPROP,y
	STA !OAMPROP,y
	SEP #$10
	JML $019A4D


SPINJUMP_HACK:
	REP #$30
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,x
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA $1540,X
	LSR
	LSR
	LSR
	AND #$03
	PHX
	TAX
	LDA $9A4E,X
	PLX
	STA !OAMTILE,Y
	AND #$30
	STA !OAMPROP,Y
	SEP #$10
	JML $019A76
	

SMUSHED_HACK:
	REP #$30
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	SEP #$20
	LDA #$AC
	STA !OAMTILE,Y
	SEP #$10
	JML $019B0F


KOOPAWING_HACK:
	PHX
	REP #$30
	LDA !SPRITEINDEX
	TAY
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20
	LDA $157C,X
	ASL
	ADC $02
	TAX
	LDA $00
	CLC
	ADC $9E10,X
	STA $00
	LDA $04
	ADC $9E14,X
	PHA
	LDA $00
	SEC
	SBC $1A
	STA !OAMX,Y
	PLA
	SBC $1B
	BEQ KOOPAWING_0
	REP #$20
	PHY
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$01
	BRA KOOPAWING_1
KOOPAWING_0:
	REP #$20
	PHY
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$00
KOOPAWING_1:
	ORA $9E24,X
	STA !OAMEXTENDED,Y
	PLY
	LDA $01
	SEC
	SBC $1C
	CLC
	ADC $9E18,X
	STA !OAMY,Y
	LDA $9E1C,X
	STA !OAMTILE,Y
	LDA $64
	ORA $9E20,X
	STA !OAMPROP,Y
	SEP #$10
	JML $019E93	; RETURN


FLYINGQUESTION_HACK:
	REP #$30
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	SEP #$20
	LDA !OAMY,Y
	DEC A
	STA !OAMY,Y
	SEP #$10
	JML $01AD8D	; return


FLYINGQUESTION_HACK2:
	REP #$30
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	SEP #$20
	LDA !OAMY,Y
	SEC
	SBC $00
	STA !OAMY,Y
	LDA $C2,X
	CMP #$01
	LDA #$2A
	BCC CODE_01AE7B
	LDA #$2E
CODE_01AE7B:
	STA !OAMTILE,Y
	SEP #$10
	JML $01AE7E	; return

FLYINGQUESTION_HACK3:
	REP #$30
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEINDEX
	STA !SPRITEOAM,x
	PLX
	SEP #$30
	JML FLYINGQUESTION_0

COINSPRGFX_HACK:
	REP #$30
	LDA !SPRITEINDEX
	TAY
	LDA #$0000	; clear high byte of A
	SEP #$20
	TXA
	CLC
	ADC $14
	LSR
	LSR
	AND #$03
	BNE CODE_01C670
	LDA $00
	STA !OAMX,Y
	LDA $01
	STA !OAMY,Y
	LDA #$E8
	STA !OAMTILE,Y
	LDA $15F6,X
	ORA $64
	STA !OAMPROP,Y
	SEP #$10
	LDY #$02
	LDA #$00
	BRA CODE_01C69A
CODE_01C670:
	PHX
	TAX
	LDA $00
	CLC
	ADC #$04
	STA !OAMX,Y
	STA !OAMX-$4,Y
	LDA $01
	STA !OAMY,Y
	CLC
	ADC #$08
	STA !OAMY-$4,Y
	LDA $01C66C,X
	STA !OAMTILE,Y
	STA !OAMTILE-$4,Y
	PLX
	LDA $15F6,X
	ORA $64
	STA !OAMPROP,Y
	ORA #$80
	STA !OAMPROP-$4,Y
	SEP #$10
	LDY #$00
	LDA #$01
CODE_01C69A:
	JML $01C69C	; return


POWERUP_HACK:
	REP #$30
	LDA !SPRITEINDEX
	TAY
	LDA #$0000	; clear high byte of A
	SEP #$20
	LDA $00
	STA !OAMX,Y
	LDA $01
	DEC A
	STA !OAMY,Y
	LDA $157C,X
	LSR
	LDA #$00
	BCS CODE_01C6C7
	ORA #$40
CODE_01C6C7:
	ORA $64
	ORA $15F6,X
	EOR $0A
	STA !OAMPROP,Y
	LDA $9E,X
	SEC
	SBC #$74
	TAX
	LDA $C609,X
	STA !OAMTILE,Y
	SEP #$10
	JML $01C6DD	; return
	

THWOMP_HACK:
	LDX #$00
	CMP #$00
	BEQ CODE_01AF64
	LDA #$04
	STA $03
	STA $04
	BRA THWOMP_0
CODE_01AF64:
	LDA #$03
	STA $03
	STA $04
THWOMP_0:
	REP #$30
	LDA !SPRITEINDEX
	TAY
	SEP #$20
THWOMP_LOOP:
	LDA $00
	CLC
	ADC $AF40,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $AF45,X
	STA !OAMY,Y
	LDA $AF4F,X
	ORA $64
	STA !OAMPROP,Y
	LDA $AF4A,X
	CPX #$0004
	BNE CODE_01AF8F
	PHA
	LDA $02
	CMP #$02
	BNE THWOMP_1
	PLA
	LDA #$CA
	BRA CODE_01AF8F
THWOMP_1:
	PLA
CODE_01AF8F:
	STA !OAMTILE,Y
	DEY
	DEY
	DEY
	DEY
	INX
	DEC $03
	BPL THWOMP_LOOP
	SEP #$10
	PLX
	LDA $04
	JML $01B37E	; return
	
	

PLATFORM_HACK:
	REP #$30
	BEQ PLATFORM_0
	LDA !SPRITEINDEX
	SEC
	SBC #$0010	; 5 tiles
	BRA PLATFORM_1
PLATFORM_0:
	LDA !SPRITEINDEX
	SEC
	SBC #$0008	; 3 tiles
PLATFORM_1:
	TAY
	SEP #$20
	LDA $D8,X
	SEC
	SBC $1C
	STA !OAMY,Y
	STA !OAMY+$4,Y
	STA !OAMY+$8,Y
	PHA
	LDA $01
	BEQ CODE_01B2FF
	LDA $01,S
	STA !OAMY+$C,Y
	STA !OAMY+$10,Y
CODE_01B2FF:
	PLA
	LDA $E4,X
	SEC
	SBC $1A
	STA !OAMX,Y
	CLC
	ADC #$10
	STA !OAMX+$4,Y
	CLC
	ADC #$10
	STA !OAMX+$8,Y
	PHA
	LDA $01
	BEQ CODE_01B326
	LDA $01,S
	CLC
	ADC #$10
	STA !OAMX+$C,Y
	CLC
	ADC #$10
	STA !OAMX+$10,Y
CODE_01B326:
	PLA
	LDA $01
	BEQ CODE_01B344
	LDA #$EA
	STA !OAMTILE,Y
	LDA #$EB
	STA !OAMTILE+$4,Y
	STA !OAMTILE+$8,Y
	STA !OAMTILE+$C,Y
	LDA #$EC
	STA !OAMTILE+$10,Y
	LDA $64
	ORA $15F6,X
	STA !OAMPROP+$C,Y
	STA !OAMPROP+$10,Y
	BRA CODE_01B359
CODE_01B344:
	LDA #$60
	STA !OAMTILE,Y
	LDA #$61
	STA !OAMTILE+$4,Y
	LDA #$62
	STA !OAMTILE+$8,Y
	LDA $64
	ORA $15F6,X
CODE_01B359:
	STA !OAMPROP,Y
	STA !OAMPROP+$4,Y
	STA !OAMPROP+$8,Y
	SEP #$10
	LDA #$02
	LDY $01
	BEQ CODE_01B37E
	LDA #$04
CODE_01B37E:
	JML $01B37E	; return


ORANGEPLATS_HACK:
	LDA $00
	REP #$30
	BEQ ORANGEPLATS_0
	LDA !SPRITEINDEX
	SEC
	SBC #$0020	; 9 tiles
	BRA ORANGEPLATS_1
ORANGEPLATS_0:
	LDA !SPRITEINDEX
	SEC
	SBC #$0010	; 5 TILES
ORANGEPLATS_1:
	TAY
	LDA #$0000	; clear high byte of A
	SEP #$20
	PHY
	LDA $D8,X
	SEC
	SBC $1C
	STA !OAMY,Y
	STA !OAMY+$8,Y
	STA !OAMY+$10,Y
	PHA
	LDA $00
	BEQ CODE_01B3BD
	LDA $01,S
	STA !OAMY+$18,Y
	STA !OAMY+$20,Y
	CLC
	ADC #$10
	STA !OAMY+$14,Y
	STA !OAMY+$1C,Y
CODE_01B3BD:
	PLA
	CLC
	ADC #$10
	STA !OAMY+$4,Y
	STA !OAMY+$C,Y
	LDA $00
	BNE CODE_01B3D8
	LDA #$08
	BRA ORANGEPLATS_2
CODE_01B3D8:
	LDA #$04
ORANGEPLATS_2:
	STA $01
	DEC A
	STA $02
	LDA $15F6,X
	STA $03
	LDA $9E,X
	CMP #$5B
	LDA #$00
	BCS CODE_01B3EF
	LDA #$09
CODE_01B3EF:
	PHA
	LDA $E4,X
	SEC
	SBC $1A
CODE_01B3F6:
	STA !OAMX,Y
	LDA $01,S
	TAX
	LDA $B383,X
	STA !OAMTILE,Y
	LDA $64
	ORA $03
	STA !OAMPROP,Y
	LDA $01
	CMP $02
	BCS CODE_01B411
	LDA !OAMPROP,Y
	ORA #$40
	STA !OAMPROP,Y
CODE_01B411:
	PLA
	INC A
	PHA
	LDA !OAMX,Y
	CLC
	ADC #$08
	INY
	INY
	INY
	INY
	DEC $01
	BPL CODE_01B3F6
	PLA
	LDA $15E9
	TAX
	PLY
	LDA $00
	BNE CODE_01B444
	LDA $9E,X
	CMP #$5B
	BCS CODE_01B43A
	LDA #$85
	STA !OAMTILE+$10,Y
	LDA #$88
	STA !OAMTILE+$C,Y
	BRA CODE_01B444
CODE_01B43A:
	LDA #$CB
	STA !OAMTILE+$10,Y
	LDA #$E4
	STA !OAMTILE+$C,Y
CODE_01B444:
	SEP #$10
	JML $01B444	; return


FLOATMINE_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C	; 4 tiles
	TAY
	SEP #$20
CODE_01B66C:
	LDA $00
	CLC
	ADC $B65A,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $B65E,X
	STA !OAMY,Y
	LDA $14
	LSR
	LSR
	AND #$04
	LSR
	ADC #$AA
	STA !OAMTILE,Y
	LDA $B6B2,X
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_01B66C 
	SEP #$10
	JML $01B697	; return
	

TURNBLOCKBRIDGE_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0010	; 5 tiles
	TAY
	SEP #$20
	LDA $D8,X
	SEC
	SBC $1C
	STA !OAMY+$10,Y
	PHA
	PHA
	PHA
	SEC
	SBC $02
	STA !OAMY+$8,Y
	PLA
	SEC
	SBC $03
	STA !OAMY+$C,Y
	PLA
	CLC
	ADC $02
	STA !OAMY,Y
	PLA
	CLC
	ADC $03
	STA !OAMY+$4,Y
	LDA $E4,X
	SEC
	SBC $1A
	STA !OAMX+$10,Y
	PHA
	PHA
	PHA
	SEC
	SBC $00
	STA !OAMX+$8,Y
	PLA
	SEC
	SBC $01
	STA !OAMX+$C,Y
	PLA
	CLC
	ADC $00
	STA !OAMX,Y
	PLA
	CLC
	ADC $01
	STA !OAMX+$4,Y
	LDA $C2,X
	LSR
	LSR
	LDA #$40
	STA !OAMTILE,Y
	STA !OAMTILE+$4,Y
	STA !OAMTILE+$8,Y
	STA !OAMTILE+$C,Y
	STA !OAMTILE+$10,Y
	LDA #$3C
	STA !OAMPROP+$10,Y
	STA !OAMPROP+$4,Y
	STA !OAMPROP+$8,Y
	STA !OAMPROP+$C,Y
	ORA #$40
	STA !OAMPROP,Y
	SEP #$10
	JML $01B7A1	; return


CLIMBINGDOOR_HACK:
	LDA $E4,X
	SEC
	SBC $1A
	STA $00
	LDA $D8,X
	SEC
	SBC $1C
	STA $01
	LDA $1540,X
	LSR
	STA $02
	TAX
	LDA $13F9
	BEQ CLIMBINGDOOR_6
	JML CLIMBINGDOOR_HIGH
CLIMBINGDOOR_6:
	LDA $BAA7,X
	STA $06
	TAY
	REP #$30
	LDA !SPRITEINDEX
	SEC 			; set number of tiles
	SBC #$0008
	DEY
	DEY
	DEY
	BEQ CLIMBINGDOOR_0
CLIMBINGDOOR_1:
	SEC
	SBC #$000C
	DEY
	DEY
	DEY
	BNE CLIMBINGDOOR_1
CLIMBINGDOOR_0:
	TAY
	LDA #$0000		; clear high byte of A
	SEP #$20
	LDA $00
	CLC
	ADC $BA97,X
	STA !OAMX,Y
	STA !OAMX+$4,Y
	STA !OAMX+$8,Y
	LDA $06
	CMP #$02
	BEQ CODE_01BB8E
	LDA $00
	CLC
	ADC #$20
	SEC
	SBC $BA97,X
	STA !OAMX+$C,Y
	STA !OAMX+$10,Y
	STA !OAMX+$14,Y
	LDA $06
	CMP #$09
	BNE CODE_01BB8E
	LDA $00
	CLC
	ADC #$10
	STA !OAMX+$18,Y
	STA !OAMX+$1C,Y
	STA !OAMX+$20,Y
	LDA $06
CODE_01BB8E:
	PHY
	TAX
CLIMBINGDOOR_2:
	LDA $01
	STA !OAMY,Y
	CLC
	ADC #$10
	STA !OAMY+$4,Y
	CLC
	ADC #$10
	STA !OAMY+$8,Y
	REP #$20
	TYA
	CLC
	ADC #$000C
	TAY
	LDA #$0000
	SEP #$20
	DEX
	DEX
	DEX
	BNE CLIMBINGDOOR_2
	PLY		; get y back
	PHY		; and push it again
	LDA $06
	DEC A
	STA $07		; set number of tiles
	INC A
	CMP #$03
	BNE CLIMBINGDOOR_5
	LDA #$00
	BRA CLIMBINGDOOR_3
CLIMBINGDOOR_5:
	CMP #$06
	BNE CLIMBINGDOOR_3
	LDA #$03
CLIMBINGDOOR_3:
	TAX
CLIMBINGDOOR_4:
	LDA $BAB7,X
	STA !OAMTILE,Y
	INY
	INY
	INY
	INY
	INX
	DEC $07
	BPL CLIMBINGDOOR_4
	PLY		; get y back
	LDA $06		; get number of tiles
	DEC A
	STA $07
	LDX #$0000
CODE_01BBD0:
	LDA.l CLIMBINGDOOR_TABLE,x
	ORA $64
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	INX
	DEC $07
	BPL CODE_01BBD0
	LDA $15E9
	TAX
	LDA $06
	DEC A
	SEP #$10
	JML $01BBFA	; return


CLIMBINGDOOR_HIGH:
	LDA $BAA7,X
	STA $06
	TXY
	REP #$30
	LDA !HIGHINDEX
	TAX
	LDA #$0000		; clear high byte of A
	SEP #$20
	LDA $00
	CLC
	ADC $BA97,Y
	STA !HIGHOAMX,X
	STA !HIGHOAMX+$4,X
	STA !HIGHOAMX+$8,X
	LDA $06
	CMP #$02
	BEQ CODE_01BB8E_2
	LDA $00
	CLC
	ADC #$20
	SEC
	SBC $BA97,Y
	STA !HIGHOAMX+$C,X
	STA !HIGHOAMX+$10,X
	STA !HIGHOAMX+$14,X
	LDA $06
	CMP #$09
	BNE CODE_01BB8E_2
	LDA $00
	CLC
	ADC #$10
	STA !HIGHOAMX+$18,X
	STA !HIGHOAMX+$1C,X
	STA !HIGHOAMX+$20,X
	LDA $06
CODE_01BB8E_2:
	PHX
	TAY
CLIMBINGDOOR_2_2:
	LDA $01
	STA !HIGHOAMY,X
	CLC
	ADC #$10
	STA !HIGHOAMY+$4,X
	CLC
	ADC #$10
	STA !HIGHOAMY+$8,X
	REP #$20
	TXA
	CLC
	ADC #$000C
	TAX
	LDA #$0000
	SEP #$20
	DEY
	DEY
	DEY
	BNE CLIMBINGDOOR_2_2
	PLX		; get X back
	PHX		; and push it again
	LDA $06
	DEC A
	STA $07		; set number of tiles
	INC A
	CMP #$03
	BNE CLIMBINGDOOR_5_2
	LDA #$00
	BRA CLIMBINGDOOR_3_2
CLIMBINGDOOR_5_2:
	CMP #$06
	BNE CLIMBINGDOOR_3_2
	LDA #$03
CLIMBINGDOOR_3_2:
	TAY
CLIMBINGDOOR_4_2:
	LDA $BAB7,Y
	STA !HIGHOAMTILE,X
	INX
	INX
	INX
	INX
	INY
	DEC $07
	BPL CLIMBINGDOOR_4_2
	PLX		; get y back
	LDA $06		; get number of tiles
	DEC A
	STA $07
	PHB
	PHK
	PLB
	LDY #$0000
CODE_01BBD0_2:
	LDA CLIMBINGDOOR_TABLE,Y
	ORA $64
	STA !HIGHOAMPROP,x
	INX
	INX
	INX
	INX
	INY
	DEC $07
	BPL CODE_01BBD0_2
	PLB
	LDA $15E9
	TAY
	LDA $06
	DEC A
	SEP #$10
	LDX #$02
	JSR FinishOAMWriteRt_HIGH
	JML $01BBFD		; return

CLIMBINGDOOR_TABLE:		; properties bytes for climbing door
db $09,$09,$89,$49,$49,$C9,$49,$49,$C9
	
	

MAGIMAGIC_HACK:
	TXY
	REP #$30
	LDA !SUPERINDEX
	TAX
	LDA #$0000
	SEP #$20
	LDA $01
	CLC
	ADC $BCE0,Y
	STA !SUPEROAMY,X
	LDA $03
	TAY
	LDA $00
	CLC
	ADC $BCE0,Y
	STA !SUPEROAMX,X
	LDA $02
	CLC
	ADC #$05
	AND #$0F
	STA $02
	TAY
	LDA $01
	CLC
	ADC $BCE0,Y
	STA !SUPEROAMY+$4,X
	LDA $03
	CLC
	ADC #$05
	AND #$0F
	STA $03
	TAY
	LDA $00
	CLC
	ADC $BCE0,Y
	STA !SUPEROAMX+$4,X
	LDA $02
	CLC
	ADC #$05
	AND #$0F
	STA $02
	TAY
	LDA $01
	CLC
	ADC $BCE0,Y
	STA !SUPEROAMY+$8,X
	LDA $03
	CLC
	ADC #$05
	AND #$0F
	STA $03
	TAY
	LDA $00
	CLC
	ADC $BCE0,Y
	STA !SUPEROAMX+$8,X
	LDA $15E9
	TAY
	LDA $15F6,Y
	ORA $64
	STA !SUPEROAMPROP,X
	STA !SUPEROAMPROP+$4,X
	STA !SUPEROAMPROP+$8,X
	LDA #$88
	STA !SUPEROAMTILE,X
	LDA #$89
	STA !SUPEROAMTILE+$4,X
	LDA #$98
	STA !SUPEROAMTILE+$8,X
	SEP #$10
	LDX #$00
	LDA #$02
	JSR FinishOAMWriteRt_SUPER
	JML $01BDA2	; return


MAGIKOOPA_HACK:
	REP #$30
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,X
	SEC
	SBC #$0004
	TAX
	SEP #$20
	INC !OAMY,X
	PLX
	SEP #$10
	JML $01BEC6		; return


MAGIKOOPA_HACK2:
	PHA
	REP #$30
	LDA !SPRITEINDEX
	TAY
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	SEP #$20
	PLA
	STA !OAMX,Y
	LDA $D8,X
	SEC
	SBC $1C
	CLC
	ADC #$10
	STA !OAMY,Y
	LDA $157C,X
	LSR
	LDA #$00
	BCS CODE_01B3FC
	LDA #$40
CODE_01B3FC:
	ORA $64
	ORA $15F6,X
	STA !OAMPROP,Y
	LDA #$99
	STA !OAMTILE,Y
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$00
	ORA $15A0,X
	STA !OAMEXTENDED,Y
	SEP #$10
	JML $01BF15	; return


GOALTAPE_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0008	; THREE tiles
	TAY
	SEP #$20
	LDA $00
	STA !OAMX+$4,Y
	SEC
	SBC #$08
	STA !OAMX,Y
	LDA $00
	CLC
	ADC #$08
	STA !OAMX+$8,Y
	LDA $01
	CLC
	ADC #$08
	STA !OAMY,Y
	STA !OAMY+$4,Y
	STA !OAMY+$8,Y
	LDA #$D4
	STA !OAMTILE,Y
	INC A
	STA !OAMTILE+$4,Y
	STA !OAMTILE+$8,Y
	LDA #$32
	STA !OAMPROP,Y
	STA !OAMPROP+$4,Y
	STA !OAMPROP+$8,Y
	SEP #$10
	JML $01C16E	; RETURN

BONUSSTAR_HACK:
	BEQ BONUS_1STAR
	LDA $07F1A0,X
	TAX
	REP #$30
	LDA !UBERINDEX
	TAY
	LDA #$0000
	SEP #$20
	JSR DRAWSTARS
BONUS_1STAR:
	PLA
	AND #$0F
	TAX
	LDA $07F1A0,X
	TAX
	LDA #$20
	STA $02
	REP #$30
	LDA !UBERINDEX
	TAY
	LDA #$0000
	SEP #$20
	JSR DRAWSTARS
	JML $07F1FF		; return

CODE_07F24A:
	SEP #$10
	LDX $15E9
	RTS

DRAWSTARS:
	LDA $07F0C8,X
	BMI CODE_07F24A
	CLC
	ADC #$64
	CLC
	ADC $02
	STA !OAMX,Y
	LDA $07F134,X
	CLC
	ADC #$40
	PHX
	STA !OAMY,Y
	LDA $04
	CMP #$10
	BCS CODE_07F22A
	LSR
	LSR
	TAX
	LDA $07F24E,X
	BRA DRAWSTARS_0
CODE_07F22A:
	LDA #$EF
DRAWSTARS_0:
	STA !OAMTILE,Y
	LDA $13
	LSR
	AND #$0E
	ORA #$30
	STA !OAMPROP,Y
	REP #$20
	TYA
	LSR
	LSR
	TAX
	LDA !UBERINDEX
	CLC
	ADC #$0004
	STA !UBERINDEX
	LDA #$0000
	SEP #$20
	LDA #$00
	STA !OAMEXTENDED,X
	PLX
	INY
	INY
	INY
	INY
	INX
	BRA DRAWSTARS


VINE_HACK:
	REP #$30
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	SEP #$20
	LDA $14
	LSR
	LSR
	LSR
	LSR
	LDA #$AC
	BCC CODE_01C1A3
	LDA #$AE
CODE_01C1A3:
	STA !OAMTILE,y
	SEP #$10
	JML $01C1A6	; return


BERRY_HACK:
	REP #$30
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,x
	TAY
	LDA #$0000
	SEP #$20
	LDA #$80
	STA !OAMTILE,Y
	LDA $18D6
	TAX
	LDA $C345,X
	ORA $64
	STA !OAMPROP,Y
	PLX
	JML $01C370	; return


BROWNPLAT_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0010	; set up chain tiles first. 5 tiles here, 4 for platform itself later
	TAY
	LDA #$0000
	SEP #$20
	LDA $14BA
	SEC
	SBC $1C
	SEC
	SBC #$08
	STA !OAMY,Y
	LDA $14B8
	SEC
	SBC $1A
	SEC
	SBC #$08
	STA !OAMX,Y
	LDA #$A2
	STA !OAMTILE,Y
	STA !OAMTILE+$4,Y
	STA !OAMTILE+$8,Y
	STA !OAMTILE+$C,Y
	STA !OAMTILE+$10,Y
	LDA #$31
	STA !OAMPROP,Y
	STA !OAMPROP+$4,Y
	STA !OAMPROP+$8,Y
	STA !OAMPROP+$C,Y
	STA !OAMPROP+$10,Y
	PHY
	SEP #$10
	LDY #$00
	LDA $14BA
	SEC
	SBC $14B2
	BPL CODE_01C802
	EOR #$FF
	INC A
	INY
CODE_01C802:
	STY $00
	STA $4205
	STZ $4204
	LDA #$05
	STA $4206
	JSR WASTE_TIME	; waste 16 cycles while waiting for division
	LDA $4214
	STA $02
	STA $06
	LDA $4215
	STA $03
	STA $07
	LDY #$00
	LDA $14B8
	SEC
	SBC $14B0
	BPL CODE_01C82F
	EOR #$FF
	INC A
	INY
CODE_01C82F:
	STY $01
	STA $4205
	STZ $4204
	LDA #$05
	STA $4206
	JSR WASTE_TIME
	LDA $4214
	STA $04
	STA $08
	LDA $4215
	STA $05
	STA $09
	REP #$10
	PLY
	INY
	INY
	INY
	INY
	LDA $14B2
	SEC
	SBC $1C
	SEC
	SBC #$08
	STA $0A
	LDA $14B0
	SEC
	SBC $1A
	SEC
	SBC #$08
	STA $0B
	LDX #$0003
	BRA BROWNPLAT_1
CODE_01C87C:
	INY
	INY
	INY
	INY
BROWNPLAT_1:
	LDA $00
	BNE CODE_01C88E
	LDA $0A
	CLC
	ADC $07
	BRA CODE_01C896
CODE_01C88E:
	LDA $0A
	SEC
	SBC $07
CODE_01C896:
	STA !OAMY,Y
	LDA $06
	CLC
	ADC $02
	STA $06
	LDA $07
	ADC $03
	STA $07
	LDA $01
	BNE CODE_01C8B1
	LDA $0B
	CLC
	ADC $09
	BRA CODE_01C8B9
CODE_01C8B1:
	LDA $0B
	SEC
	SBC $09
CODE_01C8B9:
	STA !OAMX,Y
	LDA $08
	CLC
	ADC $04
	STA $08
	LDA $09
	ADC $05
	STA $09
	DEX
	BPL CODE_01C87C
	REP #$20
	LDA !SPRITEINDEX
	SEC
	SBC #$0020		; last 4 tiles
	TAY
	LDA #$0000
	SEP #$20
	LDA $14BA
	SEC
	SBC $1C
	SEC
	SBC #$10
	STA !OAMY,Y
	STA !OAMY+$4,Y
	STA !OAMY+$8,Y
	STA !OAMY+$C,Y
	LDA #$31
	STA !OAMPROP,Y
	STA !OAMPROP+$4,Y
	STA !OAMPROP+$8,Y
	STA !OAMPROP+$C,Y
	LDX #$0003
	BRA BROWNPLAT_0
CODE_01C8D5:
	INY
	INY
	INY
	INY	
BROWNPLAT_0:
	LDA $14B8
	SEC
	SBC $1A
	CLC
	ADC $C9B7,X
	STA !OAMX,Y
	LDA $C9BB,X
	STA !OAMTILE,Y
	DEX
	BPL CODE_01C8D5
	REP #$20
	LDA !SPRITEINDEX
	SEC
	SBC #$0010
	TAY
	LDA #$0000
	SEP #$20
	LDA $15E9
	TAX
	LDA $E4,X
	PHA
	LDA $14E0,X
	PHA
	LDA $D8,X
	PHA
	LDA $14D4,X
	PHA
	LDA $14B0
	STA $E4,X
	LDA $14B1
	STA $14E0,X
	LDA $14B2
	STA $D8,X
	LDA $14B3
	STA $14D4,X
	LDA $14B2
	SEC
	SBC #$08
	STA $00
	LDA $14B3
	SBC #$00
	STA $01
	LDA $14B0
	SEC
	SBC #$08
	STA $02
	LDA $14B1
	SBC #$00
	STA $03
	LDA $14B2
	SEC
	SBC $1C
	SEC
	SBC #$08
	STA $06
	LDA $14B0
	SEC
	SBC $1A
	SEC
	SBC #$08
	STA $07
	LDX #$0000
	LDA !OAMX,Y
	SEC
	SBC $07
	BPL CODE_01C948
	DEX
CODE_01C948:
	CLC
	ADC $02
	STA $14B8
	TXA
	ADC $03
	STA $14B9
	LDX #$0000
	LDA !OAMY,Y
	SEC
	SBC $06
	BPL CODE_01C96B
	DEX
CODE_01C96B:
	CLC
	ADC $00
	STA $14BA
	TXA
	ADC $01
	STA $14BB
	SEP #$10
	LDX $15E9
	LDY #$02
	LDA #$08
	JSR FinishOAMWriteRt
	PLA
	STA $14D4,X
	PLA
	STA $D8,X
	PLA
	STA $14E0,X
	PLA
	STA $E4,X
	JML $01C9AC		; return


WASTE_TIME:
	NOP
	NOP
	RTS


GRINDER_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C		; 4 tiles
	TAY
	LDA #$0000
	SEP #$20
CODE_01DBA8:
	LDA $00
	CLC
	ADC $DB96,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $DB9A,X
	STA !OAMY,Y
	LDA $14
	AND #$02
	ORA #$6C
	STA !OAMTILE,Y
	LDA $DB9E,X
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_01DBA8
	SEP #$10
	JML $01DBD0	; return


LINEGRINDER_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C		; 4 tiles
	TAY
	LDA #$0000
	SEP #$20
CODE_01DBA8_LINE:
	LDA $00
	CLC
	ADC $DC3B,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $DC3F,X
	STA !OAMY,Y
	LDA $14
	AND #$02
	ORA #$6C
	STA !OAMTILE,Y
	LDA $DC43,X
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_01DBA8_LINE
	SEP #$10
	JML $01DBD0	; return


FUZZBALL_HACK:
	REP #$30
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,X
	TAY
	LDA #$0000
	SEP #$20
	PLX
	LDA !OAMX,Y
	SEC
	SBC #$08
	STA !OAMX,Y
	LDA !OAMY,Y
	SEC
	SBC #$08
	STA !OAMY,Y
	PHX
	LDA $14
	LSR
	LSR
	AND #$01
	TAX
	LDA #$C8
	STA !OAMTILE,Y
	LDA $DC09,X
	ORA $64
	STA !OAMPROP,y
	PLX
	SEP #$10
	LDA #$00
	JML $01DC04	; RETURN

LINEROPE_HACK:
	REP #$30
	AND #$00FF
	DEC A
	ASL
	ASL
	STA $04
	LDA !SPRITEINDEX; 6-10 tiles
	SEC
	SBC $04
	TAY
	LDA #$0000
	TAX
	SEP #$20
CODE_01DC85:
	LDA $00
	STA !OAMX,Y
	LDA $01
	STA !OAMY,Y
	CLC
	ADC #$10
	STA $01
	LDA $DC4B,X
	CPX #$0000
	BNE CODE_01DCA2
	PHX
	LDA $02
	TAX
	LDA $DC47,X
	PLX
CODE_01DCA2:
	STA !OAMTILE,Y
	LDA #$37
	CPX #$0001
	BCC CODE_01DCAD
	LDA #$31
CODE_01DCAD:
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	INX
	TXA
	CMP $03
	BNE CODE_01DC85
	LDA #$DE
	STA !OAMTILE-$4,Y
	SEP #$10
	JML $01DCBE		; return

KEYHOLE_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004		; TWO TILES
	TAY
	SEP #$20
	LDA $00
	STA !OAMX,Y
	STA !OAMX+$4,Y
	LDA $01
	STA !OAMY,Y
	CLC
	ADC #$08
	STA !OAMY+$4,Y
	LDA #$EB
	STA !OAMTILE,Y
	LDA #$FB
	STA !OAMTILE+$4,Y
	LDA #$30
	STA !OAMPROP,Y
	STA !OAMPROP+$4,Y
	SEP #$10
	JML $01E262		; return


DRYSPRITES_HACK:
	PHA
	REP #$30
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,x
	SEC
	SBC #$0004
	TAY
	PLX
	LDA #$0000
	SEP #$20
	PLA
	STA !OAMTILE,Y
	DEC A
	STA !OAMTILE+$4,Y
	PHX
	LDA $157C,X
	TAX
	LDA !OAMX+$4,Y
	STA !OAMX,Y
	CLC
	ADC $E43C,X
	STA !OAMX+$4,Y
	PLX
	LDA !OAMY+$4,Y
	STA !OAMY,Y
	LDA !OAMPROP+$4,Y
	STA !OAMPROP,Y
	LDA $1540,X
	BEQ CODE_01E4AC
	CMP #$40
	BCS CODE_01E4AC
	LSR
	LSR
	PHP
	LDA !OAMX,Y
	ADC #$00
	STA !OAMX,Y
	PLP
	LDA !OAMX+$4,Y
	ADC #$00
	STA !OAMX+$4,Y
CODE_01E4AC:
	SEP #$10
	JML $01E4AC		; return

SMUSHED_HACK2:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004		; TWO TILES
	TAY
	SEC
	SBC #$0004		; update this
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20
	LDA $00
	STA !OAMX,Y
	CLC
	ADC #$08
	STA !OAMX+$4,Y
	LDA $01
	CLC
	ADC #$08
	STA !OAMY,Y
	STA !OAMY+$4,Y
	PHX
	LDA $9E,X
	TAX
	LDA #$FE
	CPX #$003E
	BEQ CODE_01E73A
	LDA #$EE
	CPX #$00BD
	BEQ CODE_01E73A
	CPX #$0004
	BCC CODE_01E73A
	LDA #$C7
	CPX #$000F
	BCS CODE_01E73A
	LDA #$4D
CODE_01E73A:
	STA !OAMTILE,Y
	STA !OAMTILE+$4,Y
	PLX
	LDA $64
	ORA $15F6,X
	STA !OAMPROP,Y
	ORA #$40
	STA !OAMPROP+$4,Y
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$00
	STA !OAMEXTENDED,Y
	STA !OAMEXTENDED+$1,Y
	SEP #$10
	JML $01E75A		; return


LAKITUCLOUD_HACK:
	LDA $15A0,X
	BNE LAKITUCLOUD_0
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0004
	STA !HIGHINDEX
	SEP #$20
	LDA $14B0
	CLC
	ADC #$04
	STA !HIGHOAMX,X
	LDA $14B2
	CLC
	ADC #$07
	STA !HIGHOAMY,X
	LDA #$4D
	STA !HIGHOAMTILE,X
	LDA #$39
	STA !HIGHOAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !HIGHOAMEXTENDED,X
LAKITUCLOUD_0:
	REP #$30
	LDA !HIGHINDEX
	TAX
	LDA #$0000
	SEP #$20
	LDA #$01
	STA $03
CODE_01E901:
	LDA $03
	CLC
	ADC $02
	TAY
	LDA $E771,Y
	CLC
	ADC $14B0
	STA !HIGHOAMX,X
	LDA $E781,Y
	CLC
	ADC $14B2
	STA !HIGHOAMY,X
	LDA $15E9
	TAY
	LDA #$60
	STA !HIGHOAMTILE,X
	LDA $1540,Y
	BEQ CODE_01E935
	LSR
	LSR
	LSR
	TAY
	LDA $E985,Y
	STA !HIGHOAMTILE,X
CODE_01E935:
	LDA $64
	STA !HIGHOAMPROP,X
	INX
	INX
	INX
	INX
	DEC $03
	BPL CODE_01E901
	REP #$20
	LDA $00
	PHA
	LDA $02
	PHA		; preserve these
	SEP #$30
	LDA $15E9
	TAY
	LDX #$02
	LDA #$01
	JSR FinishOAMWriteRt_HIGH
	REP #$10
	LDY #$01FC
CLOUDLOOP:
	LDA !OAMTILE,Y
	CMP #$EE
	BNE CLOUDLOOP_0
	LDA !OAMPROP,Y
	AND #$01
	BEQ CLOUDLOOP_0
	REP #$20
	LDA $01,S
	STA $02
	LDA $03,S
	STA $00
	SEP #$20
	LDA #$01
	PHY
	PHA
	JSR LAKITUCLOUD_SWITCH
	PLA
	PLY
	DEY
	DEY
	DEY
	DEY
	LDA !OAMTILE,Y
	CMP #$A8
	BEQ CLOUDLOOP_1
	CMP #$EC
	BEQ CLOUDLOOP_1
	CMP #$CE
	BNE CLOUDLOOP_2
CLOUDLOOP_1:
	LDA !OAMPROP,Y
	AND #$01
	BEQ CLOUDLOOP_2
	LDA #$00
	PHA
	JSR LAKITUCLOUD_SWITCH
	PLA
	REP #$20
	PLA
	PLA
	SEP #$30
	JMP LAKITUCLOUD_RETURN
CLOUDLOOP_2:
	JMP LAKITUCLOUD_TILE2
CLOUDLOOP_0:
	DEY
	DEY
	DEY
	DEY
	REP #$20
	TYA
	CMP.l !SPRITEINDEX
	SEP #$20
	BEQ CLOUDLOOP_3
	BCS CLOUDLOOP
CLOUDLOOP_3:
	REP #$20
	LDA !SPRITEINDEX
	SEC
	SBC #$0004		; TWO TILES
	TAY
	PLA
	STA $02
	PLA
	STA $00			; restore these
	LDA #$0000
	SEP #$20
	LDA #$01
	STA $03
CODE_01E901_2:
	LDA $03
	CLC
	ADC $02
	TAX
	LDA $E76F,X
	CLC
	ADC $14B0
	STA !OAMX,Y
	LDA $E77F,X
	CLC
	ADC $14B2
	STA !OAMY,Y
	LDA $15E9
	TAX
	LDA #$60
	STA !OAMTILE,Y
	LDA $1540,X
	BEQ CODE_01E935_2
	LSR
	LSR
	LSR
	TAX
	LDA $E985,X
	STA !OAMTILE,Y
CODE_01E935_2:
	LDA $64
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEC $03
	BPL CODE_01E901_2
	SEP #$10
	LDX $15E9
	LDY #$02
	LDA #$01
	JSR FinishOAMWriteRt
LAKITUCLOUD_RETURN:
	JML $01E984		; return


LAKITUCLOUD_SWITCH:
	REP #$20
	LDA !SPRITEINDEX
	TAX
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	SEP #$20
	LDA !OAMTILE,Y
	STA !OAMTILE,X
	LDA !OAMX,Y
	STA !OAMX,X
	LDA !OAMY,Y
	STA !OAMY,X
	LDA !OAMPROP,Y
	STA !OAMPROP,X
	REP #$20
	PHY
	TYA
	LSR
	LSR
	TAY
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA !OAMEXTENDED,Y
	STA !OAMEXTENDED,X
	PLY
	LDA $03,s
	CLC
	ADC $02
	TAX
	LDA $E76F,X
	CLC
	ADC $14B0
	STA !OAMX,Y
	LDA $E77F,X
	CLC
	ADC $14B2
	STA !OAMY,Y
	LDA $15E9
	TAX
	LDA #$60
	STA !OAMTILE,Y
	LDA $1540,X
	BEQ CODE_01E935_3
	LSR
	LSR
	LSR
	TAX
	LDA $E985,X
	STA !OAMTILE,Y
CODE_01E935_3:
	LDA $64
	STA !OAMPROP,Y
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA $15E9
	TAX
	LDA #$02
	ORA $15A0,X
	STA !OAMEXTENDED,Y
	RTS

LAKITUCLOUD_TILE2:
	REP #$30
	LDA !SPRITEINDEX
	TAY
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20
	LDA #$00
	CLC
	ADC $02
	TAX
	LDA $E76F,X
	CLC
	ADC $14B0
	STA !OAMX,Y
	LDA $E77F,X
	CLC
	ADC $14B2
	STA !OAMY,Y
	LDA $15E9
	TAX
	LDA #$60
	STA !OAMTILE,Y
	LDA $1540,X
	BEQ CODE_01E935_4
	LSR
	LSR
	LSR
	TAX
	LDA $E985,X
	STA !OAMTILE,Y
CODE_01E935_4:
	LDA $64
	STA !OAMPROP,Y
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA $15E9
	TAX
	LDA #$02
	ORA $15A0,X
	STA !OAMEXTENDED,Y
	REP #$20
	PLA
	PLA
	SEP #$30
	JMP LAKITUCLOUD_RETURN


YOSHI_HACK:
	REP #$20
	LDA !YOSHIINDEX
	CLC
	ADC #$0004
	STA !YOSHIINDEX
	SEP #$30
	LDA #$F0
	STA !YOSHIOAMY
	LDA #$00
	STA !YOSHIOAMEXTENDED 
	JSR YOSHI_SUB
	LDA $185E
	TAY
	LDA !YOSHIOAMY+$4
	CMP #$F0
	BEQ YOSHI_HACK_2
	CLC
	ADC $EE54,Y
	STA !YOSHIOAMY+$4
YOSHI_HACK_2:
	LDA $15E9
	TAY
	PLA
	PLA
	STA $14E0,Y
	PLA
	STA $00E4,Y
	LDA $185E
	TAX
	LDA $EE06,X
	STA $1602,y
	LDA $00D8,Y
	CLC
	ADC #$10
	STA $00D8,Y
	BCC CODE_01EFA3
	LDA $14D4,Y
	INC A
	STA $14D4,Y
CODE_01EFA3:
	TYX
	SEP #$10
	JSR YOSHI_SUB
	LDA $15E9
	TAY
	PLA
	STA $14D4,Y
	PLA
	STA $00D8,Y
	LDA $00C2,Y
	BNE CODE_01EFC6
	LDA $14
	AND #$30
	BNE CODE_01EFDB
	LDA #$2A
	BRA CODE_01EFFA
CODE_01EFC6:
	CMP #$02
	BNE CODE_01EFDB
	LDA $151C,Y
	ORA $13C6
	BNE CODE_01EFDB
	LDA $14
	AND #$10
	BEQ CODE_01EFFD
	BRA CODE_01EFF8
YOSHI_RETURN2:
	SEP #$10
	LDX $15E9
	JML $01F0A0
CODE_01EFDB:
	LDA $1594,Y
	CMP #$03
	BEQ CODE_01EFEE
	LDA $151C,Y
	BEQ CODE_01EFF3
	LDA !YOSHIOAMTILE+$4
	CMP #$24
	BEQ CODE_01EFF3
CODE_01EFEE:
	LDA #$2A
	STA !YOSHIOAMTILE+$4
CODE_01EFF3:
	LDA $18AE
	BEQ CODE_01EFFD
CODE_01EFF8:
	LDA #$0C
CODE_01EFFA:
	STA !YOSHIOAMTILE+$4
CODE_01EFFD:
	LDA $18AC
	BEQ CODE_01F00F
	CMP #$26
	TAY
	BCS CODE_01F038
	LDA $14
	AND #$18
	BNE CODE_01F038
CODE_01F00F:
	LDA $1564,Y
	CMP #$00
	BEQ YOSHI_RETURN2
	LDX #$0000
	CMP #$1C
	BCC CODE_01F038
	BNE YOSHI_HACK2
	SEP #$10
	TYX
	JML $01F025	; go do some stuff
YOSHI_HACK2:
	REP #$30
	LDA !YOSHIINDEX
	TAX
	LDA #$0000
	SEP #$20
	INC $13FB
	LDA #$00
	LDY #$002A
	BRA CODE_01F03A
CODE_01F038:
	LDY #$0004
CODE_01F03A:
	PHA
	TYA
	STA !YOSHIOAMTILE+$4
	PLA
	CMP #$0F
	BCS YOSHI_RETURN
	CMP #$05	
	BCC YOSHI_RETURN
	SBC #$05
	PHA
	LDA $15E9
	TAY
	LDA $157C,Y
	TAY
	PLA
	CPY #$0000
	BEQ CODE_01F054
	CLC
	ADC #$0A
CODE_01F054:
	PHA
	LDA $15E9
	TAY
	LDA $1602,Y
	TAY
	PLA
	CPY #$000A
	BNE CODE_01F05E
	CLC
	ADC #$14
CODE_01F05E:
	STA $02
	LDA $15E9
	TAY
	LDA $15A0,Y
	ORA $186C,Y
	BNE YOSHI_RETURN
	LDA $00E4,Y
	SEC
	SBC $1A
	STA $00
	LDA $00D8,Y
	SEC
	SBC $1C
	STA $01
	PHB
	LDA #$03
	PHA
	PLB
	PHY
	LDA $02
	TAY
	LDA $00
	CLC
	ADC $C176,Y
	STA !YOSHIOAMX
	LDA $01
	CLC
	ADC $C19E,Y
	STA !YOSHIOAMY
	LDA #$3F
	STA !YOSHIOAMTILE
	LDA !YOSHIOAMPROP+$4
	ORA #$01
	STA !YOSHIOAMPROP
	PLY
	PLB
YOSHI_RETURN:
	SEP #$10
	LDX $15E9
	JML $01F0A0	; return

YOSHI_HACK3:
	LDA !YOSHIOAMTILE+$4
	BPL YOSHI_HACK3_0
	LDA #$F0
	STA !YOSHIOAMY+$4
YOSHI_HACK3_0:
	STA $00
	STZ $01
	LDA #$06
	STA !YOSHIOAMTILE+$4
	LDA !YOSHIOAMTILE+$8
	BPL YOSHI_HACK3_1
	LDA #$F0
	STA !YOSHIOAMY+$8
YOSHI_HACK3_1:
	STA $02
	STZ $03
	LDA #$08
	STA !YOSHIOAMTILE+$8
	JSR YOSHI_HEADCHECK
	JML $01EEAA
	
YOSHI_SUB:
	STZ $04
	PHK
	PER $0006
	PEA $9D65
	JML $01A365		; get draw info
	LDA $157C,X
	STA $02
	TXY
	REP #$30
	LDA !YOSHIINDEX
	TAX
	CLC
	ADC #$0004
	STA !YOSHIINDEX		; 1 tile
	LDA #$0000
	SEP #$20
	LDA $1602,Y
	PHA
	LDA $009E,Y
	TAY
	PLA
	CLC
	ADC $9C7F,Y
	TAY
	LDA $9B83,Y
	STA !YOSHIOAMTILE,X
	LDA $00
	STA !YOSHIOAMX,X
	LDA $01
	STA !YOSHIOAMY,X
	LDA $15E9
	TAY
	LDA $157C,Y
	LSR
	LDA #$00
	ORA $15F6,Y
	BCS CODE_019F44_YOSHI
	EOR #$40
CODE_019F44_YOSHI:
	ORA $04
	ORA $64
	STA !YOSHIOAMPROP,X
	PHX
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA $15A0,Y
	ORA #$02
	STA !YOSHIOAMEXTENDED,X
	PLX
	LDA $186C,Y
	BEQ YOSHI_HACK_0
	LDA #$F0
	STA !YOSHIOAMY,X
YOSHI_HACK_0:
	RTS

YOSHI_HEADCHECK: 
	LDY $15E9
	LDA $15AC,Y
	ORA $1419
	BEQ YOSHI_HEADCHECK_RETURN
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0008
	STA !HIGHINDEX
	LDA !YOSHIOAMX+$4
	STA !HIGHOAMX,X
	LDA !YOSHIOAMTILE+$4
	STA !HIGHOAMTILE,X
	LDA !YOSHIOAMX+$8
	STA !HIGHOAMX+$4,X
	LDA !YOSHIOAMTILE+$8
	STA !HIGHOAMTILE+$4,X
	TXA
	LSR
	LSR
	TAX
	LDA !YOSHIOAMEXTENDED+$1
	STA !HIGHOAMEXTENDED,X
	LDA #$0000
	STA !YOSHIINDEX		
	SEP #$30
	LDX $15E9
YOSHI_HEADCHECK_RETURN:
	RTS


YOSHIWINGS_HACK:
	REP #$30
	TXY
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0004
	STA !HIGHINDEX
	SEP #$20
	LDA $00
	SEC
	SBC $1A
	STA !HIGHOAMX,X
	PLA
	SBC $1B
	BNE CODE_02BB86
	PHB
	LDA #$02
	PHA
	PLB
	LDA $01
	SEC
	SBC $1C
	CLC
	ADC $BB13,Y
	STA !HIGHOAMY,X
	LDA $BB17,Y
	STA !HIGHOAMTILE,X
	LDA $64
	ORA $BB1B,Y
	STA !HIGHOAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA $BB1F,Y
	STA !HIGHOAMEXTENDED,X
	PLB
	SEP #$10
	JML $02BB86		;RETURN

CODE_02BB86:
	REP #$20
	LDA !HIGHINDEX
	SEC
	SBC #$0004
	STA !HIGHINDEX
	SEP #$30
	JML $02BB86		; RETURN

YOSHITONGUE_RETURN:
	REP #$20
	LDA !HIGHINDEX
	SEC
	SBC #$0004
	STA !HIGHINDEX
	SEP #$30
	LDX $15E9
	JML $01F4B1


YOSHITONGUE_HACK:
	TXY
CODE_01F46A:
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0004		
	STA !HIGHINDEX
	SEP #$20
	LDA $00
	STA !HIGHOAMX,X
	CLC
	ADC $05
	STA $00
	LDA $05
	BPL CODE_01F47C
	BCC YOSHITONGUE_RETURN
	BRA CODE_01F47E
CODE_01F47C:
	BCS YOSHITONGUE_RETURN
CODE_01F47E:
	LDA $01
	STA !HIGHOAMY,X
	LDA $06
	CMP #$01
	LDA #$76
	BCS CODE_01F48D
	LDA #$66
CODE_01F48D:
	STA !HIGHOAMTILE,X
	LDA $07
	LSR
	LDA #$09
	BCS CODE_01F499
	ORA #$40
CODE_01F499:
	ORA $64
	STA !HIGHOAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !HIGHOAMEXTENDED,X
	DEC $06
	BPL CODE_01F46A
	SEP #$10
	LDX $15E9
	JML $01F4B1	; RETURN


YOSHIEGG_HACK:
	REP #$30
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	SEP #$20
	LDA #$00
	STA !OAMTILE,Y
	SEP #$10
	JML $01F798		; return

YOSHIEGG_HACK2:
	REP #$30
	PHX
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	SEP #$20
	PLA
	STA $00
	LDA !OAMPROP,Y
	AND #$FE
	ORA $00
	STA !OAMPROP,Y
	PLA
	STA !OAMTILE,Y
	SEP #$10
	JML $01F7C1		; return

YOSHISHATTER_HACK:
	PHA
	TXY
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0004
	STA !HIGHINDEX
	LDA #$0000
	SEP #$20
	PLA
	STA !HIGHOAMY,X
	LDA $1808,Y
	SEC
	SBC $1A
	CMP #$F8
	BCS CODE_028ED7
	STA !HIGHOAMX,X
	LDA #$6F
	STA !HIGHOAMTILE,X
	LDA $1850,Y
	AND #$C0
	ORA #$03
	ORA $64
	STA !HIGHOAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !HIGHOAMEXTENDED,X
	SEP #$10
	TYX
	JML $028ECB
CODE_028ED7:
	REP #$20
	LDA !HIGHINDEX
	SEC
	SBC #$0004
	STA !HIGHINDEX
	SEP #$30
	TYX
	JML $028F87		; return

BOOBLOCK_HACK:
	PHX
	PHA
	REP #$30
	TXA
	ASL A
	TAX
	LDA !SPRITEOAM,X
	TAY
	LDA #$0000
	SEP #$20
	PLA
	TAX
	LDA $FA37,X
	STA !OAMTILE,Y
	LDA !OAMPROP,Y
	AND #$F1
	ORA $FA3A,X
	STA !OAMPROP,Y
	SEP #$10
	JML $01FA35		; return

BOMBSPLODE_HACK:
	REP #$30
	LDA !HIGHINDEX
	TAX
	LDA #$0000
	SEP #$20
CODE_0280C4:
	LDA $15E9
	TAY
	LDA $1540,Y
	LSR
	PHA
	AND #$03
	STA $02
	LDA $00E4,Y
	SEC
	SBC $1A
	CLC
	ADC #$04
	STA $00
	LDA $00D8,Y
	SEC
	SBC $1C
	CLC
	ADC #$04
	STA $01
	LDA $0F
	TAY
	PLA
	AND #$04
	BEQ CODE_0280ED
	TYA
	CLC
	ADC #$05
	TAY
CODE_0280ED:
	LDA $00
	CLC
	ADC $8072,Y
	STA $00
	LDA $01
	CLC
	ADC $807C,Y
	STA $01
	DEC $02
	BPL CODE_0280ED
	LDA $00
	STA !HIGHOAMX,X
	LDA $01
	STA !HIGHOAMY,X
	LDA #$BC
	STA !HIGHOAMTILE,X
	LDA $14
	LSR
	LSR
	AND #$03
	SEC
	ROL
	ORA $64
	STA !HIGHOAMPROP,X
	PHX
	REP #$20
	TXA
	LSR
	LSR
	TAX
	LDA #$0000
	SEP #$20
	LDA #$00
	STA !HIGHOAMEXTENDED,X
	PLX
	INX
	INX
	INX
	INX
	DEC $0F
	BPL CODE_0280C4
	SEP #$10
	LDY $15E9
	LDX #$00
	LDA #$04
	JSR FinishOAMWriteRt_HIGH
	JML $02814F		; return

LAKITUFISH_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$001C		; 8 TILES
	TAY
	LDA #$0000
	SEP #$20
	LDA $00
	SEC
	SBC #$15
	STA $185E
	LDA $01
	CLC
	ADC #$02
	STA $18B6
	PHX
	LDX #$0007
CODE_02E6F4:
	LDA $185E
	STA !OAMX,Y
	LDA $18B6
	STA !OAMY,Y
	CLC
	ADC #$08
	STA $18B6
	LDA #$89
	STA !OAMTILE,Y
	LDA #$35
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_02E6F4
	PLX
	SEP #$10
	LDA $00
	PHA
	LDA $01
	PHA
	LDA #$07
	LDY #$00
	JSR FinishOAMWriteRt
	PLA
	STA $01
	PLA
	STA $00
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004
	TAY
	LDA #$0000
	SEP #$20
	LDA $00
	SEC
	SBC #$0D
	STA !OAMX,Y
	SEC
	SBC #$08
	STA !OAMX+$4,Y
	LDA $01
	CLC
	ADC #$02
	STA !OAMY,Y
	CLC
	ADC #$40
	STA !OAMY+$4,Y
	LDA #$AA
	STA !OAMTILE,Y
	LDA #$24
	STA !OAMTILE+$4,Y
	LDA #$35
	STA !OAMPROP,Y
	LDA #$3A
	STA !OAMPROP+$4,Y
	SEP #$10
	LDY #$02
	LDA #$01
	JSR FinishOAMWriteRt
	LDA $15A0,X
	BNE LAKITUFISH_RETURN
	REP #$30
	LDA !SPRITEINDEX
	TAY
	LDA #$0000
	SEP #$20
	LDA $7E
	SEC
	SBC !OAMX+$8,Y
	CLC
	ADC #$0C
	CMP #$18
	BCS LAKITUFISH_RETURN
	LDA $80
	SEC
	SBC !OAMY+$8,Y
	CLC
	ADC #$0C
	CMP #$18
	BCS LAKITUFISH_RETURN
	STZ $151C,X
	SEP #$10
	JSL $00F388		; give 1up
LAKITUFISH_RETURN:
	SEP #$10
	JML $02E7FB		; REturn


UNKNOWNEX_HACK:		; unknown extended sprite
	TXY
	REP #$30
	LDA !SUPERINDEX
	TAX
	CLC
	ADC #$0004
	STA !SUPERINDEX
	LDA #$0000
	SEP #$20
	LDA $00
	STA !SUPEROAMX,X
	LDA $01
	STA !SUPEROAMY,X
	PHY
	LDA $1850,Y
	LSR
	LSR
	TAY
	LDA $8C6A,Y
	STA !SUPEROAMTILE,X
	PLY
	LDA $64
	ORA #$08
	STA !SUPEROAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	LDA #$00
	STA !SUPEROAMEXTENDED,X
	SEP #$10
	TYX
	JML $028CB7		; return

BOOSTREAM_HACK:
	TXY
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0004
	STA !HIGHINDEX
	LDA #$0000
	SEP #$20
	LDA $00
	STA !HIGHOAMX,X
	LDA $17FC,Y
	SEC
	SBC $1C
	CMP #$F0
	BCS CODE_028D62
	STA !HIGHOAMY,X
	LDA $8CB8,Y
	STA !HIGHOAMTILE,X
	LDA $182C,Y
	LSR
	AND #$40
	EOR #$40
	ORA $64
	ORA #$0F
	STA !HIGHOAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$02
	STA !HIGHOAMEXTENDED,X
	SEP #$10
	TYX
	JML $028D41		; return
CODE_028D62:
	REP #$20
	LDA !HIGHINDEX
	SEC
	SBC #$0004
	STA !HIGHINDEX
	SEP #$30
	TYX
	JML $028D41


BOOSTREAM_HACK2:
	REP #$30
	TXY
	LDA $01,S
	AND #$00FF
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAX
	SEP #$20
	LDA $8F6D,Y
	STA !OAMTILE,X
	SEP #$10
	JML $038FA3	; return


WATERSPLASH_HACK:
	PHA
	TXY
	REP #$30
	LDA !SUPERINDEX
	TAX
	CLC
	ADC #$0004
	STA !SUPERINDEX
	LDA #$0000
	SEP #$20
	PLA
	STA !SUPEROAMX,X
	LDA $17FC,Y
	SEC
	SBC $1C
	CMP #$E8
	BCS CODE_028D62_2
	STA !SUPEROAMY,X
	PHY
	LDA $1850,Y
	LSR
	TAY
	CPY #$000C
	BCC CODE_028DB6
	LDY #$000C
CODE_028DB6:
	LDA $8D42,Y
	STA !SUPEROAMTILE,X
	PLY
	LDA $64
	ORA #$02
	STA !SUPEROAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$02
	STA !SUPEROAMEXTENDED,X
	SEP #$10
	TYX
	JML $028DCF		; return
CODE_028D62_2:
	REP #$20
	LDA !SUPERINDEX
	SEC
	SBC #$0004
	STA !SUPERINDEX
	SEP #$30
	TYX
	JML $028D62		; return


ZZZ_HACK:
	PHA
	TXY
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0004
	STA !HIGHINDEX
	LDA #$0000
	SEP #$20
	PLA
	STA !HIGHOAMX,X
	LDA $17FC,Y
	SEC
	SBC $1C
	CMP #$F0
	BCS CODE_028E76
	STA !HIGHOAMY,X
	LDA $64
	ORA #$03
	STA !HIGHOAMPROP,X
	LDA $1850,Y
	CMP #$14
	BEQ CODE_028E76
	LDA $17F0,Y
	CMP #$08
	LDA #$7F
	BCS CODE_028E66
	PHY
	LDA $1850,Y
	LSR
	LSR
	LSR
	LSR
	LSR
	AND #$03
	TAY
	LDA $8DD7,Y
	PLY
CODE_028E66:
	STA !HIGHOAMTILE,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !HIGHOAMEXTENDED,X
	SEP #$10
	JML $028E72		; return
CODE_028E76:
	REP #$20
	LDA !HIGHINDEX
	SEC
	SBC #$0004
	STA !HIGHINDEX
	SEP #$20
	LDA #$F0
	STA !HIGHOAMY,X
	SEP #$10
	TYX
	JML $028E76		; return
	

STARSPARKLE_HACK:
	PHA
	TXY
	REP #$30
	LDA !SUPERINDEX
	TAX
	CLC
	ADC #$0004
	STA !SUPERINDEX
	LDA #$0000
	SEP #$20
	PLA
	STA !SUPEROAMX,X
	LDA $17FC,Y
	SEC
	SBC $1C
	CMP #$F0
	BCS CODE_028ED7_2
	STA !SUPEROAMY,X
	LDA $17F0,Y
	PHY
	PHA
	LDA $1850,Y
	LSR
	LSR
	LSR
	TAY
	PLA
	CMP #$05
	BNE CODE_028F11
	INY
	INY
	INY
CODE_028F11:
	LDA $8ECC,Y
	PLY
	STA !SUPEROAMTILE,X
	LDA $64
	ORA #$06
	STA !SUPEROAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !SUPEROAMEXTENDED,X
	SEP #$10
	TYX
	JML $028F2A
CODE_028ED7_2:
	REP #$20
	LDA !SUPERINDEX
	SEC
	SBC #$0004
	STA !SUPERINDEX
	SEP #$30
	TYX
	JML $028F87

LAVASPLASH_HACK:
	PHA
	TXY
	REP #$30
	LDA !SUPERINDEX
	TAX
	CLC
	ADC #$0004
	STA !SUPERINDEX
	LDA #$0000
	SEP #$20
	PLA
	STA !SUPEROAMX,X
	LDA $17FC,Y
	CMP #$F0
	BCS CODE_028F87
	SEC
	SBC $1C
	STA !SUPEROAMY,X
	PHY
	LDA $1850,Y
	LSR
	LSR
	LSR
	TAY
	LDA $8F2B,Y
	STA !SUPEROAMTILE,X
	PLY
	LDA $64
	ORA #$05
	STA !SUPEROAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !SUPEROAMEXTENDED,X
	SEP #$10
	TYX
	JML $028F86
CODE_028F87:
	REP #$20
	LDA !SUPERINDEX
	SEC
	SBC #$0004
	STA !SUPERINDEX
	SEP #$30
	TYX
	JML $028F87


SHATTERBLOCK_HACK:
	TXY
	REP #$30
	LDA !SUPERINDEX
	TAX
	CLC
	ADC #$0004
	STA !SUPERINDEX
	LDA #$0000
	SEP #$20
	LDA $01
	STA !SUPEROAMX,X
	LDA $00
	CMP #$F0
	BCS CODE_028F87		; uses part of the lava splash code here
	STA !SUPEROAMY,X
	LDA $1850,y
	PHY
	PHA
	LDA $14
	LSR
	CLC
	ADC $1698
	AND #$07
	TAY
	LDA $8B84,Y
	STA !SUPEROAMTILE,X
	PLA
	ASL
	CMP #$10
	BCC SHATTERBLOCK_0	; little change here: only rainbow if palette is 8-FF, not just non-zero
	LDA $14
	AND #$0E
SHATTERBLOCK_0:
	EOR $8B8C,Y
	ORA $64
	STA !SUPEROAMPROP,X
	PLY
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !SUPEROAMEXTENDED,X
	SEP #$10
	TYX
	JML $02902C

CONTACT_HACK:
	PHA
	TXY
	REP #$30
	LDA !SUPERINDEX
	TAX
	CLC
	ADC #$0010		; 4 TILES
	STA !SUPERINDEX
	LDA #$0000
	SEP #$20
	PLA
	STA !SUPEROAMX,X
	STA !SUPEROAMX+$8,X
	CLC
	ADC #$08
	STA !SUPEROAMX+$4,X
	STA !SUPEROAMX+$C,X
	LDA $17C4,Y
	SEC
	SBC $1C
	STA !SUPEROAMY,X
	STA !SUPEROAMY+$4,X
	CLC
	ADC #$08
	STA !SUPEROAMY+$8,X
	STA !SUPEROAMY+$C,X
	LDA $17CC,Y
	ASL
	ASL
	ASL
	ASL
	ASL
	AND #$40
	ORA $64
	STA !SUPEROAMPROP,X
	STA !SUPEROAMPROP+$4,X
	EOR #$C0
	STA !SUPEROAMPROP+$8,X
	STA !SUPEROAMPROP+$C,X
	LDA $17CC,Y
	AND #$02
	BNE CODE_029815
	LDA #$7C
	STA !SUPEROAMTILE,X
	STA !SUPEROAMTILE+$C,X
	LDA #$7D
	STA !SUPEROAMTILE+$4,X
	STA !SUPEROAMTILE+$8,X
	BRA CODE_029825
CODE_029815:
	LDA #$7D
	STA !SUPEROAMTILE,X
	STA !SUPEROAMTILE+$C,X
	LDA #$7C
	STA !SUPEROAMTILE+$4,X
	STA !SUPEROAMTILE+$8,X
CODE_029825:
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !SUPEROAMEXTENDED,X
	STA !SUPEROAMEXTENDED+$1,X
	STA !SUPEROAMEXTENDED+$2,X
	STA !SUPEROAMEXTENDED+$3,X
	SEP #$10
	TYX
	JML $029837

BOUNCEBLOCK_HACK:
	TXY
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0004
	STA !HIGHINDEX
	LDA #$0000
	SEP #$20
	LDA $01
	STA !HIGHOAMY,X
	LDA $16A5,Y
	SEC
	SBC $03
	STA !HIGHOAMX,X
	LDA $1901,Y
	ORA $64
	STA !HIGHOAMPROP,X
	PHY
	LDA $1699,Y
	TAY
	LDA $91F0,Y
	STA !HIGHOAMTILE,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$02
	STA !HIGHOAMEXTENDED,X
	PLX
	SEP #$10
	JML $029264


SMOKEPUFF_HACK:
	PHA
	TXY
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0004
	STA !HIGHINDEX
	LDA #$0000
	SEP #$20
	PLA
	STA !HIGHOAMX,X
	LDA $17C4,Y
	SEC
	SBC $1C
	CMP #$E0
	BCS CODE_0296DF
	STA !HIGHOAMY,X
	LDA $17CC,Y
	CMP #$08
	LDA #$00
	BCS CODE_02972D
	ASL
	ASL
	ASL
	ASL
	AND #$40
CODE_02972D:
	ORA $64
	STA !HIGHOAMPROP,X
	LDA $17CC,Y
	PHY
	LSR
	LSR
	TAY
	LDA $96D8,Y
	PLY
	STA !HIGHOAMTILE,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$02
	STA !HIGHOAMEXTENDED,X
	SEP #$10
	TYX
	JML $029749
CODE_0296DF:
	REP #$20
	LDA !HIGHINDEX
	SEC
	SBC #$0004
	STA !HIGHINDEX
	SEP #$30
	TYX
	JML $0296DF


DUST_HACK:
	TXY
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0004
	STA !HIGHINDEX
	LDA #$0000
	SEP #$20
	LDA $17C8,Y
	SEC
	SBC $1A
	STA !HIGHOAMX,X
	LDA $17C4,y
	SEC
	SBC $1C
	STA !HIGHOAMY,X
	LDA $64
	STA !HIGHOAMPROP,X
	PHY
	LDA $17CC,Y
	LSR
	LSR
	TAY
	LDA $9922,Y
	PLY
	STA !HIGHOAMTILE,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !HIGHOAMEXTENDED,X
	SEP #$10
	TYX
	JML $02999E
	

COINBLOCKCOIN_HACK:
	TXY
	TXA
	CLC
	ADC $14
	LSR
	LSR
	AND #$03
	BNE COINBLOCKCOIN_0
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0004
	STA !HIGHINDEX
	LDA #$0000
	SEP #$20
	LDA $00
	STA !HIGHOAMX,X
	LDA $01
	STA !HIGHOAMY,X
	LDA #$E8
	STA !HIGHOAMTILE,X
	LDA #$04
	ORA $64
	STA !HIGHOAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$02
	STA !HIGHOAMEXTENDED,X
	SEP #$10
	TYX
	JML $029A6D
COINBLOCKCOIN_0:
	PHY
	TAY
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0008
	STA !HIGHINDEX
	LDA #$0000
	SEP #$20
	LDA $00
	CLC
	ADC #$04
	STA !HIGHOAMX,X
	STA !HIGHOAMX+$4,X
	LDA $01
	STA !HIGHOAMY,X
	CLC
	ADC #$08
	STA !HIGHOAMY+$4,X
	LDA $9A6D,Y
	STA !HIGHOAMTILE,X
	STA !HIGHOAMTILE+$4,X
	LDA #$04
	ORA $64
	STA !HIGHOAMPROP,X
	ORA #$80
	STA !HIGHOAMPROP+$4,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !HIGHOAMEXTENDED,X
	STA !HIGHOAMEXTENDED+$1,X
	SEP #$10
	PLX
	JML $029AA7	

VOLCLOTUSFIRE_HACK:
	TXY
	REP #$30
	LDA !SUPERINDEX
	TAX
	CLC
	ADC #$0004
	STA !SUPERINDEX
	LDA #$0000
	SEP #$20
	LDA $00
	STA !SUPEROAMX,X
	LDA $01
	CMP #$F0
	BCS CODE_029BA5
	STA !SUPEROAMY,X
	LDA #$09
	ORA $64
	STA !SUPEROAMPROP,X
	LDA $14
	LSR
	EOR $15E9
	LSR
	LSR
	LDA #$A6
	BCC CODE_029B99
	LDA #$B6
CODE_029B99:
	STA !SUPEROAMTILE,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !SUPEROAMEXTENDED,X
	SEP #$10
	TYX
	JML $029BA5
CODE_029BA5:
	REP #$20
	LDA !SUPERINDEX
	SEC
	SBC #$0004
	STA !SUPERINDEX
	SEP #$30
	TYX
	JML $029BA6


SMOKETRAIL_HACK:
	PHA
	LDA $170B,X	; make sure this sprite still exists
	BEQ SMOKETRAIL_HACK_0
	TXY
	REP #$30
	LDA !SUPERINDEX
	SEC
	SBC #$0004
	TAX
	LDA #$0000
	SEP #$20
	PLA
	STA !SUPEROAMPROP,X
	LDA $9C33,Y
	STA !SUPEROAMTILE,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$02
	STA !SUPEROAMEXTENDED,X
	SEP #$10
	TYX
	JML $029C66

SMOKETRAIL_HACK_0:
	PLA
	JML $029C66


SPINJUMPSTARS_HACK:
	LDA $170B,X
	BEQ SPINJUMPSTARS_HACK_0
	TXY
	REP #$30
	LDA !SUPERINDEX
	SEC
	SBC #$0004
	TAX
	LDA #$0000
	SEP #$20
	LDA #$34
	STA !SUPEROAMPROP,X
	LDA #$EF
	STA !SUPEROAMTILE,X
	SEP #$10
	TYX
SPINJUMPSTARS_HACK_0:
	JML $029C98


UNKNOWNEXSPR2:
	TXY
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0004
	STA !HIGHINDEX
	LDA #$0000
	SEP #$20
	LDA $01
	SEC
	SBC #$05
	STA !HIGHOAMY,X
	LDA $00
	STA !HIGHOAMX,X
	LDA #$98
	STA !HIGHOAMTILE,X
	LDA #$0B
	ORA $64
	STA !HIGHOAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !HIGHOAMEXTENDED,X
	SEP #$10
	TYX
	JML $029D44


CLOUDCOIN_HACK:
	TXY
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0004
	STA !HIGHINDEX
	LDA #$0000
	SEP #$20
	LDA $00
	STA !HIGHOAMX,X
	LDA $01
	STA !HIGHOAMY,X
	LDA #$C2
	STA !HIGHOAMTILE,X
	LDA #$04
	ORA $64
	STA !HIGHOAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$02
	STA !HIGHOAMEXTENDED,X
	SEP #$10
	TYX
	JML $029D59


COINCLOUD_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	PLX
	TAY
	LDA #$0000
	SEP #$20
	LDA #$60
	STA !OAMTILE,Y
	LDA $14
	ASL
	ASL
	ASL
	AND #$C0
	ORA #$30
	STA !OAMPROP,Y
	SEP #$10
	JML $02EF3E		; return

COINCLOUD_HACK2:
	REP #$30
	LDA !SPRITEINDEX
	TAY
	LDA #$0000
	SEP #$20
	LDA $00
	CLC
	ADC #$04
	STA !OAMX,Y
	LDA $01
	CLC
	ADC #$04
	STA !OAMY,Y
	LDA #$4D
	STA !OAMTILE,Y
	LDA #$39
	STA !OAMPROP,Y
	SEP #$10
	JML $02EF5F

LAUNCHERARM_HACK:
	LDA $170B,X
	BEQ LAUNCHERARM_0
	TXY
	REP #$30
	LDA !SUPERINDEX
	SEC
	SBC #$0004
	TAX
	LDA #$0000
	SEP #$20
	PLA
	CMP #$01
	LDA #$84
	BCC CODE_029E6B
	LDA #$A4
CODE_029E6B:
	STA !SUPEROAMTILE,X
	LDA #$13
	STA !SUPEROAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$02
	STA !SUPEROAMEXTENDED,X
	SEP #$10
	TYX
	JML $029E81
LAUNCHERARM_0:
	PLA
	JML $029E81

LAVASPLASH2_HACK:
	LDA $1715,X
	SEC
	SBC $1C
	CMP #$F0
	BCS CODE_029EE6
	STA $01
	TXY
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0004
	STA !HIGHINDEX
	LDA #$0000
	SEP #$20
	LDA $00
	STA !HIGHOAMX,X
	LDA $01
	STA !HIGHOAMY,X
	LDA $176F,Y
	LSR
	LSR
	LSR
	AND #$03
	PHY
	TAY
	LDA $9E82,Y
	STA !HIGHOAMTILE,X
	PLY
	LDA $64
	ORA #$05
	STA !HIGHOAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !HIGHOAMEXTENDED,X
	SEP #$10
	TYX
	JML $029EE5
CODE_029EE6:
	JML $029EE6

AIRBUBBLE_HACK:
	LDA $140B,X
	BEQ AIRBUBBLE_HACK_0
	TXY
	REP #$20
	LDA !SUPERINDEX
	SEC
	SBC #$0004
	TAX
	LDA #$0000
	SEP #$20
	LDA !SUPEROAMX,X
	CLC
	ADC $00
	STA !SUPEROAMX,X
	LDA !SUPEROAMY,X
	CLC
	ADC #$05
	STA !SUPEROAMY,X
	LDA #$1C
	STA !SUPEROAMTILE,X
	SEP #$10
	TYX
AIRBUBBLE_HACK_0:
	JML $029F60


YOSHIFIREBALL_HACK:
	LDA $170B,X
	BEQ YOSHIFIREBALL_HACK_0
	TXY
	REP #$10
	PHP
	REP #$20
	LDA !SUPERINDEX
	SEC
	SBC #$0004
	TAX
	LDA #$0000
	PLP
	LDA #$04
	BCC CODE_029F7F
	LDA #$2B
CODE_029F7F:
	STA !SUPEROAMTILE,X
	LDA $1747
	AND #$80
	EOR #$80
	LSR
	ORA #$35
	STA !SUPEROAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$02
	STA !SUPEROAMEXTENDED,X
	SEP #$10
	TYX
YOSHIFIREBALL_HACK_0:
	JML $029F98


TINYFLAME_HACK:
	LDA $170B,X
	BEQ TINYFLAME_HACK_0
	TXY
	REP #$30
	LDA !SUPERINDEX
	SEC
	SBC #$0004
	TAX
	LDA #$0000
	SEP #$20
	LDA $1765,Y
	LSR
	LSR
	AND #$01
	PHY
	TAY
	LDA $A217,Y
	STA !SUPEROAMTILE,X
	PLY
	LDA !SUPEROAMPROP,X
	AND #$3F
	ORA #$05
	STA !SUPEROAMPROP,X
	SEP #$10
	TYX
TINYFLAME_HACK_0:
	JML $02A253
	
	

BASEBALL_HACK:
	LDA $1715,X
	SEC
	SBC $1C
	STA $01
	LDA $1729,X
	SBC $1D
	BNE CODE_02A2BF
	TXY
	REP #$30
	LDA !SUPERINDEX
	TAX
	CLC
	ADC #$0004
	STA !SUPERINDEX
	LDA #$0000
	SEP #$20
	LDA $00
	STA !SUPEROAMX,X
	LDA $01
	STA !SUPEROAMY,X
	LDA #$AD
	STA !SUPEROAMTILE,X
	LDA $14
	ASL
	ASL
	ASL
	ASL
	AND #$C0
	ORA #$39
	STA !SUPEROAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !SUPEROAMEXTENDED,X
	SEP #$10
	TYX
	JML $02A2BE
CODE_02A2BF:
	JML $02A2BF

BONE_HACK:
	LDA $170B,X
	BEQ BONE_HACK_0
	TXY
	REP #$30
	LDA !SUPERINDEX
	SEC
	SBC #$0004
	TAX
	LDA #$0000
	SEP #$20
	LDA !SUPEROAMTILE,X
	CMP #$26
	LDA #$80
	BCS CODE_02A2D1
	LDA #$82
CODE_02A2D1:
	STA !SUPEROAMTILE,X
	LDA !SUPEROAMPROP,X
	AND #$F1
	ORA #$02
	STA !SUPEROAMPROP,X
	SEP #$10
	TYX
BONE_HACK_0:
	JML $02A2DE

SMOKEPUFF2_HACK:
	LDA $171F,X
	SEC
	SBC $1A
	CMP #$F8
	BCS CODE_02A3AE
	STA $00
	LDA $1715,X
	SEC
	SBC $1C
	CMP #$F0
	BCS CODE_02A3AE
	STA $01
	TXY
	REP #$30
	LDA !HIGHINDEX
	TAX
	CLC
	ADC #$0004
	STA !HIGHINDEX
	LDA #$0000
	SEP #$20
	LDA $00
	STA !HIGHOAMX,X
	LDA $01
	STA !HIGHOAMY,X
	LDA $176F,Y
	LSR
	LSR
	PHY
	TAY
	LDA $A347,Y
	STA !HIGHOAMTILE,X
	LDA $14
	LSR
	LSR
	AND #$03
	TAY
	LDA $A34B,Y
	ORA $64
	STA !HIGHOAMPROP,X
	PLY
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$02
	STA !HIGHOAMEXTENDED,X
	SEP #$10
	TYX
	JML $02A3AD
CODE_02A3AE:
	JML $02A3AE


SCORESPRITE_HACK:
	TXY
	REP #$30
	LDA !SUPERINDEX
	TAX
	CLC
	ADC #$0008
	STA !SUPERINDEX
	LDA #$0000
	SEP #$20
	LDA $16E7,Y
	SEC
	SBC $02
	STA !SUPEROAMY,X
	STA !SUPEROAMY+$4,X
	LDA $16ED,Y
	SEC
	SBC $04
	STA !SUPEROAMX,X
	CLC
	ADC #$08
	STA !SUPEROAMX+$4,X
	PHY
	LDA $16E1,Y
	TAY
	LDA $AD4C,Y
	STA !SUPEROAMTILE,X
	LDA $AD62,Y
	STA !SUPEROAMTILE+$4,X
	PLY
	LDA $16E1,Y
	CMP #$0E
	LDA #$08
	BCC CODE_02AEDF
	PHY
	TAY
	LDA $ADD4,Y
	PLY
CODE_02AEDF:
	ORA #$30
	STA !SUPEROAMPROP,X
	STA !SUPEROAMPROP+$4,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !SUPEROAMEXTENDED,X
	STA !SUPEROAMEXTENDED+$1,X
	SEP #$10
	TYX
	JML $02AEFB


POKEY_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA $C2,X
	CMP #$01
	LDA #$8A
	BCC CODE_02B692
	LDA #$E8
CODE_02B692:
	STA !OAMTILE,Y
	SEP #$10
	JML $02B695


POKEY_HACK2:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0010
	TAY
	LDA #$000
	SEP #$20
	TXA
POKEY_HACK_LOOP:
	STA $06
	LDA $14
	LSR
	LSR
	LSR
	CLC
	ADC $06
	AND #$03
	TAX
	LDA $07
	CMP #$01
	BNE CODE_02B760
	LDX #$0000
CODE_02B760:
	LDA $00
	CLC
	ADC $B65F,X
	STA !OAMX,Y
	LDA $01
	LSR $02
	BCC CODE_02B781
	LSR $04
	BCS CODE_02B77B
	PHA
	LDA $03
	STA $05
	PLA
	SEC
CODE_02B77B:
	SBC $05
	STA !OAMY,Y
CODE_02B781:
	LDA $01
	SEC
	SBC #$10
	STA $01
	LDA $02
	LSR
	LDA #$E8
	BCS CODE_02B791
	LDA #$8A
CODE_02B791:
	STA !OAMTILE,Y
	LDA #$05
	ORA $64
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	LDA $06
	DEC A
	BPL POKEY_HACK_LOOP
	SEP #$10
	JML $02B7A2

TORPEDO_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004
	TAY
	LDA #$0000
	SEP #$20
	LDA $01
	STA !OAMY,Y
	STA !OAMY+$4,Y
	PHX
	LDA $15F6,X
	ORA $64
	STA $02
	LDA $157C,X
	TAX
	LDA $00
	CLC
	ADC $B8F0,X
	STA !OAMX,Y
	LDA $00
	CLC
	ADC $B8F1,X
	STA !OAMX+$4,Y
	LDA $B8F5,X
	ORA $02
	STA !OAMPROP,Y
	STA !OAMPROP+$4,Y
	PLX
	LDA #$80
	STA !OAMTILE,Y
	LDA $1540,X
	CMP #$01
	LDA #$82
	BCS CODE_02B944
	LDA $14
	LSR
	LSR
	LDA #$A0
	BCC CODE_02B944
	LDA #$82
CODE_02B944:
	STA !OAMTILE+$4,Y
	SEP #$10
	JML $02B947


FUZZSPARKY_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA $192B
	CMP #$02
	BNE CODE_02BE79
	PHX
	LDA $14
	LSR
	LSR
	AND #$01
	TAX
	LDA #$C8
	STA !OAMTILE,Y
	LDA $BE4C,X
	ORA $64
	STA !OAMPROP,Y
	PLX
	SEP #$10
	JML $02BE78
CODE_02BE79:
	LDA #$0A
	STA !OAMTILE,Y
	LDA $14
	AND #$0C
	ASL
	ASL
	ASL
	ASL
	EOR !OAMPROP,Y
	STA !OAMPROP,Y
	SEP #$10
	JML $02BE8C

HOTHEAD_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C
	TAY
	LDA #$0000
	SEP #$20
CODE_02BEC9:
	LDA $00
	CLC
	ADC $BE8D,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $BE91,X
	STA !OAMY,Y
	PHX
	TXA
	ORA $03
	TAX
	LDA $BE95,X
	STA !OAMTILE,Y
	LDA $BE9D,X
	ORA $64
	STA !OAMPROP,Y
	PLX
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_02BEC9
	SEP #$10
	PLX
	LDA $00
	PHA
	LDA $01
	PHA
	LDY #$02
	LDA #$03
	JSR FinishOAMWriteRt
	PLA
	STA $01
	PLA
	STA $00
	PHX
	REP #$30
	LDA !SPRITEINDEX
	TAY
	LDA #$0000
	SEP #$20
	LDA #$09
	PHA
	LDA $1558,X
	BEQ CODE_02BF13
	PLA
	LDA #$19
	PHA
CODE_02BF13:
	PLA
	STA $02
	LDA $C2,X
	TAX
	LDA $00
	CLC
	ADC $BEA5,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $BEAD,X
	STA !OAMY,Y
	LDA $02
	STA !OAMTILE,Y
	LDA #$05
	ORA $64
	STA !OAMPROP,Y
	SEP #$10
	JML $02BF41

URCHIN_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0010
	TAY
	LDA #$0000
	SEP #$20
CODE_02BF84:
	LDA $05
	TAX
	LDA $00
	CLC
	ADC $BF49,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $BF4E,X
	STA !OAMY,Y
	LDA $BF53,X
	STA !OAMPROP,Y
	CPX #$0000
	BNE CODE_02BFAC
	LDA $03
	CMP #$01
	LDA #$CA
	BCC CODE_02BFB1
	LDA #$CC
	BRA CODE_02BFB1
CODE_02BFAC:
	LDA $02
	TAX
	LDA $BF58,X
CODE_02BFB1:
	STA !OAMTILE,Y
	INY
	INY
	INY
	INY
	INC $05
	LDA $05
	CMP #$05
	BNE CODE_02BF84
	SEP #$10
	JML $02BFC0


CHUCK_HACK1:
	LDA $C864,Y
	REP #$30
	AND #$00FF
	CLC
	ADC !SPRITEINDEX
	SEC
	SBC #$0010
	TAY
	LDA #$0000
	SEP #$20
	LDA $04
	TAX
	LDA $C830,X
	PHA
	LDA $03
	BNE CODE_02C8D8
	PLA
	EOR #$FF
	INC A
	PHA
CODE_02C8D8:
	PLA
	CLC
	ADC $00
	STA !OAMX,Y
	LDA $04
	TAX
	LDA $01
	CLC
	ADC $C84A,X
	SEC
	SBC $07
	STA !OAMY,Y
	LDA $02
	TAX
	LDA $C885,X
	ORA $08
	STA !OAMPROP,Y
	LDA $C87E,X
	STA !OAMTILE,Y
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$02
	STA !OAMEXTENDED,Y
	SEP #$10
	JML $02C905

CHUCK_HACK2:
	LDY $04
	LDA $CA0D,Y
	REP #$30
	AND #$00FF
	CLC
	ADC !SPRITEINDEX
	SEC
	SBC #$0010
	TAY
	LDA #$0000
	SEP #$20
	LDA $00
	CLC
	ADC $C909,X
	STA !OAMX,Y
	LDA $00
	CLC
	ADC $C93D,X
	STA !OAMX+$4,y
	LDA $04
	TAX
	LDA $01
	CLC
	ADC $C971,X
	STA !OAMY,Y
	LDA $01
	STA !OAMY+$4,Y
	LDA $C98B,X
	STA !OAMTILE,Y
	LDA $C9A5,X
	STA !OAMTILE+$4,Y
	LDA $08
	ORA $06
	PHA
	EOR $C9BF,X
	STA !OAMPROP,Y
	PLA
	EOR $C9D9,X
	STA !OAMPROP+$4,Y
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA $C9F3,X
	STA !OAMEXTENDED,Y
	LDA #$02
	STA !OAMEXTENDED+$1,Y
	SEP #$10
	JML $02CA8F


CHUCK_HACK3:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0010
	TAY
	LDA #$0000
	SEP #$20
	LDA $00
	CLC
	ADC $CA93,X
	STA !OAMX,Y
	LDA $00
	CLC
	ADC $CA95,X
	STA !OAMX+$4,Y
	LDA $01
	CLC
	ADC $CA99,X
	STA !OAMY,Y
	STA !OAMY+$4,Y
	LDA $CA97,X
	STA !OAMTILE,Y
	STA !OAMTILE+$4,Y
	LDA $08
	STA !OAMPROP,Y
	ORA #$40
	STA !OAMPROP+$4,Y
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA $CA9B,X
	STA !OAMEXTENDED,Y
	STA !OAMEXTENDED+$1,Y
	SEP #$10
	JML $02CAF6

CHUCK_HACK4:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0010
	TAY
	LDA #$0000
	SEP #$20
	LDA $157C,X
	PHX
	TAX
	ASL
	ASL
	ASL
	PHA
	EOR #$08
	CLC
	ADC $00
	STA !OAMX,Y
	PLA
	CLC
	ADC $00
	STA !OAMX+$4,Y
	LDA #$1C
	STA !OAMTILE,Y
	INC A
	STA !OAMTILE+$4,Y
	LDA $01
	SEC
	SBC #$08
	STA !OAMY,Y
	STA !OAMY+$4,Y
	LDA $CAFA,X
	ORA $64
	STA !OAMPROP,Y
	STA !OAMPROP+$4,Y
	REP #$20
	TYA
	LSR
	LSR
	TAX
	SEP #$20
	STZ !OAMEXTENDED,X
	db $9E : dw !OAMEXTENDED+$1
	PLX
	SEP #$10
	JML $02CB40

CHUCK_HACK5:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0008
	TAY
	LDA #$0000
	SEP #$20
	LDA $00
	CLC
	ADC $CB2D,X
	STA !OAMX,Y
	LDA $02
	TAX
	LDA $CB39,X
	BEQ CODE_02CB8E
	CLC
	ADC $01
	STA !OAMY,Y
	LDA #$AD
	STA !OAMTILE,Y
	LDA #$09
	ORA $64
	STA !OAMPROP,Y
	REP #$20
	TYA
	LSR
	LSR
	TAX
	SEP #$20
	STZ !OAMEXTENDED,X
CODE_02CB8E:
	SEP #$10
	JML $02CB8E

CHUCK_HACK6:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004
	TAY
	LDA #$0000
	SEP #$20
	PHX
	LDA $02
	ASL
	ORA $157C,X
	TAX
	LDA $00
	CLC
	ADC $CB90,X
	STA !OAMX,Y
	TXA
	AND #$01
	TAX
	LDA $CB96,X
	ORA $64
	STA !OAMPROP,Y
	LDA $02
	TAX
	LDA $01
	CLC
	ADC $CB98,X
	STA !OAMY,Y
	LDA $CB9B,X
	STA !OAMTILE,Y
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA $CB9E,X
	STA !OAMEXTENDED,Y
	PLX
	SEP #$10
	JML $02CBFB
	

PALACESWITCH_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$001C
	TAY
	LDA #$0000
	SEP #$20
CODE_02CD91:
	LDA $00
	CLC
	ADC $CD35,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $CD3D,X
	STA !OAMY,Y
	LDA $CD45,X
	STA !OAMTILE,Y
	LDA $CD4D,X
	CPX #$0004
	BCS CODE_02CDB2
	ORA $02
CODE_02CDB2:
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_02CD91
	SEP #$10
	JML $02CDBC

PEABOUNCER_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0010
	TAY
	LDA #$0000
	SEP #$20
CODE_02CEFC:
	LDA $04
	ASL
	ASL
	ADC $04
	ADC $02
	TAX
	LDA $05
	LSR
	LDA $CE90,X
	BCC CODE_02CF10
	EOR #$FF
	INC A
CODE_02CF10:
	STA $08
	CLC
	ADC $00
	STA !OAMX,Y
	LDA $03
	ASL
	LDA $CEB8,X
	BCC CODE_02CF23
	EOR #$FF
	INC A
CODE_02CF23:
	STA $09
	CLC
	ADC $01
	STA !OAMY,Y
	LDA #$3D
	STA !OAMTILE,Y
	LDA $64
	ORA #$0A
	STA !OAMPROP,Y
	LDA $15E9
	TAX
	PHY
	JSR PEABOUNCER_SUB
	PLY
	INY
	INY
	INY
	INY
	DEC $02
	BMI CODE_02CF4A
	JMP CODE_02CEFC
CODE_02CF4A:
	SEP #$10
	JML $02CF4A

Return02CF51:
	RTS

PEABOUNCER_SUB:
	
CODE_02CF52:	LDA $71
CODE_02CF54:	CMP #$01                
CODE_02CF56:	BCS Return02CF51          
CODE_02CF58:	LDA $81                   
CODE_02CF5A:	ORA $7F                   
CODE_02CF5C:	ORA $15A0,X 
CODE_02CF5F:	ORA $186C,X 
CODE_02CF62:	BNE Return02CF51          
CODE_02CF64:	LDA $7E                   
CODE_02CF66:	CLC                       
CODE_02CF67:	ADC #$02                
CODE_02CF69:	STA $0A                   
CODE_02CF6B:	LDA $187A         
CODE_02CF6E:	CMP #$01                
CODE_02CF70:	LDA #$10                
CODE_02CF72:	BCC CODE_02CF76           
CODE_02CF74:	LDA #$20                
CODE_02CF76:	CLC                       
CODE_02CF77:	ADC $80                   
CODE_02CF79:	STA $0B                   
CODE_02CF7B:	LDA !OAMX,Y         
CODE_02CF7E:	SEC                       
CODE_02CF7F:	SBC $0A                   
CODE_02CF81:	CLC                       
CODE_02CF82:	ADC #$08                
CODE_02CF84:	CMP #$14                
CODE_02CF86:	BCS Return02CFFD          
CODE_02CF88:	LDA $19
CODE_02CF8A:	CMP #$01                
CODE_02CF8C:	LDA #$1A                
CODE_02CF8E:	BCS CODE_02CF92           
CODE_02CF90:	LDA #$1C                
CODE_02CF92:	STA $0F                   
CODE_02CF94:	LDA !OAMY,Y         
CODE_02CF97:	SEC                       
CODE_02CF98:	SBC $0B                   
CODE_02CF9A:	CLC                       
CODE_02CF9B:	ADC #$08                
CODE_02CF9D:	CMP $0F                   
CODE_02CF9F:	BCS Return02CFFD          
CODE_02CFA1:	LDA $7D      
CODE_02CFA3:	BMI Return02CFFD          
CODE_02CFA5:	LDA #$1F                
CODE_02CFA7:	PHA                       
CODE_02CFA8:	LDA $187A        
CODE_02CFAB:	BEQ CODE_02CFAF  
		PLA         
ADDR_02CFAD:	LDA #$2F   
		PHA             
CODE_02CFAF:	
		PLA
		STA $0F                    
CODE_02CFB2:	LDA !OAMY,Y         
CODE_02CFB5:	SEC                       
CODE_02CFB6:	SBC $0F                   
CODE_02CFB8:	PHP                       
CODE_02CFB9:	CLC                       
CODE_02CFBA:	ADC $1C   
CODE_02CFBC:	STA $96         
CODE_02CFBE:	LDA $1D   
CODE_02CFC0:	ADC #$00                
CODE_02CFC2:	PLP                       
CODE_02CFC3:	SBC #$00                
CODE_02CFC5:	STA $97      
CODE_02CFC7:	STZ $72         
CODE_02CFC9:	LDA #$02                
CODE_02CFCB:	STA $1471               
CODE_02CFCE:	LDA $1528,X             
CODE_02CFD1:	BEQ CODE_02CFEB           
CODE_02CFD3:	CMP #$02                
CODE_02CFD5:	BEQ CODE_02CFEB           
CODE_02CFD7:	LDA $1540,X             
CODE_02CFDA:	CMP #$01                
CODE_02CFDC:	BNE Return02CFEA          
CODE_02CFDE:	LDA #$08                
CODE_02CFE0:	STA $1534,X             
CODE_02CFE3:	LDA $C2,X   
		TAY  
CODE_02CFE5:	LDA $CE07,Y       
CODE_02CFE8:	STA $7D       
Return02CFEA:	RTS                       ; Return 

CODE_02CFEB:	STZ $7B      
CODE_02CFED:	LDA $02   
		TAY                
CODE_02CFEF:	LDA $CFFE,Y 
CODE_02CFF2:	STA $151C,X             
CODE_02CFF5:	LDA #$01                
CODE_02CFF7:	STA $1528,X             
CODE_02CFFA:	STZ $1570,X             
Return02CFFD:	RTS                       ; Return 


BANZAIBILL_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$003C		; 16 tiles
	TAY
	LDA #$0000
	SEP #$20
CODE_02D5EA:
	LDA $00
	CLC
	ADC $D5A4,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $D5B4,X
	STA !OAMY,Y
	LDA $D5C4,X
	STA !OAMTILE,Y
	LDA $D5D4,X
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_02D5EA
	SEP #$10
	JML $02D60F


CHAIN_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004
	TAY
	LDA #$0000
	SEP #$20
CODE_02D7AF:
	LDA $00
	STA !OAMX,Y
	LDA $01
	STA !OAMY,Y
	LDA $08
	STA !OAMTILE,Y
	LDA #$33
	STA !OAMPROP,Y
	LDA $00
	CLC
	ADC $1A
	SEC
	SBC $0A
	STA $00
	ASL
	ROR $00
	LDA $00
	SEC
	SBC $1A
	CLC
	ADC $0A
	STA $00
	LDA $01
	CLC
	ADC $1C
	SEC
	SBC $0B
	STA $01
	ASL
	ROR $01
	LDA $01
	SEC
	SBC $1C
	CLC
	ADC $0B
	STA $01
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_02D7AF
	SEP #$10
	JML $02D7F8

BALLNCHAIN_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0014
	TAY
	LDA #$0000
	SEP #$20
CODE_02D819:
	LDA $00
	CLC
	ADC $D807,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $D80B,X
	STA !OAMY,Y
	LDA #$EA
	STA !OAMTILE,Y
	LDA $D80F,X
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_02D819
	SEP #$10
	JML $02D83E

GREYPLAT_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0014
	TAY
	LDA #$0000
	SEP #$20
CODE_02D84E:
	LDA $00
	CLC
	ADC $D840,X
	STA !OAMX,Y
	LDA $01
	STA !OAMY,Y
	LDA $D844,X
	STA !OAMTILE,Y
	LDA #$33
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_02D84E
	SEP #$10
	JML $02D86E

BUBBLE_HACK1:
	PHA
	REP #$30
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	LDA #$0000
	SEP #$20
	PLA
	TAX
	LDA $D8A9,X
	ORA $64
	STA !OAMPROP,Y
	LDA $14
	ASL
	ASL
	ASL
	LDA $D8A1,X
	BCC CODE_02D8E4
	LDA $D8A5,X
CODE_02D8E4:
	STA !OAMTILE,Y
	SEP #$10
	JML $02D8E7


BUBBLE_HACK2:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0010
	TAY
	LDA #$0000
	SEP #$20
	PHX
	LDA $1534,X
	STA $03
	LDX #$0004
CODE_02D9F8:
	PHX
	TXA
	CLC
	ADC $02
	TAX
	LDA $00
	CLC
	ADC $D9A5,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $D9B4,X
	STA !OAMY,Y
	PLX
	LDA $D9C3,X
	STA !OAMTILE,Y
	LDA $D9C8,X
	ORA $64
	STA !OAMPROP,Y
	LDA $03
	CMP #$06
	BCS CODE_02DA37
	CMP #$03
	LDA #$02
	ORA $64
	STA !OAMPROP,Y
	LDA #$64
	BCS CODE_02DA34
	LDA #$66
CODE_02DA34:
	STA !OAMTILE,Y
CODE_02DA37:
	PHY
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA $D9CD,X
	STA !OAMEXTENDED,Y
	PLY
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_02D9F8
	PLX
	SEP #$10
	JML $02DA4B


STUNNEDADD_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA !OAMPROP,Y
	AND #$FE
	STA !OAMPROP,Y
	SEP #$10
	JML $01A217


STUNNEDADD_HACK2:
	PHA
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	PLA
	STA !OAMTILE,Y
	SEP #$10
	JML $01A228

HAMMERBRO_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C
	TAY
	LDA #$0000
	SEP #$20
CODE_02DB08:
	LDA $00
	CLC
	ADC $DAE9,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $DAED,X
	STA !OAMY,Y
	PHX
	LDA $02
	PHA
	ORA #$37
	STA !OAMPROP,Y
	PLA
	BEQ CODE_02DB2A
	INX
	INX
	INX
	INX
CODE_02DB2A:
	LDA $DAF1,X
	STA !OAMTILE,Y
	PLX
	PHY
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA $DAF9,X
	STA !OAMEXTENDED,Y
	PLY
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_02DB08
	SEP #$10
	JML $02DB44

HAMMERBROPLAT_HACK:
	STX $06
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C
	TAY
	LDA #$0000
	SEP #$20
CODE_02DC5D:
	LDA $06
	ORA $02
	TAX
	LDA $00
	CLC
	ADC $DC0F,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $DC17,X
	STA !OAMY,Y
	LDA $06
	CMP #$02
	BCS CODE_02DC8A
	INC A
	CMP #$07
	BNE CODE_02DC8A
	LDA !OAMY,Y
	SEC
	SBC $05
	STA !OAMY,Y
CODE_02DC8A:
	LDA $DC1F,X
	STA !OAMTILE,Y
	LDA $DC27,X
	STA !OAMPROP,Y
	PHY
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA $DC2F,X
	STA !OAMEXTENDED,Y
	PLY
	INY
	INY
	INY
	INY
	DEC $06
	BPL CODE_02DC5D
	SEP #$10
	JML $02DB44


DOLPHIN_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0008
	TAY
	LDA #$0000
	SEP #$20
	LDA $00
	ASL $02
	PHP
	BCC CODE_02BC3C
	STA !OAMX,Y
	CLC
	ADC #$10
	STA !OAMX+$4,Y
	CLC
	ADC #$08
	STA !OAMX+$8,Y
	BRA CODE_02BC4E
CODE_02BC3C:
	CLC
	ADC #$18
	STA !OAMX,Y
	SEC
	SBC #$10
	STA !OAMX+$4,Y
	SEC
	SBC #$08
	STA !OAMX+$8,Y
CODE_02BC4E:
	LDA $01
	STA !OAMY,Y
	STA !OAMY+$4,Y
	STA !OAMY+$8,Y
	PHX
	LDA $14
	AND #$08
	LSR
	LSR
	LSR
	TAX
	LDA $BC0E,X
	STA !OAMTILE,Y
	LDA $BC10,X
	STA !OAMTILE+$4,Y
	LDA $BC12,X
	STA !OAMTILE+$8,Y
	PLX
	LDA $15F6,X
	ORA $64
	PLP
	BCS CODE_02BC7F
	ORA #$40
CODE_02BC7F:
	STA !OAMPROP,Y
	STA !OAMPROP+$4,Y
	STA !OAMPROP+$8,Y
	SEP #$10
	JML $02BC88


SUMOBRO_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C
	TAY
	LDA #$0000
	SEP #$20
CODE_02DE5B:
	PHX
	LDA $02
	BEQ CODE_02DE65
	TXA
	CLC
	ADC #$18
	TAX
CODE_02DE65:
	LDA $00
	CLC
	ADC $DDC6,X
	STA !OAMX,Y
	PLX
	LDA $01
	CLC
	ADC $DDF6,X
	STA !OAMY,Y
	LDA $DE0E,X
	STA !OAMTILE,Y
	CMP #$66
	SEC
	BNE CODE_02DE84
	CLC
CODE_02DE84:
	LDA #$34
	ADC $02
	STA !OAMPROP,Y
	PHY
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA $DE26,X
	STA !OAMEXTENDED,Y
	PLY
	INY
	INY
	INY
	INY
	INX
	DEC $05
	BPL CODE_02DE5B
	SEP #$10
	JML $02DEA0
	
	
SUMOLIGHTNING_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA !OAMPROP-$8,Y
	EOR #$C0
	STA !OAMPROP-$8,Y
	SEP #$10
	JML $02DEFB

LIGHTNINGFIRE_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004
	TAY
	LDA #$0000
	SEP #$20
CODE_02F967:
	PHX
	LDA $00
	STA !OAMX,Y
	TXA
	ORA $185E
	TAX
	LDA $F8FC,X
	BMI CODE_02F993
	CLC
	ADC $01
	STA !OAMY,Y
	LDA $F904,X
	STA !OAMTILE,Y
	LDA $14
	AND #$04
	ASL
	ASL
	ASL
	ASL
	ORA $64
	ORA #$05
	STA !OAMPROP,Y
CODE_02F993:
	PLX
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_02F967
	SEP #$10
	JML $02F99B

MUSHSCALE_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004
	TAY
	LDA #$0000
	SEP #$20
	LDA $00
	SEC
	SBC #$08
	STA !OAMX,Y
	CLC
	ADC #$10
	STA !OAMX+$4,Y
	LDA $01
	DEC A
	STA !OAMY,Y
	STA !OAMY+$4,Y
	LDA #$80
	STA !OAMTILE,Y
	STA !OAMTILE+$4,Y
	LDA $15F6,X
	ORA $64
	STA !OAMPROP,Y
	ORA #$40
	STA !OAMPROP+$4,Y
	SEP #$10
	JML $02E5AD
	

VOLCLOTUS_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	SEC
	SBC #$000C
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA #$CE
	STA !OAMTILE+$8,Y
	STA !OAMTILE+$C,Y
	LDA !OAMPROP+$8,Y
	AND #$30
	ORA #$0B
	STA !OAMPROP+$8,Y
	ORA #$40
	STA !OAMPROP+$C,Y
	LDA !OAMX+$8,Y
	CLC
	ADC #$08
	STA !OAMX,Y
	CLC
	ADC #$08
	STA !OAMX+$4,Y
	LDA !OAMY+$8,Y
	STA !OAMY,Y
	STA !OAMY+$4,Y
	PHX
	LDA $1602,X
	TAX
	LDA $E008,X
	STA !OAMTILE,Y
	INC A
	STA !OAMTILE+$4,Y
	PLX
	LDA $151C,X
	CMP #$01
	LDA #$39
	BCC CODE_02E05B
	LDA #$35
CODE_02E05B:
	STA !OAMPROP,Y
	STA !OAMPROP+$4,Y
	SEP #$10
	JML $02E06A

DIRCOINS_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA #$2E
	STA !OAMTILE,Y
	LDA !OAMPROP,Y
	AND #$3F
	STA !OAMPROP,Y
	SEP #$10
	JML $02E259


GASBUBBLE_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$003C
	TAY
	LDA #$0000
	SEP #$20
CODE_02E3C6:
	LDA $00
	CLC
	ADC $E352,X
	PHA
	LDA $E392,X
	AND #$02
	BNE CODE_02E3DA
	PLA
	CLC
	ADC $02
	BRA CODE_02E3DE
CODE_02E3DA:
	PLA
	SEC
	SBC $02
CODE_02E3DE:
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $E362,X
	PHA
	LDA $E392,X
	AND #$01
	BNE CODE_02E3F5
	PLA
	CLC
	ADC $03
	BRA CODE_02E3F9
CODE_02E3F5:
	PLA
	SEC
	SBC $03
CODE_02E3F9:
	STA !OAMY,Y
	LDA $E372,X
	STA !OAMTILE,Y
	LDA $E382,X
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_02E3C6
	SEP #$10
	JML $02E40F


HOLE_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C
	TAY
	LDA #$0000
	SEP #$20
CODE_02E63D:
	LDA $00
	CLC
	ADC $E666,X
	STA !OAMX,Y
	LDA $01
	STA !OAMY,Y
	LDA $E66A,X
	STA !OAMTILE,Y
	LDA $E66E,X
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_02E63D
	SEP #$10
	JML $02E65E


GROWINGPIPE_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004
	TAY
	LDA #$0000
	SEP #$20
	LDA $00
	STA !OAMX,Y
	CLC
	ADC #$10
	STA !OAMX+$4,Y
	LDA $01
	DEC A
	STA !OAMY,Y
	STA !OAMY+$4,Y
	LDA #$A4
	STA !OAMTILE,Y
	LDA #$A6
	STA !OAMTILE+$4,Y
	LDA $15F6,X
	ORA $64
	STA !OAMPROP,Y
	STA !OAMPROP+$4,Y
	SEP #$10
	JML $02E92E

PIPELAKITU_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004
	TAY
	LDA #$0000
	SEP #$20
	LDA $00
	STA !OAMX,Y
	STA !OAMX+$4,Y
	LDA $01
	STA !OAMY,Y
	CLC
	ADC #$10
	STA !OAMY+$4,Y
	PHX
	LDA $1602,X
	TAX
	LDA $E9E6,X
	STA !OAMTILE,Y
	LDA $E9E9,X
	STA !OAMTILE+$4,Y
	PLX
	LDA $157C,X
	LSR
	ROR
	LSR
	EOR #$5B
	STA !OAMPROP,Y
	STA !OAMPROP+$4,Y
	SEP #$10
	JML $02E92E

PIPELAKITU_HACK2:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA !OAMTILE,Y
	STA $00
	STZ $01
	LDA #$06
	STA !OAMTILE,Y
	SEP #$10
	JML $02EA34

SUPERKOOPA_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C
	TAY
	LDA #$0000
	SEP #$20
CODE_02ECF7:
	LDA $03
	CLC
	ADC $04
	TAX
	LDA $01
	CLC
	ADC $EC4E,X
	STA !OAMY,Y
	LDA $EC72,X
	STA !OAMTILE,Y
	PHY
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA $ECBA,X
	STA !OAMEXTENDED,Y
	PLY
	LDA $02
	LSR
	LDA $EC96,X
	AND #$02
	BEQ CODE_02ED4D
	PHP
	PHX
	LDA $15E9
	TAX
	LDA $1534,X
	BEQ CODE_02ED3B
	LDA $14
	LSR
	AND #$01
	PHY
	TAY
	LDA $ED39,Y
	PLY
	BRA CODE_02ED44
CODE_02ED3B:
	LDA $9E,X
	CMP #$72
	LDA #$08
	BCC CODE_02ED44
	LSR
CODE_02ED44:
	PLX
	PLP
	ORA $EC96,X
	AND #$FD
	BRA CODE_02ED52
CODE_02ED4D:
	LDA $EC96,X
	ORA $05
CODE_02ED52:
	ORA $64
	BCS CODE_02ED5F
	PHA
	REP #$20
	TXA
	CLC
	ADC #$0024
	TAX
	SEP #$20
	PLA
	ORA #$40
CODE_02ED5F:
	STA !OAMPROP,Y
	LDA $00
	CLC
	ADC $EC06,X
	STA !OAMX,Y
	INY
	INY
	INY
	INY
	INC $04
	LDA $04
	CMP #$04
	BNE CODE_02ECF7_2
	SEP #$10
	JML $02ED77

CODE_02ECF7_2:
	JMP CODE_02ECF7


FLOATINGSKULL_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA $14
	LSR
	LSR
	LSR
	LSR
	LDA #$E0
	BCC CODE_02EE09
	LDA #$E2
CODE_02EE09:
	STA !OAMTILE,Y
	LDA !OAMY,Y
	CMP #$F0
	BCS CODE_02EE19
	CLC
	ADC #$03
	STA !OAMY,Y
CODE_02EE19:
	SEP #$10
	JML $02EE19


WIGGLER_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0010
	TAY
	LDA #$0000
	SEP #$20
CODE_02F12D:
	PHX
	TXA
	STA $05
	LDA $03
	LSR
	LSR
	LSR
	CLC
	ADC $05
	AND #$03
	STA $06
	PHY
	LDA $F103,X
	TAY
	LDA $08
	BEQ CODE_02F14D
	TYA
	LSR
	AND #$FE
	TAY
CODE_02F14D:
	TYA
	STA $09
	LDA [$D5],Y
	PLY
	SEC
	SBC $1A
	STA !OAMX,Y
	PHY
	LDA $09
	INC A
	TAY
	LDA [$D5],Y
	PLY
	SEC
	SBC $1C
	PHA
	LDA $06
	TAX
	PLA
	SEC
	SBC $F108,X
	STA !OAMY,Y
	PLX
	PHX
	LDA #$8C
	CPX #$0000
	BEQ CODE_02F178
	LDA $06
	TAX
	LDA $F10C,X
CODE_02F178:
	STA !OAMTILE,Y
	PLX
	LDA $07
	ORA $64
	LSR $02
	BCS CODE_02F186
	ORA #$40
CODE_02F186:
	STA !OAMPROP,Y
	PHY
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$02
	STA !OAMEXTENDED,Y
	PLY
	INY
	INY
	INY
	INY
	INX
	CPX #$0005
	BEQ CODE_02F12D_2
	JMP CODE_02F12D
CODE_02F12D_2:
	LDA $15E9
	TAX
	REP #$20
	LDA !SPRITEINDEX
	SEC
	SBC #$0014
	TAY
	LDA #$0000
	SEP #$20
	PHX
	LDA $157C,X
	TAX
	LDA $08
	BEQ CODE_02F1C7
	LDA !OAMX+$4,Y
	CLC
	ADC $F2D5,X
	PLX
	STA !OAMX,Y
	LDA !OAMY+$4,Y
	STA !OAMY,Y
	LDA #$88
	STA !OAMTILE,Y
	LDA !OAMPROP+$4,Y
	BRA CODE_02F1EF
CODE_02F1C7:
	LDA !OAMX+$4,Y
	CLC
	ADC $F2D3,X
	PLX
	STA !OAMX,Y
	LDA !OAMY+$4,Y
	SEC
	SBC #$08
	STA !OAMY,Y
	LDA #$98
	STA !OAMTILE,Y
	LDA !OAMPROP+$4,Y
	AND #$F1
	ORA #$0A
CODE_02F1EF:
	STA !OAMPROP,Y
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$00
	STA !OAMEXTENDED,Y	
	SEP #$10
	JML $02F1FB

WIGGLER_HACK2:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	SEC
	SBC #$0010
	TAY
	PLX
	LDA #$0000
	SEP #$20
CODE_02F22B:
	LDA !OAMX,Y
	SEC
	SBC $7E
	ADC #$0C
	CMP #$18
	BCS CODE_02F29B
	LDA !OAMY,Y
	SEC
	SBC $80
	SBC #$10
	PHA
	LDA $187A
	CMP #$01
	PLA
	BCC CODE_02F247
	SEC
	SBC #$10
CODE_02F247:
	CLC
	ADC #$0C
	CMP #$18
	BCS CODE_02F29B
	LDA $1490
	BNE ADDR_02F29D
	LDA $154C,X
	ORA $81
	BNE CODE_02F29B
	SEP #$10
	JML $02F25B

ADDR_02F29D:
	SEP #$10
	JML $02F29D
CODE_02F29B:
	INY
	INY
	INY
	INY
	DEC $00
	BMI CODE_02F2D2
	JMP CODE_02F22B
CODE_02F2D2:
	SEP #$10
	JML $02F2D2


BIRDS_HACK:
	REP #$30
	LDA !SPRITEINDEX
	TAY
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20
	LDA $E4,X
	SEC
	SBC $1A
	STA !OAMX,Y
	LDA $D8,X
	SEC
	SBC $1C
	STA !OAMY,Y
	PHX
	LDA $1602,X
	TAX
	LDA $F3DB,X
	STA !OAMTILE,Y
	PLX
	LDA $02
	STA !OAMPROP,Y
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$00
	STA !OAMEXTENDED,Y
	SEP #$10
	JML $02F42B

CHIMNEYSMOKE_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004
	TAY
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20
	LDA $E4,X
	SEC
	SBC $1A
	PHA
	SEC
	SBC $00
	STA !OAMX,Y
	PLA
	CLC
	ADC $00
	STA !OAMX+$4,Y
	LDA $D8,X
	SEC
	SBC $1C
	STA !OAMY,Y
	STA !OAMY+$4,Y
	LDA #$C5
	STA !OAMTILE,Y
	STA !OAMTILE+$4,Y
	LDA #$05
	STA !OAMPROP,Y
	ORA #$40
	STA !OAMPROP+$4,Y
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$02
	STA !OAMEXTENDED,Y
	STA !OAMEXTENDED+$1,Y
	SEP #$10
	JML $02F4CC

FIREPLACE_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004
	TAY
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20
	LDA #$B8
	STA !OAMX,Y
	STA !OAMX+$4,Y
	LDA #$B0
	STA !OAMY,Y
	LDA #$B8
	STA !OAMY+$4,Y
	LDA $13
	AND #$03
	BNE CODE_02F516
	PHY
	SEP #$10
	JSL $01ACF9
	REP #$10
	PLY
	AND #$03
	BNE CODE_02F516
	INC $C2,X
CODE_02F516:
	PHX
	LDA $C2,X
	AND #$01
	TAX
	LDA $F4E7,X
	STA !OAMTILE,Y
	LDA $F4E9,X
	STA !OAMTILE+$4,Y
	LDA #$35
	STA !OAMPROP,Y
	STA !OAMPROP+$4,Y
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$00
	STA !OAMEXTENDED,Y
	STA !OAMEXTENDED+$1,Y
	PLX
	SEP #$10
	JML $02F53D

GHOSTHOUSEEXIT_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0024
	TAY
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20
CODE_02F5DA:
	STZ $02
	LDA $F59E,X
	SEC
	SBC $1A
	STA $00
	LDA $F5A8,X
	SBC $1B
	BEQ CODE_02F5ED
	INC $02
CODE_02F5ED:
	LDA $00
	STA !OAMX,Y
	LDA $F5B2,X
	STA !OAMY,Y
	LDA $F5BC,X
	STA !OAMTILE,Y
	LDA $F5C6,X
	STA !OAMPROP,Y
	PHY
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$02
	ORA $02
	STA !OAMEXTENDED,Y
	PLY
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_02F5DA
	SEP #$10
	JML $02F618

CASTLEANIMATION_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$001C
	TAY
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20
ADDR_02F63D:
	LDA #$C0
	CLC
	ADC $F619,X
	STA !OAMX,Y
	LDA #$70
	CLC
	ADC $F621,X
	STA !OAMY,Y
	LDA $F629,X
	STA !OAMTILE,Y
	LDA $F631,X
	STA !OAMPROP,Y
	PHY
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$02
	STA !OAMEXTENDED,Y
	PLY
	INY
	INY
	INY
	INY
	DEX
	BPL ADDR_02F63D
	SEP #$10
	JML $02F66D

CASTLEANIMATION_HACK2:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$002C
	TAY
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20
CODE_02F6BC:
	LDA #$B8
	CLC
	ADC $F6A0,X
	STA !OAMX,Y
	LDA #$50
	SEC
	SBC $1C
	SEC
	SBC $00
	CLC
	ADC $F6AC,X
	STA !OAMY,Y
	LDA #$A5
	STA !OAMTILE,Y
	LDA #$21
	STA !OAMPROP,Y
	PHY
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$02
	STA !OAMEXTENDED,Y
	PLY
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_02F6BC
	SEP #$10
	JML $02F6F0


CASTLEFLAME_HACK:
	REP #$30
	LDA !SPRITEINDEX
	TAY
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20
	LDA $1E16,X
	SEC
	SBC $1E
	STA !OAMX,Y
	LDA $1E02,X
	SEC
	SBC $02
	STA !OAMY,Y
	PHY
	PHX
	LDA $0F4A,X
	AND #$03
	TAX
	LDA $FA0E,X
	STA !OAMTILE,Y
	LDA $FA12,X
	STA !OAMPROP,Y
	PLX
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$02
	STA !OAMEXTENDED,Y
	PLY
	LDA !OAMX,Y
	CMP #$F0
	BCC RETURN_02FA83
	STA $03EC
	LDA !OAMY,Y
	STA $03ED
	LDA !OAMTILE,Y
	STA $03EE
	LDA !OAMPROP,Y
	STA $03EF
	LDA #$03
	STA $049B
RETURN_02FA83:
	SEP #$10
	JML $02FA83


BOORING_HACK:
	REP #$30
	LDA !SPRITEINDEX
	TAY
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20
	LDA $1E16,X
	SEC
	SBC $1A
	STA !OAMX,Y
	LDA $1E02,X
	SEC
	SBC $1C
	STA !OAMY,Y
	LDA $14
	LSR
	LSR
	LSR
	AND #$01
	STA $00
	TXA
	AND #$03
	ASL
	ADC $00
	PHX
	TAX
	LDA $FBBF,X
	STA !OAMTILE,Y
	PLX
	LDA $1E66,X
	ASL
	LDA #$00
	BCS CODE_02FD81
	LDA #$40
CODE_02FD81:
	ORA #$31
	ORA $02
	STA !OAMPROP,Y
	PHY
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$02
	STA !OAMEXTENDED,Y
	PLY
	LDA $1892,X
	CMP #$08
	BNE RETURN_02FDB7
	LDA $14
	LSR
	LSR
	AND #$01
	STA $00
	LDA $0F86,X
	ASL
	ORA $00
	PHX
	TAX
	LDA $FDB8,X
	STA !OAMTILE,Y
	LDA #$37
	STA !OAMPROP,Y
	PLX
RETURN_02FDB7:
	SEP #$10
	JML $02FDB7
	

BOORING_HACK2:
	REP #$30
	LDA !SPRITEINDEX
	CLC
	ADC #$0004
	TAY
	STA !SPRITEINDEX	; free this up for another tile
	SEP #$20
	LDA #$F0
	STA !OAMY,Y		; push offscreen in the case it isn't used
	SEP #$10
	JML $02FCE1

BOORING_HACK3:
	REP #$30
	LDA !SPRITEINDEX
	CLC
	ADC #$0004
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$03
	STA !OAMEXTENDED,Y
	SEP #$10
	JML $02FCD8


BONUS1UP_HACK:
	REP #$30
	LDA !SPRITEINDEX
	TAY
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20
	LDA $1E16,X
	SEC
	SBC $1A
	STA !OAMX,Y
	LDA $1E02,X
	SEC
	SBC $1C
	STA !OAMY,Y
	LDA #$24
	STA !OAMTILE,Y
	LDA #$3A
	STA !OAMPROP,Y
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$02
	STA !OAMEXTENDED,Y
	SEP #$10
	JML $02FE70

BIGBOO_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$004C
	TAY
	LDA #$0000
	SEP #$20
	PHY
CODE_0383E0:
	PHX
	LDA $02
	TAX
	LDA $82F8,X
	STA !OAMTILE,Y
	LDA $04
	LSR
	LDA $8348,X
	ORA $05
	BCS CODE_0383F5
	EOR #$40
CODE_0383F5:
	ORA $64
	STA !OAMPROP,Y
	LDA $8280,X
	BCS CODE_038405
	EOR #$FF
	INC A
	CLC
	ADC #$28
CODE_038405:
	CLC
	ADC $00
	STA !OAMX,Y
	PLX
	PHX
	LDA $06
	CMP #$03
	BCC CODE_038418
	TXA
	CLC
	ADC #$14
	TAX
CODE_038418:
	LDA $01
	CLC
	ADC $82D0,X
	STA !OAMY,Y
	PLX
	INY
	INY
	INY
	INY
	INC $02
	INX
	CPX #$0014
	BNE CODE_0383E0
	PLY
	LDA $15E9
	TAX
	LDA $1602,X
	CMP #$03
	BNE CODE_03844B
	LDA $1558,X
	BEQ CODE_03844B
	LDA !OAMY,Y
	CLC
	ADC #$05
	STA !OAMY,Y
	STA !OAMY+$4,Y
CODE_03844B:
	SEP #$10
	JML $03844B

FALLINGGREYPLAT_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C
	TAY
	LDA #$0000
	SEP #$20
CODE_038498:
	LDA $00
	CLC
	ADC $848A,X
	STA !OAMX,Y
	LDA $01
	STA !OAMY,Y
	LDA $848E,X
	STA !OAMTILE,Y
	LDA #$03
	ORA $64
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_038498
	SEP #$10
	JML $0384BA

BLURP_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA $14
	LSR
	LSR
	LSR
	CLC
	ADC $15E9
	LSR
	LDA #$A2
	BCC CODE_0384E2
	LDA #$EC
CODE_0384E2:
	STA !OAMTILE,Y
	LDA $14C8,X
	CMP #$08
	BEQ CODE_0384F5
	LDA !OAMPROP,Y
	ORA #$80
	STA !OAMPROP,Y
	SEP #$10
	JML $0384F4
CODE_0384F5:
	SEP #$10
	JML $0384F5


PUFFER_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C
	TAY
	LDA #$0000
	SEP #$20
CODE_0385B4:
	LDA $01
	CLC
	ADC $858F,X
	STA !OAMY,Y
	PHX
	LDA $02
	BNE CODE_0385C6
	TXA
	ORA #$04
	TAX
CODE_0385C6:
	LDA $00
	CLC
	ADC $8587,X
	STA !OAMX,Y
	LDA $859B,X
	ORA $64
	STA !OAMPROP,Y
	REP #$20
	PLA
	PHA
	SEP #$20
	ORA $03
	TAX
	LDA $8593,X
	STA !OAMTILE,Y
	PLX
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_0385B4
	SEP #$10
	JML $0385EA


FLYINGPLAT_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0010
	TAY
	LDA #$0000
	SEP #$20
	TXA
CODE_0386BB:
	STA $06
	CLC
	ADC $02
	TAX
	LDA $00
	CLC
	ADC $8676,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $8680,X
	STA !OAMY,Y
	LDA $868A,X
	STA !OAMTILE,Y
	LDA $8694,X
	STA !OAMPROP,Y
	PHY
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA $869E,X
	STA !OAMEXTENDED,Y
	PLY
	INY
	INY
	INY
	INY
	DEC $06
	LDA $06
	BPL CODE_0386BB
	SEP #$10
	JML $0386F5

LAVAPLAT_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0008
	TAY
	LDA #$0000
	SEP #$20
CODE_038740:
	LDA $00
	STA !OAMX,Y
	CLC
	ADC #$10
	STA $00
	LDA $01
	STA !OAMY,Y
	LDA $8734,X
	STA !OAMTILE,Y
	LDA $8737,X
	ORA $64
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_038740
	SEP #$10
	JML $038764

MEGAMOLE_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C
	TAY
	LDA #$0000
	SEP #$20
CODE_038859:
	PHX
	LDA $02
	BNE CODE_038862
	INX
	INX
	INX
	INX
CODE_038862:
	LDA $00
	CLC
	ADC $882B,X
	STA !OAMX,Y
	PLX
	LDA $01
	CLC
	ADC $8833,X
	STA !OAMY,Y
	PHX
	TXA
	CLC
	ADC $03
	TAX
	LDA $8837,X
	STA !OAMTILE,Y
	LDA $02
	CMP #$01
	LDA #$01
	BCC CODE_038889
	ORA #$40
CODE_038889:
	ORA $64
	STA !OAMPROP,Y
	PLX
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_038859
	SEP #$10
	JML $038896

SWOOPER_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	PHX
	LDA $1602,X
	TAX
	LDA $88A0,X
	STA !OAMTILE,Y
	PLX
	SEP #$10
	JML $0388B6

SLIDINGKOOPA_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA $1558,X
	CMP #$01
	BNE CODE_038983
	LDA $157C,X
	PHA
	LDA #$02
	STA $9E,X
	PHY
	SEP #$10
	JSL $07F7D2
	REP #$10
	PLY
	PLA
	STA $157C,X
	SEC
CODE_038983:
	LDA #$86
	BCC CODE_038989
	LDA #$E0
CODE_038989:
	STA !OAMTILE,Y
	SEP #$10
	JML $03898C

BOWSERSTATUE_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0008
	TAY
	LDA #$0000
	SEP #$20
CODE_038B57:
	PHX
	LDA $02
	BNE CODE_038B5F
	INX
	INX
	INX
CODE_038B5F:
	LDA $00
	CLC
	ADC $8B25,X
	STA !OAMX,Y
	LDA $8B37,X
	ORA $05
	ORA $64
	STA !OAMPROP,Y
	PLX
	LDA $01
	CLC
	ADC $8B2B,X
	STA !OAMY,Y
	PHX
	LDA $04
	BEQ CODE_038B84
	INX
	INX
	INX
CODE_038B84:
	LDA $8B2E,X
	STA !OAMTILE,Y
	PLX
	PHY
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA $8B34,X
	STA !OAMEXTENDED,Y
	PLY
	INY
	INY
	INY
	INY
	DEX
	TXA
	CMP $03
	BNE CODE_038B57
	SEP #$10
	JML $038BA0

CARROTLIFT_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0008
	TAY
	LDA #$0000
	SEP #$20
CODE_038D34:
	LDA $00
	CLC
	ADC $8D0C,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $8D12,X
	STA !OAMY,Y
	LDA $8D18,X
	STA !OAMTILE,Y
	LDA $8D1E,X
	ORA $64
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEX
	DEC $02
	BPL CODE_038D34
	SEP #$10
	JML $038D5D

MESSAGEBOX_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA #$C0
	STA !OAMTILE,Y
	SEP #$10
	JML $038DB4

TIMEDPLAT_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0008
	TAY
	LDA #$0000
	SEP #$20
CODE_038E2E:
	LDA $00
	CLC
	ADC $8DFF,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $8E02,X
	STA !OAMY,Y
	LDA $8E05,X
	CPX #$0002
	BNE CODE_038E49
	LDA $02
CODE_038E49:
	STA !OAMTILE,Y
	LDA $8E08,X
	ORA $64
	STA !OAMPROP,Y
	PHY
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA $8E0B,X
	STA !OAMEXTENDED,Y
	PLY
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_038E2E
	SEP #$10
	JML $038E67

GREYBLOCK_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C
	TAY
	LDA #$0000
	SEP #$20
CODE_038EBA:
	LDA $00
	CLC
	ADC $8EA8,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $8EAC,X
	STA !OAMY,Y
	LDA $8EB0,X
	STA !OAMTILE,Y
	LDA #$03
	ORA $64
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_038EBA
	SEP #$10
	JML $038EE0
	

STATUEFIREBALL_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004
	TAY
	LDA #$0000
	SEP #$20
CODE_038F2F:
	LDA $01
	STA !OAMY,Y
	PHX
	TXA
	ORA $02
	TAX
	LDA $00
	CLC
	ADC $8F07,X
	STA !OAMX,Y
	LDA $01,S
	ORA $03
	TAX
	LDA $8F0B,X
	STA !OAMTILE,Y
	LDA $02
	CMP #$01
	LDA $8F13,X
	BCC CODE_038F56
	EOR #$40
CODE_038F56:
	ORA $64
	STA !OAMPROP,Y
	PLX
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_038F2F
	SEP #$10
	JML $038F63

REFLECTINGFIREBALL_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	SEP #$20
	LDA #$AC
	STA !OAMTILE,Y
	LDA !OAMPROP,Y
	AND #$31
	ORA $0
	STA !OAMPROP,Y
	SEP #$10
	JML $03901F

FISHINGBOO_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0024
	TAY
	LDA #$0000
	SEP #$20
	PHY
CODE_039191:
	LDA $01
	CLC
	ADC $9156,X
	STA !OAMY,Y
	STZ $03
	LDA $9160,X
	CPX #$0009
	BNE CODE_0391B4
	LDA $14
	LSR
	LSR
	PHX
	AND #$03
	TAX
	LDA $9178,X
	STA $03
	LDA $9174,X
	PLX
CODE_0391B4:
	STA !OAMTILE,Y
	LDA $02
	CMP #$01
	LDA $916A,X
	EOR $03
	ORA $64
	BCS CODE_0391C6
	EOR #$40
CODE_0391C6:
	STA !OAMPROP,Y
	PHX
	LDA $04
	BEQ CODE_0391D3
	TXA
	CLC
	ADC #$0A
	TAX
CODE_0391D3:
	LDA $02
	BNE CODE_0391DC
	TXA
	CLC
	ADC #$14
	TAX
CODE_0391DC:
	LDA $00
	CLC
	ADC $912E,X
	STA !OAMX,Y
	PLX
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_039191
	LDA $14
	LSR
	LSR
	LSR
	AND #$03
	TAX
	PLY
	LDA $917C,X
	EOR !OAMPROP+$10,Y
	STA !OAMPROP+$10,Y
	STA !OAMPROP+$24,Y
	EOR #$C0
	STA !OAMPROP+$14,Y
	STA !OAMPROP+$20,Y
	SEP #$10
	PLY
	JML $03920A

FALLINGSPIKE_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA #$E0
	STA !OAMTILE,Y
	LDA !OAMY,Y
	DEC A
	STA !OAMY,Y
	LDA $1540,X
	BEQ CODE_039237
	LSR
	LSR
	AND #$01
	CLC
	ADC !OAMX,Y
	STA !OAMX,Y
CODE_039237:
	SEP #$10
	JML $039237

CREATEEATBLOCK_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	STA !SPRITEINDEX
	PLX
	LDA #$0000
	SEP #$20
	LDA !OAMY,Y
	DEC A
	STA !OAMY,Y
	LDA #$2E
	STA !OAMTILE,Y
	LDA !OAMPROP,Y
	AND #$3F
	STA !OAMPROP,Y
	SEP #$10
	JML $03929F

WOODSPIKE_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0010
	TAY
	LDA #$0000
	SEP #$20
CODE_0394E1:
	PHX
	TXA
	CLC
	ADC $02
	TAX
	LDA $00
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $94B1,X
	STA !OAMY,Y
	LDA $94BB,X
	STA !OAMTILE,Y
	LDA $94C5,X
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	PLX
	DEX
	BPL CODE_0394E1
	SEP #$10
	JML $039509

REX_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004
	TAY
	LDA #$0000
	SEP #$20
CODE_0396A3:
	PHX
	LDA $02
	CMP #$01
	TXA
	ORA $03
	REP #$20
	PHA
	SEP #$20
	BCS REXFACELEFT
	CLC
	ADC #$0C
REXFACELEFT:
	TAX
	LDA $00
	CLC
	ADC $964C,X
	STA !OAMX,Y
	PLX
	LDA $01
	CLC
	ADC $9664,X
	STA !OAMY,Y
	LDA $9670,X
	STA !OAMTILE,Y
	LDA $02
	TAX
	LDA $967C,X
	ORA $64
	STA !OAMPROP,Y
	REP #$20
	TYA
	LSR
	LSR
	TAX
	SEP #$20
	LDA $03
	CMP #$0A
	LDA #$00
	BCS REX_0
	LDA #$02
REX_0:
	STA !OAMEXTENDED,X
	PLX
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_0396A3
	SEP #$10
	JML $0396EC


FISHBONE_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA $1558,X
	CMP #$01
	LDA #$A6
	BCC CODE_03979E
	LDA #$A8
CODE_03979E:
	STA !OAMTILE,Y
	SEP #$10
	JML $0397A1

FISHBONE_HACK2:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0004
	TAY
	LDA #$0000
	SEP #$20
CODE_0397BD:
	LDA $01
	CLC
	ADC $9782,X
	STA !OAMY,Y
	PHX
	TXA
	ORA $02
	TAX
	LDA $00
	CLC
	ADC $977E,X
	STA !OAMX,Y
	LDA $9784,X
	ORA $64
	STA !OAMPROP,Y
	LDA $01,S
	ORA $03
	TAX
	LDA $9788,X
	STA !OAMTILE,Y
	PLX
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_0397BD
	SEP #$10
	PLX
	LDY #$00
	LDA #$01
	JML $0397F4


DINO_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C
	TAY
	LDA #$0000
	SEP #$20
	TXA
	STA $0F
CODE_039E5F:
	TAX
	LDA $02
	BNE CODE_039E6C
	TXA
	CLC
	ADC #$04
	TAX
CODE_039E6C:
	LDA $9E2D,X
	STA !OAMPROP,Y
	LDA $9E25,X
	CLC
	ADC $00
	STA !OAMX,Y
	LDA $04
	CMP #$01
	LDA $0F
	TAX
	LDA $9E35,X
	ADC $01
	STA !OAMY,Y
	LDA $04
	ASL
	ASL
	ADC $0F
	TAX
	LDA $9E39,X
	STA !OAMTILE,Y
	INY
	INY
	INY
	INY
	DEC $0F
	LDA $0F
	BPL CODE_039E5F
	SEP #$10
	JML $039E9F

DINO_HACK2:
	REP #$30
	LDA $00
	PHA
	PHX
	LDA $15E9
	AND #$00FF
	TAX
	LDA $151C,X
	PLX
	AND #$00FF
	TAY
	LDA #$0004
	DEY
	BMI DINO_HACK2_0
DINO_HACK2_1:
	DEC A
	DEY
	BPL DINO_HACK2_1
DINO_HACK2_0:
	ASL
	ASL
	STA $00
	LDA !SPRITEINDEX
	SEC
	SBC $00
	TAY
	PLA
	STA $00
	LDA #$0000
	SEP #$20
	TXA
	STA $06
CODE_039EC8:
	TAX
	LDA $04
	CMP #$03
	BNE CODE_039ED5
	TXA
	CLC
	ADC #$05
	TAX
CODE_039ED5:
	LDA $02
	CMP #$01
	LDA $9DFE,X
	BCS CODE_039EE0
	EOR #$FF
	INC A
CODE_039EE0:
	CLC
	ADC $00
	STA !OAMX,Y
	LDA $9E08,X
	CLC
	ADC $01
	STA !OAMY,Y
	LDA $06
	CMP #$04
	BNE CODE_039EFD
	LDA $04
	TAX
	LDA $9E21,X
	BRA CODE_039F00
CODE_039EFD:
	LDA $9E12,X
CODE_039F00:
	STA !OAMTILE,Y
	LDA $02
	CMP #$01
	LDA #$00
	BCS CODE_039F0B
	ORA #$40
CODE_039F0B:
	PHA
	LDA $06
	TAX
	CMP #$04
	BEQ CODE_039F13
	PLA
	EOR $05
	PHA
CODE_039F13:
	PLA
	ORA $9E1C,X
	ORA $64
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEC $06
	LDA $06
	CMP $03
	BPL CODE_039EC8
	SEP #$10
	JML $039F24


BLAARG_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA #$A0
	STA !OAMTILE,Y
	LDA !OAMPROP,Y
	AND #$CF
	STA !OAMPROP,Y
	SEP #$10
	JML $03A081

BLAARG_HACK2:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0010
	TAY
	LDA #$0000
	SEP #$20
CODE_03A0AF:
	PHX
	PHX
	LDA $01
	CLC
	ADC $A08C,X
	STA !OAMY,Y
	LDA $02
	BNE CODE_03A0C3
	TXA
	CLC
	ADC #$05
	TAX
CODE_03A0C3:
	LDA $00
	CLC
	ADC $A082,X
	STA !OAMX,Y
	PLX
	TXA
	CLC
	ADC $03
	TAX
	LDA $A091,X
	STA !OAMTILE,Y
	LDA $02
	TAX
	LDA $A09B,X
	STA !OAMPROP,Y
	PLX
	INY
	INY
	INY
	INY
	DEX
	BPL CODE_03A0AF
	SEP #$10
	JML $03A0E7
		

MECHAKOOPA_HACK:
	PHX
	LDX $15E9
	LDA $14C8,x
	CMP #$0B
	BNE STUNMECHA_0
	LDA $13E0
	CMP #$0F
	BNE STUNMECHA_0
	PLX
	BRA MECHAKOOPA_GFX_HIGH
STUNMECHA_0:
	PLX
	REP #$30
	LDA !SPRITEINDEX
	TAY
	LDA #$0000
	SEP #$20
CODE_03B39F:
	PHX
	PHY
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA $B34F,X
	STA !OAMEXTENDED,Y
	PLY
	LDA $01,S
	CLC
	ADC $02
	TAX
	LDA $00
	CLC
	ADC $B30F,X
	STA !OAMX,Y
	LDA $B347,X
	ORA $04
	ORA $64
	STA !OAMPROP,Y
	LDA $01,S
	CLC
	ADC $03
	TAX
	LDA $B32F,X
	STA !OAMTILE,Y
	LDA $01
	CLC
	ADC $B317,X
	STA !OAMY,Y
	PLX
	DEY
	DEY
	DEY
	DEY
	DEX
	BPL CODE_03B39F
	SEP #$10
	JML $03B3E2

MECHAKOOPA_GFX_HIGH:
	TXY
	REP #$30
	LDA !HIGHINDEX
	CLC
	ADC #$000C
	TAX
	LDA #$0000
	SEP #$20
CODE_03B39F_HIGH:
	PHY
	PHX
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA $B34F,Y
	STA !HIGHOAMEXTENDED,X
	PLX
	LDA $01,S
	CLC
	ADC $02
	TAY
	LDA $00
	CLC
	ADC $B30F,Y
	STA !HIGHOAMX,X
	LDA $B347,Y
	ORA $04
	ORA $64
	STA !HIGHOAMPROP,X
	LDA $01,S
	CLC
	ADC $03
	TAY
	LDA $B32F,Y
	STA !HIGHOAMTILE,X
	LDA $01
	CLC
	ADC $B317,Y
	STA !HIGHOAMY,X
	PLY
	DEX
	DEX
	DEX
	DEX
	DEY
	BPL CODE_03B39F_HIGH
	SEP #$10
	PLY
	LDX #$FF
	LDA #$03
	JSR FinishOAMWriteRt_HIGH
	JML $03B3EB

MECHAKOOPA_HACK2:
	PHX
	LDX $15E9
	LDA $14C8,x
	CMP #$0B
	BNE STUNMECHA2_0
	LDA $13E0
	CMP #$0F
	BNE STUNMECHA2_0
	PLX
	BRA MECHAKOOPA2_GFX_HIGH
STUNMECHA2_0:
	PLX
	REP #$30
	LDA !SPRITEINDEX
	TAY
	LDA #$0000
	SEP #$20
	LDA $00
	CLC
	ADC $B3EF,X
	STA !OAMX,Y	
	LDA $01
	STA !OAMY,Y
	LDA $B3F1,X
	ORA $64
	STA !OAMPROP,Y
	LDA $02
	TAX
	LDA $B3F3,X
	STA !OAMTILE,Y
	SEP #$10
	JML $03B432
MECHAKOOPA2_GFX_HIGH:
	TXY
	REP #$30
	LDA !HIGHINDEX
	TAX
	LDA #$0000
	SEP #$20
	LDA $00
	CLC
	ADC $B3EF,Y
	STA !HIGHOAMX,X	
	LDA $01
	STA !HIGHOAMY,X
	LDA $B3F1,Y
	ORA $64
	STA !HIGHOAMPROP,X
	LDA $02
	TAY
	LDA $B3F3,Y
	STA !HIGHOAMTILE,X
	SEP #$10
	PLY
	LDX #$00
	LDA #$00
	JSR FinishOAMWriteRt_HIGH
	JML $03B43B

LIGHTSWITCH_HACK:
	REP #$30
	PHX
	TXA
	ASL
	TAX
	LDA !SPRITEOAM,X
	TAY
	PLX
	LDA #$0000
	SEP #$20
	LDA #$2A
	STA !OAMTILE,Y
	LDA !OAMPROP,Y
	AND #$BF
	STA !OAMPROP,Y
	SEP #$10
	JML $03C254

CHAINSAW_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0008
	TAY
	LDA #$0000
	SEP #$20
	LDA $00
	SEC
	SBC #$08
	STA !OAMX,Y
	STA !OAMX+$4,Y
	STA !OAMX+$8,Y
	LDA $01
	SEC
	SBC #$08
	STA !OAMY,Y
	CLC
	ADC $03
	CLC
	ADC $02
	STA !OAMY+$4,Y
	CLC
	ADC $03
	STA !OAMY+$8,Y
	LDA $14
	LSR
	LSR
	AND #$03
	PHX
	TAX
	LDA $C25B,X
	STA !OAMTILE,Y
	PLX
	LDA #$AE
	STA !OAMTILE+$4,Y
	LDA #$8E
	STA !OAMTILE+$8,Y
	LDA #$37
	STA !OAMPROP,Y
	LDA $04
	STA !OAMPROP+$4,Y
	STA !OAMPROP+$8,Y
	SEP #$10
	JML $03C2D1

DRYBONES_HACK:
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$0008
	TAY
	LDA #$0000
	SEP #$20
CODE_03C404:
	PHX
	TXA
	CLC
	ADC $02
	TAX
	PHX
	LDA $05
	BEQ CODE_03C414
	TXA
	CLC
	ADC #$06
	TAX
CODE_03C414:
	LDA $00
	CLC
	ADC $C3B3,X
	STA !OAMX,Y
	PLX
	LDA $C3BF,X
	ORA $64
	STA !OAMPROP,Y
	LDA $01,S
	CLC
	ADC $03
	TAX
	LDA $01
	CLC
	ADC $C3C5,X
	STA !OAMY,Y
	LDA $C3CE,X
	STA !OAMTILE,Y
	PLX
	INY
	INY
	INY
	INY
	DEX
	TXA
	CMP $04
	BNE CODE_03C404
	SEP #$10
	JML $03C445

DISCOBALL_HACK:
	REP #$30
	LDA !SPRITEINDEX
	TAY
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20
	LDA #$78
	STA !OAMX,Y
	LDA #$28
	STA !OAMY,Y
	PHX
	LDA $C2,X
	LDX #$0008
	AND #$01
	BEQ CODE_03C4C1
	LDA $13
	LSR
	AND #$07
	TAX
CODE_03C4C1:
	LDA $C493,X
	STA !OAMTILE,Y
	LDA $C49C,X
	STA !OAMPROP,Y
	REP #$20
	TYA
	LSR
	LSR
	TAY
	SEP #$20
	LDA #$02
	STA !OAMEXTENDED,Y
	PLX
	SEP #$10
	JML $03C4D7


STUNGOOMBA_HACK:
	LDA $14C8,x
	CMP #$0B
	BNE STUNGOOMBA_0
	LDA $13E0
	CMP #$0F
	BNE STUNGOOMBA_0
	LDA #$80
	JSR SUBSPRGFX2_HIGH2
	JML $01A12E
STUNGOOMBA_0:
	LDA #$80
	JML $019F09

STUNTHROWBLOCK_HACK:
	LDA $14C8,x
	CMP #$0B
	BNE STUNTHROWBLOCK_0
	LDA $13E0
	CMP #$0F
	BNE STUNTHROWBLOCK_0
	JSR SUBSPRGFX2_HIGH
	JML $01A1D3
STUNTHROWBLOCK_0:
	JML $019F0D

STUNBOMB_HACK:
	LDA $14C8,x
	CMP #$0B
	BNE STUNBOMB_0
	LDA $13E0
	CMP #$0F
	BNE STUNBOMB_0
	JSR SUBSPRGFX2_HIGH
	REP #$30
	LDA !HIGHINDEX
	SEC
	SBC #$0004
	TAX
	SEP #$20
	LDA #$CA
	STA !HIGHOAMTILE,X
	SEP #$10
	LDX $15E9
	JML $01A228
STUNBOMB_0:
	PHK
	PER $0006
	PEA $A7E2
	JML $019F0D
	LDA #$CA
	JML $01A222

STUNKEY_HACK:
	LDA $14C8,x
	CMP #$0B
	BNE STUNKEY_0
	LDA $13E0
	CMP #$0F
	BNE STUNKEY_0
	JSR SUBSPRGFX2_HIGH
	REP #$30
	LDA !HIGHINDEX
	SEC
	SBC #$0004
	TAX
	SEP #$20
	LDA #$EC
	STA !HIGHOAMTILE,X
	SEP #$10
	LDX $15E9
	JML $01A228
STUNKEY_0:
	PHK
	PER $0006
	PEA $A7E2
	JML $019F0D
	LDA #$EC
	JML $01A222

STUNPOW_HACK:
	LDA #$01
	STA $157C,X
	LDA $14C8,x
	CMP #$0B
	BNE STUNPOW_0
	LDA $13E0
	CMP #$0F
	BNE STUNPOW_0
	JSR SUBSPRGFX2_HIGH
	REP #$30
	LDA !HIGHINDEX
	SEC
	SBC #$0004
	TAX
	SEP #$20
	LDA #$42
	STA !HIGHOAMTILE,X
	SEP #$10
	LDX $15E9
	JML $01A228
STUNPOW_0:
	JML $01A21D


STUNBABYYOSHI_HACK:
	LDA $14C8,x
	CMP #$0B
	BNE STUNYOSHI_0
	LDA $13E0
	CMP #$0F
	BNE STUNYOSHI_0
	JSR SUBSPRGFX2_HIGH
	REP #$30
	LDA !HIGHINDEX
	SEC
	SBC #$0004
	TAX
	SEP #$20
	LDA !HIGHOAMTILE,X
	STA $00
	STZ $01
	LDA #$06
	STA !HIGHOAMTILE,X
	REP #$20
	LDA $00
	ASL
	ASL
	ASL
	ASL
	ASL
	CLC
	ADC #$8500
	STA $0D8B
	CLC
	ADC #$0200
	STA $0D95
	SEP #$30
	LDX $15E9
	JML $01A359
STUNYOSHI_0:
	STZ $04
	JSL GETDRAWINFOBNK1_LONG
	LDA $157C,X
	STA $02
	LDY $9E,x
	LDA $1602,x
	CLC
	ADC $9C7F,y
	TAY
	REP #$30	; 16 bit X Y
	LDA !YOSHIINDEX	; update this; 1 less tile
	TAX
	CLC
	ADC #$0004
	STA !YOSHIINDEX
	LDA #$0000	; clear high byte of A
	SEP #$20	; 8 bit A
	LDA $9B83,Y	; get tile
	STA !YOSHIOAMTILE,X	; set tile
	LDA $15E9
	TAY		; sprite index
	LDA $00
	STA !YOSHIOAMX,X
	LDA $01
	STA !YOSHIOAMY,X
	LDA $157C,Y	; sprite direction
	LSR
	LDA $15F6,Y	; palette info
	BCS CODE_019F42_YOSHI
	EOR #$40	; flip sprite direction if necessary
CODE_019F42_YOSHI:
	ORA $04
	ORA $64
	STA !YOSHIOAMPROP,X	; set properties
	PHX		; push X
	REP #$20	; 16 bit A
	TXA
	LSR
	LSR
	TAX
	SEP #$20	; 8 bit A
	LDA #$02
	ORA $15A0,Y
	STA !YOSHIOAMEXTENDED,X
	PLX		; pull X
	LDA $186C,Y	; check if offscreen vertically
	BEQ SUBSPRGFX2_YOSHI_RETURN
	LSR A
	BCC SUBSPRGFX2_YOSHI_0
	PHA
	LDA #$F0	; push tile offscreen
	STA !YOSHIOAMY,X
	PLA
SUBSPRGFX2_YOSHI_0:
	LSR A
	BCC SUBSPRGFX2_YOSHI_RETURN
	LDA #$F0
	STA !YOSHIOAMY+$4,X	; push tile offscreen
SUBSPRGFX2_YOSHI_RETURN:
	SEP #$30	; 8 bit A X Y
	TYX
	REP #$30
	LDA !YOSHIINDEX
	SEC
	SBC #$0004
	TAX
	SEP #$20
	LDA !YOSHIOAMTILE,X
	STA $00
	STZ $01
	LDA #$06
	STA !YOSHIOAMTILE,X
	REP #$20
	LDA $00
	ASL
	ASL
	ASL
	ASL
	ASL
	CLC
	ADC #$8500
	STA $0D8B
	CLC
	ADC #$0200
	STA $0D95
	SEP #$30
	LDX $15E9
	JML $01A359
	

STUNSPRINGBOARD_HACK:
	LDA $14C8,x
	CMP #$0B
	BNE STUNSB_0
	LDA $13E0
	CMP #$0F
	BNE STUNSB_0
	LDA #$02
	JSR SUBSPRGFX0_HIGH1
	JML $01E6FC
STUNSB_0:
	LDA #$02
	JML $019CF5 
	
	
	
	

	





EXSPRSUB_HACK:
	PHA
	TXY
	REP #$30
	LDA !SUPERINDEX
	TAX
	CLC
	ADC #$0004
	STA !SUPERINDEX
	SEP #$20
	PLA
	STA !SUPEROAMY,X
	LDA $01
	STA !SUPEROAMX,X
	LDA $1779,Y
	STA $01
	PHY
	LDA $14
	LSR
	LSR
	AND #$03
	TAY
	LDA $A15B,Y
	STA !SUPEROAMTILE,X
	LDA $A15F,Y
	EOR $00
	ORA $64
	STA !SUPEROAMPROP,X
	PHA
	LDA $01
	BEQ CODE_02A204
	LDA $01,S
	AND #$CF
	ORA #$10
	STA !SUPEROAMPROP,X
CODE_02A204:
	PLA
	PLY
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$00
	STA !SUPEROAMEXTENDED,X
	SEP #$10
	TYX
	JML $02A210

EXSPRSUB2_HACK:
	LDA $170B,X
	BEQ EXSPRSUB2_HACK_0
	TXY
	REP #$30
	LDA !SUPERINDEX
	SEC
	SBC #$0004
	TAX
	LDA #$0000
	SEP #$20
	LDA $1765,Y
	LSR
	LSR
	LSR
	AND #$07
	PHY
	TAY
	LDA $A2DF,Y
	STA !SUPEROAMTILE,X
	LDA $A2E7,Y
	PLY
	EOR $00
	EOR #$40
	ORA $64
	STA !SUPEROAMPROP,X
	REP #$20
	TXA
	LSR
	LSR
	TAX
	SEP #$20
	LDA #$02
	STA !SUPEROAMEXTENDED,X
	SEP #$10
	TYX
EXSPRSUB2_HACK_0:
	JML $02A343


SUBSPRGFX0_HACK:
	PHX
	REP #$30
	LDA !SPRITEINDEX
	SEC
	SBC #$000C		; 4 tiles drawn
	TAY
	LDA #$0000
	SEP #$20
	LDA #$03
	STA $04
CODE_019D1F:
	TAX
	LDA $00
	CLC
	ADC $9CD3,X
	STA !OAMX,Y
	LDA $01
	CLC
	ADC $9CD7,X
	STA !OAMY,Y
	LDA $02
	CLC
	ADC $04
	TAX
	LDA $9B83,X
	STA !OAMTILE,Y
	LDA $05
	ASL
	ASL
	ADC $04
	TAX
	LDA $9CDB,X
	ORA $03
	STA !OAMPROP,Y
	INY
	INY
	INY
	INY
	DEC $04
	LDA $04
	BPL CODE_019D1F
	SEP #$10
	JML $019D56	; return

SUBSPRGFX0_HIGH0:
	LDY #$00
SUBSPRGFX0_HIGH1:
	STA $05
	STY $0F
	JSL GETDRAWINFOBNK1_LONG
	LDY $0F
	TYA
	CLC
	ADC $01
	STA $01
	LDY $9E,X
	LDA $1602,X
	ASL
	ASL
	ADC $9C7F,Y
	STA $02
	LDA $15F6,X
	ORA $64
	STA $03
	PHX
	REP #$30
	LDA !HIGHINDEX
	TAX
	LDA #$0000
	SEP #$20
	LDA #$03
	STA $04
CODE_019D1F_HIGH:
	TAY
	LDA $00
	CLC
	ADC $9CD3,Y
	STA !HIGHOAMX,X
	LDA $01
	CLC
	ADC $9CD7,Y
	STA !HIGHOAMY,X
	LDA $02
	CLC
	ADC $04
	TAY
	LDA $9B83,Y
	STA !HIGHOAMTILE,X
	LDA $05
	ASL
	ASL
	ADC $04
	TAY
	LDA $9CDB,Y
	ORA $03
	STA !HIGHOAMPROP,X
	INX
	INX
	INX
	INX
	DEC $04
	LDA $04
	BPL CODE_019D1F_HIGH
	SEP #$10
	PLY
	LDA #$03
	LDX #$00
	JSR FinishOAMWriteRt_HIGH
	LDX $15E9
	RTS


SUBSPRGFX1_HACK1:
	REP #$30	; 16 bit A X Y
	LDA !SPRITEINDEX
	TAY
	SEC
	SBC #$0008	; this is a two tile sprite
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20	; 8 bit A
	PHY
	LDA $9E,x
	TAY
	LDA $1602,x
	ASL
	CLC
	ADC $9C7F,y
	TAX
	PLY
	LDA $9B83,X
	STA !OAMTILE-$4,y
	LDA $9B84,x
	STA !OAMTILE,y
CODE_019D9B:
	LDA $15E9
	TAX
	LDA $01
	STA !OAMY-$4,y
	CLC
	ADC #$10
	STA !OAMY,y
	LDA $00
	STA !OAMX-$4,y
	STA !OAMX,y
	LDA $157C,x
	LSR
	LDA #$00
	ORA $15F6,x
	BCS CODE_019DB3
	ORA #$40
CODE_019DB3:
	ORA $64
	STA !OAMPROP-$4,y
	STA !OAMPROP,Y
	PHY		; push y
	REP #$20	; 16 bit A
	TYA
	LSR
	LSR
	TAY
	SEP #$20	; 8 bit A
	LDA #$02
	ORA $15A0,x
	STA !OAMEXTENDED-$1,y
	STA !OAMEXTENDED,y
	PLY		; pull y
	LDA $186C,x	; check if offscreen vertically
	BEQ SUBSPRGFX1_RETURN
	LSR A
	BCC SUBSPRGFX1_0
	PHA
	LDA #$F0	; push tile offscreen
	STA !OAMY-$4,y
	REP #$20	; 16 bit A
	LDA !SPRITEINDEX
	CLC
	ADC #$0004	; clear up this tile
	STA !SPRITEINDEX
	SEP #$20	; 8 bit A
	PLA
SUBSPRGFX1_0:
	LSR A
	BCC SUBSPRGFX1_RETURN
	LDA #$F0
	STA !OAMY,y	; push tile offscreen
SUBSPRGFX1_RETURN:
	SEP #$30	; 8 bit a X Y
	JML $019DD8	; return


SUBSPRGFX1_HACK2:
	REP #$30	; 16 bit A X Y
	LDA !SPRITEINDEX
	TAY
	SEC
	SBC #$0008	; this is a two tile sprite
	STA !SPRITEINDEX
	LDA #$0000
	SEP #$20	; 8 bit A
	PHY
	LDA $9E,x
	TAY
	LDA $1602,x
	ASL
	CLC
	ADC $9C7F,y
	TAX
	PLY
	LDA $9B83,x
	STA !OAMTILE,y
	LDA $9B84,x
	STA !OAMTILE-$4,y
	JMP CODE_019D9B	; hop to rest of code



SUBSPRGFX2_HACK:
	LDY $9E,x
	LDA $1602,x
	CLC
	ADC $9C7F,y
	REP #$30	; 16 bit X Y
	AND #$00FF	; clear high byte
	TAX
	LDA !SPRITEINDEX; update this; 1 less tile
	TAY
	SEC
	SBC #$0004
	STA !SPRITEINDEX
	LDA #$0000	; clear high byte of A
	SEP #$20	; 8 bit A
	LDA $9B83,x	; get tile
	STA !OAMTILE,y	; set tile
	LDA $15E9
	TAX		; sprite index
	LDA $00
	STA !OAMX,y
	LDA $01
	STA !OAMY,y
	LDA $157C,x	; sprite direction
	LSR
	LDA $15F6,x	; palette info
	BCS CODE_019F44
	EOR #$40	; flip sprite direction if necessary
CODE_019F44:
	ORA $04
	ORA $64
	STA !OAMPROP,y	; set properties
	PHY		; push y
	REP #$20	; 16 bit A
	TYA
	LSR
	LSR
	TAY
	SEP #$20	; 8 bit A
	LDA #$02
	ORA $15A0,x
	STA !OAMEXTENDED,y
	PLY		; pull y
	LDA $186C,x	; check if offscreen vertically
	BEQ SUBSPRGFX2_RETURN
	LSR A
	BCC SUBSPRGFX2_0
	PHA
	LDA #$F0	; push tile offscreen
	STA !OAMY,y
	PLA
SUBSPRGFX2_0:
	LSR A
	BCC SUBSPRGFX2_RETURN
	LDA #$F0
	STA !OAMY-$4,y	; push tile offscreen
SUBSPRGFX2_RETURN:
	SEP #$30	; 8 bit A X Y
	JML $019F5A	; return
	

SUBSPRGFX2_HIGH2:
	STA $04
	BRA SUBSPRGFX2_HIGH_CONT

SUBSPRGFX2_HIGH:
	STZ $04
SUBSPRGFX2_HIGH_CONT:
	JSL GETDRAWINFOBNK1_LONG
	LDA $157C,X
	STA $02
	LDY $9E,x
	LDA $1602,x
	CLC
	ADC $9C7F,y
	REP #$30	; 16 bit X Y
	AND #$00FF	; clear high byte
	TAY
	LDA !HIGHINDEX	; update this; 1 less tile
	TAX
	CLC
	ADC #$0004
	STA !HIGHINDEX
	LDA #$0000	; clear high byte of A
	SEP #$20	; 8 bit A
	LDA $9B83,Y	; get tile
	STA !HIGHOAMTILE,X	; set tile
	LDA $15E9
	TAY		; sprite index
	LDA $00
	STA !HIGHOAMX,X
	LDA $01
	STA !HIGHOAMY,X
	LDA $157C,Y	; sprite direction
	LSR
	LDA $15F6,Y	; palette info
	BCS CODE_019F42_2
	EOR #$40	; flip sprite direction if necessary
CODE_019F42_2:
	ORA $04
	ORA $64
	STA !HIGHOAMPROP,X	; set properties
	PHX		; push X
	REP #$20	; 16 bit A
	TXA
	LSR
	LSR
	TAX
	SEP #$20	; 8 bit A
	LDA #$02
	ORA $15A0,Y
	STA !HIGHOAMEXTENDED,X
	PLX		; pull X
	LDA $186C,Y	; check if offscreen vertically
	BEQ SUBSPRGFX2_HIGH_RETURN
	LSR A
	BCC SUBSPRGFX2_HIGH_0
	PHA
	LDA #$F0	; push tile offscreen
	STA !HIGHOAMY,X
	PLA
SUBSPRGFX2_HIGH_0:
	LSR A
	BCC SUBSPRGFX2_HIGH_RETURN
	LDA #$F0
	STA !HIGHOAMY+$4,X	; push tile offscreen
SUBSPRGFX2_HIGH_RETURN:
	SEP #$30	; 8 bit A X Y
	TYX
	RTS
	


	




FINISHOAMWRITE_HACK:
			JSR FinishOAMWriteRt
			JML $01B843		; return

FinishOAMWriteRt:	STY $0B                   
CODE_01B7BD:		STA $08     
			REP #$30	; 16 bit A x y
CODE_01B7BF:		LDA !SPRITEINDEX   ; Y = Index into sprite OAM 
			TAY
			SEP #$20	; 8 bit A
CODE_01B7C2:		LDA $D8,X       
CODE_01B7C4:		STA $00                   
CODE_01B7C6:		SEC                       
CODE_01B7C7:		SBC $1C 
CODE_01B7C9:		STA $06                   
CODE_01B7CB:		LDA $14D4,X     
CODE_01B7CE:		STA $01                   
CODE_01B7D0:		LDA $E4,X       
CODE_01B7D2:		STA $02                   
CODE_01B7D4:		SEC                       
CODE_01B7D5:		SBC $1A   
CODE_01B7D7:		STA $07                   
CODE_01B7D9:		LDA $14E0,X     
CODE_01B7DC:		STA $03     
CODE_01B7DE:		REP #$20	; 16 bit A  	
			TYA                       
CODE_01B7DF:		LSR                       
CODE_01B7E0:		LSR                       
CODE_01B7E1:		TAX               
			SEP #$20	; 8 bit A   
			JSR FINISHOAM_SUB	; need to make this smaller so branches work                      
CODE_01B83C:		DEC $08                   
CODE_01B83E:		BPL CODE_01B7DE           
			SEP #$10	; 8 bit X Y
CODE_01B840:		LDX $15E9               ; X = Sprite index 
			RTS

FINISHOAM_SUB:
CODE_01B7E2:		LDA $0B                   
CODE_01B7E4:		BPL CODE_01B7F0           
CODE_01B7E6:		LDA !OAMEXTENDED,X      
CODE_01B7E9:		AND #$02                
CODE_01B7EB:		STA !OAMEXTENDED,X      
CODE_01B7EE:		BRA CODE_01B7F3           
CODE_01B7F0:		STA !OAMEXTENDED,X      
CODE_01B7F3:		LDX #$0000              
CODE_01B7F5:		LDA !OAMX,Y         
CODE_01B7F8:		SEC                       
CODE_01B7F9:		SBC $07                   
CODE_01B7FB:		BPL CODE_01B7FE           
CODE_01B7FD:		DEX                       
CODE_01B7FE:		CLC                       
CODE_01B7FF:		ADC $02                   
CODE_01B801:		STA $04                   
CODE_01B803:		TXA                       
CODE_01B804:		ADC $03                   
CODE_01B806:		STA $05           
CODE_01B844:		REP #$20                  ; Accum (16 bit) 
			LDA !SPRITEINDEX
			SEC
			SBC #$0004	; update this
			STA !SPRITEINDEX    
CODE_01B846:		LDA $04                   
CODE_01B848:		SEC                       
CODE_01B849:		SBC $1A
CODE_01B84B:		CMP #$0100              
CODE_01B80B:		BCC CODE_01B819        
CODE_01B80D:		TYA                       
CODE_01B80E:		LSR                       
CODE_01B80F:		LSR                       
CODE_01B810:		TAX                     
			SEP #$20		; 8 bit A
CODE_01B811:		LDA !OAMEXTENDED,X      
CODE_01B814:		ORA #$01                
CODE_01B816:		STA !OAMEXTENDED,X      
CODE_01B819:		LDX #$0000      
			SEP #$20                  ; Accum (8 bit)        
CODE_01B81B:		LDA !OAMY,Y         
CODE_01B81E:		SEC                       
CODE_01B81F:		SBC $06                   
CODE_01B821:		BPL CODE_01B824           
CODE_01B823:		DEX                       
CODE_01B824:		CLC                       
CODE_01B825:		ADC $00                   
CODE_01B827:		STA $09                   
CODE_01B829:		TXA                       
CODE_01B82A:		ADC $01                   
CODE_01B82C:		STA $0A                   
CODE_01C9BF:		REP #$20                  ; Accum (16 bit) 
CODE_01C9C1:		LDA $09                   
CODE_01C9C3:		PHA                       
CODE_01C9C4:		CLC                       
CODE_01C9C5:		ADC #$0010              
CODE_01C9C8:		STA $09                   
CODE_01C9CA:		SEC                       
CODE_01C9CB:		SBC $1C 
CODE_01C9CD:		CMP #$0100              
CODE_01C9D0:		PLA                       
CODE_01C9D1:		STA $09       
			SEP #$20                             
CODE_01B831:		BCC CODE_01B838  
CODE_01B833:		LDA #$F0                
CODE_01B835:		STA !OAMY,Y   
			LDA $08
			BNE CODE_01B838
			REP #$20
			LDA !SPRITEINDEX
			CLC
			ADC #$0004
			STA !SPRITEINDEX
			SEP #$20
CODE_01B838:		DEY                  
CODE_01B839:		DEY                       
CODE_01B83A:		DEY                       
CODE_01B83B:		DEY      
			RTS
	

FINISHOAM_HIGH:
			JSR FinishOAMWriteRt_HIGH
			RTL

FinishOAMWriteRt_HIGH:	STX $0B                   
CODE_01B7BD_HIGH:	STA $08     
			REP #$30	; 16 bit A x y
CODE_01B7BF_HIGH:	LDA !HIGHINDEX   ; X = Index into sprite OAM 
			TAX
			SEP #$20	; 8 bit A
CODE_01B7C2_HIGH:	LDA $00D8,Y     
CODE_01B7C4_HIGH:	STA $00                   
CODE_01B7C6_HIGH:	SEC                       
CODE_01B7C7_HIGH:	SBC $1C 
CODE_01B7C9_HIGH:	STA $06                   
CODE_01B7CB_HIGH:	LDA $14D4,Y 
CODE_01B7CE_HIGH:	STA $01                   
CODE_01B7D0_HIGH:	LDA $00E4,Y     
CODE_01B7D2_HIGH:	STA $02                   
CODE_01B7D4_HIGH:	SEC                       
CODE_01B7D5_HIGH:	SBC $1A   
CODE_01B7D7_HIGH:	STA $07                   
CODE_01B7D9_HIGH:	LDA $14E0,Y  
CODE_01B7DC_HIGH:	STA $03            
CODE_01B7DE_HIGH:	REP #$20	; 16 bit A  	
			TXA                       
CODE_01B7DF_HIGH:	LSR                       
CODE_01B7E0_HIGH:	LSR                       
CODE_01B7E1_HIGH:	TAY   
			SEP #$20	; 8 bit A   
			JSR FINISHOAM_SUB_HIGH	; need to make this smaller so branches work                      
CODE_01B83C_HIGH:	DEC $08                   
CODE_01B83E_HIGH:	BPL CODE_01B7DE_HIGH           
			SEP #$10	; 8 bit X Y
CODE_01B840_HIGH:	LDX $15E9               ; X = Sprite index 
			RTS

FINISHOAM_SUB_HIGH: 
			PHX
			TYX
CODE_01B7E2_HIGH:	LDA $0B                   
CODE_01B7E4_HIGH:	BPL CODE_01B7F0_HIGH          
CODE_01B7E6_HIGH:	LDA !HIGHOAMEXTENDED,X      
CODE_01B7E9_HIGH:	AND #$02                
CODE_01B7EB_HIGH:	STA !HIGHOAMEXTENDED,X  
			PLX  
CODE_01B7EE_HIGH:	BRA CODE_01B7F3_HIGH           
CODE_01B7F0_HIGH:	STA !HIGHOAMEXTENDED,X   
			PLX     
CODE_01B7F3_HIGH:	LDY #$0000              
CODE_01B7F5_HIGH:	LDA !HIGHOAMX,X    
CODE_01B7F8_HIGH:	SEC                       
CODE_01B7F9_HIGH:	SBC $07                   
CODE_01B7FB_HIGH:	BPL CODE_01B7FE_HIGH          
CODE_01B7FD_HIGH:	DEY                       
CODE_01B7FE_HIGH:	CLC                       
CODE_01B7FF_HIGH:	ADC $02                   
CODE_01B801_HIGH:	STA $04                   
CODE_01B803_HIGH:	TYA                       
CODE_01B804_HIGH:	ADC $03                   
CODE_01B806_HIGH:	STA $05           
CODE_01B844_HIGH:	REP #$20                  ; Accum (16 bit) 
			LDA !HIGHINDEX
			CLC
			ADC #$0004	; update this
			STA !HIGHINDEX    
CODE_01B846_HIGH:	LDA $04                   
CODE_01B848_HIGH:	SEC                       
CODE_01B849_HIGH:	SBC $1A
CODE_01B84B_HIGH:	CMP #$0100              
CODE_01B80B_HIGH:	BCC CODE_01B819_HIGH        
CODE_01B80D_HIGH:	TXA                       
CODE_01B80E_HIGH:	LSR                       
CODE_01B80F_HIGH:	LSR         
			PHX              
CODE_01B810_HIGH:	TAX                    
			SEP #$20		; 8 bit A
CODE_01B811_HIGH:	LDA !HIGHOAMEXTENDED,X      
CODE_01B814_HIGH:	ORA #$01                
CODE_01B816_HIGH:	STA !HIGHOAMEXTENDED,X   
			PLX   
CODE_01B819_HIGH:	LDY #$0000      
			SEP #$20                  ; Accum (8 bit)        
CODE_01B81B_HIGH:	LDA !HIGHOAMY,X        
CODE_01B81E_HIGH:	SEC                       
CODE_01B81F_HIGH:	SBC $06                   
CODE_01B821_HIGH:	BPL CODE_01B824_HIGH           
CODE_01B823_HIGH:	DEY                   
CODE_01B824_HIGH:	CLC                       
CODE_01B825_HIGH:	ADC $00                   
CODE_01B827_HIGH:	STA $09                   
CODE_01B829_HIGH:	TYA                       
CODE_01B82A_HIGH:	ADC $01                   
CODE_01B82C_HIGH:	STA $0A                   
CODE_01C9BF_HIGH:	REP #$20                  ; Accum (16 bit) 
CODE_01C9C1_HIGH:	LDA $09                   
CODE_01C9C3_HIGH:	PHA                       
CODE_01C9C4_HIGH:	CLC                       
CODE_01C9C5_HIGH:	ADC #$0010              
CODE_01C9C8_HIGH:	STA $09                   
CODE_01C9CA_HIGH:	SEC                       
CODE_01C9CB_HIGH:	SBC $1C 
CODE_01C9CD_HIGH:	CMP #$0100              
CODE_01C9D0_HIGH:	PLA                       
CODE_01C9D1_HIGH:	STA $09       
			SEP #$20                             
CODE_01B831_HIGH:	BCC CODE_01B838_HIGH  
CODE_01B833_HIGH:	LDA #$F0                
CODE_01B835_HIGH:	STA !HIGHOAMY,X
			LDA $08
			BNE CODE_01B838_HIGH
			REP #$20
			LDA !HIGHINDEX
			SEC
			SBC #$0004
			STA !HIGHINDEX
			SEP #$20
CODE_01B838_HIGH:	INX                 
CODE_01B839_HIGH:	INX                       
CODE_01B83A_HIGH:	INX                       
CODE_01B83B_HIGH:	INX      
			RTS

FINISHOAM_SUPER:
			JSR FinishOAMWriteRt_SUPER
			RTL


FinishOAMWriteRt_SUPER:	STX $0B                   
CODE_01B7BD_SUPER:	STA $08     
			REP #$30	; 16 bit A x y
CODE_01B7BF_SUPER:	LDA !SUPERINDEX   ; X = Index into sprite OAM 
			TAX
			SEP #$20	; 8 bit A
CODE_01B7C2_SUPER:	LDA $00D8,Y     
CODE_01B7C4_SUPER:	STA $00                   
CODE_01B7C6_SUPER:	SEC                       
CODE_01B7C7_SUPER:	SBC $1C 
CODE_01B7C9_SUPER:	STA $06                   
CODE_01B7CB_SUPER:	LDA $14D4,Y 
CODE_01B7CE_SUPER:	STA $01                   
CODE_01B7D0_SUPER:	LDA $00E4,Y     
CODE_01B7D2_SUPER:	STA $02                   
CODE_01B7D4_SUPER:	SEC                       
CODE_01B7D5_SUPER:	SBC $1A   
CODE_01B7D7_SUPER:	STA $07                   
CODE_01B7D9_SUPER:	LDA $14E0,Y  
CODE_01B7DC_SUPER:	STA $03            
CODE_01B7DE_SUPER:	REP #$20	; 16 bit A  	
			TXA                       
CODE_01B7DF_SUPER:	LSR                       
CODE_01B7E0_SUPER:	LSR                       
CODE_01B7E1_SUPER:	TAY   
			SEP #$20	; 8 bit A   
			JSR FINISHOAM_SUB_SUPER	; need to make this smaller so branches work                      
CODE_01B83C_SUPER:	DEC $08                   
CODE_01B83E_SUPER:	BPL CODE_01B7DE_SUPER           
			SEP #$10	; 8 bit X Y
CODE_01B840_SUPER:	LDX $15E9               ; X = Sprite index 
			RTS

FINISHOAM_SUB_SUPER: 
			PHX
			TYX
CODE_01B7E2_SUPER:	LDA $0B                   
CODE_01B7E4_SUPER:	BPL CODE_01B7F0_SUPER          
CODE_01B7E6_SUPER:	LDA !SUPEROAMEXTENDED,X      
CODE_01B7E9_SUPER:	AND #$02                
CODE_01B7EB_SUPER:	STA !SUPEROAMEXTENDED,X    
CODE_01B7EE_SUPER:	BRA CODE_01B7F3_SUPER          
CODE_01B7F0_SUPER:	STA !SUPEROAMEXTENDED,X   
			PLX     
CODE_01B7F3_SUPER:	LDY #$0000              
CODE_01B7F5_SUPER:	LDA !SUPEROAMX,X    
CODE_01B7F8_SUPER:	SEC                       
CODE_01B7F9_SUPER:	SBC $07                   
CODE_01B7FB_SUPER:	BPL CODE_01B7FE_SUPER         
CODE_01B7FD_SUPER:	DEY                       
CODE_01B7FE_SUPER:	CLC                       
CODE_01B7FF_SUPER:	ADC $02                   
CODE_01B801_SUPER:	STA $04                   
CODE_01B803_SUPER:	TYA                       
CODE_01B804_SUPER:	ADC $03                   
CODE_01B806_SUPER:	STA $05           
CODE_01B844_SUPER:	REP #$20                  ; Accum (16 bit) 
			LDA !SUPERINDEX
			CLC
			ADC #$0004	; update this
			STA !SUPERINDEX    
CODE_01B846_SUPER:	LDA $04                   
CODE_01B848_SUPER:	SEC                       
CODE_01B849_SUPER:	SBC $1A
CODE_01B84B_SUPER:	CMP #$0100              
CODE_01B80B_SUPER:	BCC CODE_01B819_SUPER        
CODE_01B80D_SUPER:	TXA                       
CODE_01B80E_SUPER:	LSR                       
CODE_01B80F_SUPER:	LSR         
			PHX              
CODE_01B810_SUPER:	TAX                    
			SEP #$20		; 8 bit A
CODE_01B811_SUPER:	LDA !SUPEROAMEXTENDED,X      
CODE_01B814_SUPER:	ORA #$01                
CODE_01B816_SUPER:	STA !SUPEROAMEXTENDED,X   
			PLX   
CODE_01B819_SUPER:	LDY #$0000      
			SEP #$20                  ; Accum (8 bit)        
CODE_01B81B_SUPER:	LDA !SUPEROAMY,X        
CODE_01B81E_SUPER:	SEC                       
CODE_01B81F_SUPER:	SBC $06                   
CODE_01B821_SUPER:	BPL CODE_01B824_SUPER        
CODE_01B823_SUPER:	DEY                   
CODE_01B824_SUPER:	CLC                       
CODE_01B825_SUPER:	ADC $00                   
CODE_01B827_SUPER:	STA $09                   
CODE_01B829_SUPER:	TYA                       
CODE_01B82A_SUPER:	ADC $01                   
CODE_01B82C_SUPER:	STA $0A                   
CODE_01C9BF_SUPER:	REP #$20                  ; Accum (16 bit) 
CODE_01C9C1_SUPER:	LDA $09                   
CODE_01C9C3_SUPER:	PHA                       
CODE_01C9C4_SUPER:	CLC                       
CODE_01C9C5_SUPER:	ADC #$0010              
CODE_01C9C8_SUPER:	STA $09                   
CODE_01C9CA_SUPER:	SEC                       
CODE_01C9CB_SUPER:	SBC $1C 
CODE_01C9CD_SUPER:	CMP #$0100              
CODE_01C9D0_SUPER:	PLA                       
CODE_01C9D1_SUPER:	STA $09       
			SEP #$20                             
CODE_01B831_SUPER:	BCC CODE_01B838_SUPER 
CODE_01B833_SUPER:	LDA #$F0                
CODE_01B835_SUPER:	STA !SUPEROAMY,X
			LDA $08
			BNE CODE_01B838_SUPER
			REP #$20
			LDA !SUPERINDEX
			SEC
			SBC #$0004
			STA !SUPERINDEX
			SEP #$20
CODE_01B838_SUPER:	INX                 
CODE_01B839_SUPER:	INX                       
CODE_01B83A_SUPER:	INX                       
CODE_01B83B_SUPER:	INX      
			RTS



MainEnd:

print bytes